/*
 * DataTest.java
 *
 * Created on August 10, 2000, 10:47 AM
 */
 
package saaps.ann;

import saaps.ann.mlff.*;

/** 
 *
 * @author  saaps
 * @version 
 */
public class DataTest extends Object {

  /** Creates new DataTest */
  public DataTest() {
  }
  
  /**
  * @param args the command line arguments
  */
  public static void main (String args[]) {
    double[] w = {-1.0,0.5,1.0};
    double b = -4.0;
    Weights weights = new Weights(w,b);
//    Data inputData = new Data(3,5);  //3 inputs and 5 examples.
    Data inputData = DataCreator.read("/space/saaps/test.text",3);
//    for (int exam=0;exam<inputData.getNumOfExamples();exam++)
//      for (int conn=0;conn<inputData.getNumOfConnections();conn++)
//        inputData.set(conn,exam,(double) (conn * exam));
    Data outputData = inputData.weightedSum(weights);
 
    System.out.println("Weights");
    weights.print();
    System.out.println("Input data");
    inputData.print();
    System.out.println("Output data");
    outputData.print();
    
    LinNeuron ln = new LinNeuron(weights);
    ln.setInput(inputData);
    Data outputData1 = ln.getOutput();
    System.out.println("Output from LinNeuron");
    outputData1.print();

    TanhNeuron tn = new TanhNeuron(weights);
    tn.setInput(inputData);
    Data outputData2 = tn.getOutput();
    System.out.println("Output from TanhNeuron");
    outputData2.print();
    
    Neuron[] neurons = new Neuron[2];
    neurons[0] = ln;
    neurons[1] = tn;
    
    System.out.println("Output from layer");
    Layer l1 = new Layer(neurons);
    l1.setInput(inputData);
    Data outputData3 = l1.getOutput();
    outputData3.print();
    
    Layer[] layers = new Layer[1];
    layers[0] = l1;
    
    System.out.println("Network test");
    Network net = new Network(layers);
    net.setInput(inputData);
    Data outputData4 = net.getOutput();
    outputData4.print();
}

}