package saaps.dbt;

import java.io.*;
import java.util.*;
import java.text.*;
import java.lang.*;

import saaps.util.*;

public class CheckDatabase  {

  static public void main(String[] args) {
    Database db = null;

    if(args.length<1) {
      System.out.println("Usage: java saaps.dbt.CheckDatabase <Db class name>");
      System.exit(0);
    }
    try {
      DatabaseObject dbo1 = null;
      DatabaseObject dbo2 = null;

      NumberFormat nf = NumberFormat.getInstance();
      nf.setMaximumFractionDigits(3);
      nf.setMinimumFractionDigits(3);

      Calendar sd = Calendar.getInstance(TimeZone.getTimeZone("UTC"),new Locale("sv","SE"));
      Calendar ed = Calendar.getInstance(TimeZone.getTimeZone("UTC"),new Locale("sv","SE"));
      sd.set(2000,5-1,1,0,0,0);
      sd.clear(sd.MILLISECOND);
      ed.set(2000,6-1,1,0,0,0);
      ed.clear(ed.MILLISECOND);

      SimpleDateFormat formatter = (SimpleDateFormat) SimpleDateFormat.getDateTimeInstance(0,0,new Locale("sv","SE"));

      formatter.setTimeZone(TimeZone.getTimeZone("UTC"));
      formatter.applyPattern("yyyy MM dd HH mm ss");

      db = Database.getInstance(args[0],true);
      //int size = (int) db.getFirst().getObjectSize();
      db.position(true); //In beginning
      //get first
      dbo1 = (DatabaseObject) db.read();
      while (true) {
	dbo2 = (DatabaseObject) db.read();
	long diff = dbo2.getDate().getTime() - dbo1.getDate().getTime();
	if( diff != db.meta.getTimeStep()) {
	  // System.out.println("diff: " + diff + " meta:" + db.meta.getTimeStep());
	  System.out.println("first: " + formatter.format(dbo1.getDate()) + " second:" + formatter.format(dbo2.getDate()));	  
	}
	dbo1=dbo2;
      }
    } 
    catch (Exception e) {
      System.err.println(e);
      System.out.println("Finished");
    }
    finally {
      try {
	db.close();
      }
      catch (IOException ee) {
	System.err.println(ee);
      }
    }
  }
}
