/** 
 *
 * Title: LatestData.java
 * Author: Leif Kalla
 * Description:	Retreive the latest data from our dataprovider
 * and store it in our database.
 */

package saaps.dbt;

import java.io.*;
import java.util.Vector;
import saaps.util.ObjectTimeSeries;
import saaps.util.IllegalTimeSeriesException;

public class LatestData  {

  static public void main(String[] args) {

    Database dbRef;

    if(args.length==0) {
      System.out.println("Usage: java saaps.dbt.LatestData <Db class name>");
      System.exit(0);
    }

    dbRef = Database.getInstance(args[0]);

    try {
      Vector newData = dbRef.getLatestDatabaseObjects();
      ObjectTimeSeries ts = new ObjectTimeSeries(newData);
      dbRef.store(ts);
      dbRef.close();
    }
    catch (IOException e) {
	System.err.println(e);
	e.printStackTrace();
    }
    catch (IllegalTimeSeriesException e) {
      System.err.println(e);
    }
    catch (Exception e) {
        System.err.println(e);
    }
  }
}
