package saaps.dbt;

/**
 * LatestDst downloads the latest worlddatacenter in Japan
 * and stores it in the SAAPS database.
 * http://swdcdb.kugi.kyoto-u.ac.jp:80/dstdir/dst1/q/Dstqthism.html
 * http://swdcdb.kugi.kyoto-u.ac.jp:80/dstdir/dst1/q/Dstqlastm.html
 * http://swdcdb.kugi.kyoto-u.ac.jp:80/dstdir/dst1/q/Dstqlastm2.html
 *
 *@author Leif Kalla
 */

public class LatestDst {
            
    public LatestDst(int type) {
        DstDownloader ldst = new DstDownloader();
        ldst.getData(DstDownloader.URLlist[type]);        
    }
    
    public static void main(String[] args) {
        int type = 0; //Default is latest data
        
        if(args.length>0) {
            type = Integer.parseInt(args[0]);
        }
        new LatestDst(type);
    }
}
