/*
 * LatestMonthACEmag.java
 *
 * Created on April 26, 2000, 4:44 PM
 */
 
package saaps.dbt;

import java.net.*;
import java.io.*;

/** 
 *
 * @author  Peter Wintoft
 * @version 2000-04-26
 */
public class LatestMonthACE extends Object {

  //The base url.
  URL baseURL;
  //The base url buffered reader.
  BufferedReader baseBufReader;

  /** Creates new LatestMonthACEmag */
  public LatestMonthACE() {
    //Create base url and url connection.
    String urlString = "ftp://ftp.sec.noaa.gov/pub/lists/ace";
    try
    {
      baseURL = new URL(urlString);
      baseBufReader = new BufferedReader(new InputStreamReader(baseURL.openStream()));
    }
    catch (MalformedURLException e)
    {
      System.err.println(e);
    }
    catch (IOException e)
    {
      System.err.println(e);
    }
  }
  
  /**
  * @param args the command line arguments
  */
  public static void main (String args[]) {
    LatestMonthACE ace = new LatestMonthACE();
    //Go through the list.
    try
    {
      String textLine;
      while ((textLine = ace.baseBufReader.readLine()) != null)
      {
        //Is it one minute magnetic field data.
        if (textLine.endsWith("ace_mag_1m.txt"))
          ace.readAndStoreACEmag(textLine);
        //Is it one minute plasma data.
        if (textLine.endsWith("ace_swe_1m.txt"))
          ace.readAndStoreACEswe(textLine);
      }
    }
    catch (IOException e)
    {
       System.err.println(e);
    }
  }
  
  private void readAndStoreACEmag(String name)
  {
    System.out.println("ACE mag");
    System.out.println(name);
  }

  private void readAndStoreACEswe(String name)
  {
    System.out.println("ACE swe");
    System.out.println(name);
  }
}
