/*
   ShowMetaData.java

   Title:
   Author:
   Description:
*/

package saaps.dbt;

import java.io.*;
import java.sql.*;
import java.util.Calendar;
import java.util.TimeZone;
import java.util.Locale;
import java.text.*;


public class ShowMetaData  {
    private static long cdfEpoch1970 = 62167219200000L;

    public static String getMetaString(String dbName, String sedatdbname) {
		
		String id = null, 
				name = null,
				description = null,
//				startTime = null,
//				endTime = null,
				lastModified = null,
//				continous = null,
				timeStep = null;
		
		ODIDatabase odi = new ODIDatabase();
		
		name = sedatdbname;
			Calendar calStart = Calendar.getInstance(TimeZone.getTimeZone("UTC"),new Locale("sv","SE"));
			Calendar calEnd = Calendar.getInstance(TimeZone.getTimeZone("UTC"),new Locale("sv","SE"));
		Date ds = null;
		Date de = null;

		try {
			String q = "SELECT id,epoch_start,epoch_end,modification_date FROM dataset WHERE name=\""+dbName+"\"";
			ResultSet res = odi.query(q);
			res.next();
			calStart.setTime(new Date(res.getLong("epoch_start") - cdfEpoch1970));
			calEnd.setTime(new Date(res.getLong("epoch_end") - cdfEpoch1970));
			id = res.getString("id");
//			startTime = res.getString("epoch_start");
//			endTime = res.getString("epoch_end");
			lastModified = res.getString("modification_date");
		
			q = "SELECT value FROM dataset_metadata WHERE attribute=\"Logical_source_description\" AND dataset_id="+id;
			res = odi.query(q);
			res.next();
			description = res.getString("value");

			q = "SELECT value FROM dataset_metadata WHERE attribute=\"Time_resolution\" AND dataset_id="+id;
			res = odi.query(q);
			res.next();
			timeStep = res.getString("value");
		}
		catch(SQLException e) {
			e.printStackTrace();
		}
		
		StringBuffer result = new StringBuffer();
	    result.append("***********  " + name + " MetaData  ***********\n");
	    result.append("SEDAT Name   :      " + name + "\n");
	    result.append("ODI Name     :      " + dbName + "\n");
	    result.append("Description  :      " + description + "\n");
//	    result.append("Start time   :      " + startTime + "\n");
	    result.append("Start time   :      " + formatDate(calStart) + "\n");
//	    result.append("End time     :      " + endTime + "\n");
	    result.append("End time     :      " + formatDate(calEnd) + "\n");
	    result.append("Last modified:      " + lastModified + "\n");
//	    result.append("Continous    :      " + continous + "\n");
	    result.append("Timestep     :      " + timeStep + "\n");

		return result.toString();
	}

    private static String formatDate(Calendar c) {
	c.setTimeZone(TimeZone.getTimeZone("GMT"));
	int year = c.get(Calendar.YEAR);
	int month = c.get(Calendar.MONTH) + 1;
	int date = c.get(Calendar.DATE);
	int hour = c.get(Calendar.HOUR_OF_DAY);
	int minute = c.get(Calendar.MINUTE);
	StringBuffer sb = new StringBuffer();
	sb.append(year);
	sb.append("-");
	if (month<10)
	    sb.append("0");
	sb.append(month);
	sb.append("-");
	if (date<10)
	    sb.append("0");
	sb.append(date);
	sb.append(" ");
	if (hour<10)
	    sb.append("0");
	sb.append(hour);
	sb.append(":");
	if (minute<10)
	    sb.append("0");
	sb.append(minute);
	sb.append(" UT");
	return sb.toString();
    }

/*	Vector dboVec=null;
	Object dbo=null;
	StringBuffer result = new StringBuffer();

	Database dbRef = Database.getInstance(dbName,true); //readonly

	Calendar sd = Calendar.getInstance(TimeZone.getTimeZone("GMT"),new Locale("sv","SE"));
	Calendar ed = Calendar.getInstance(TimeZone.getTimeZone("GMT"),new Locale("sv","SE"));
	Calendar mod = Calendar.getInstance(TimeZone.getTimeZone("GMT"),new Locale("sv","SE"));

	/* get Last modified time */
/*	//Get the database location
	StringBuffer myFile = new StringBuffer();
	String tmp1 = System.getProperty(Database.dataDirVar,Database.baseDir);

	//Make sure that it ends with a "/".
	if(!tmp1.endsWith("/"))
	    myFile.append(tmp1 + "/" + dbName + ".data");
	else 
	    myFile.append(tmp1 + dbName + ".data");

	File theFile = new File(myFile.toString());
	mod.setTime(new Date(theFile.lastModified()));
	mod.clear(sd.MILLISECOND);

	if(dbRef.isSet()) {
	    sd.setTime(dbRef.meta.getStartDate());
	    sd.clear(sd.MILLISECOND);
	    ed.setTime(dbRef.meta.getEndDate());
	    ed.clear(ed.MILLISECOND);

	    NumberFormat nf = NumberFormat.getInstance();
	    nf.setMinimumIntegerDigits(2);

	    result.append("**********   " + dbRef.meta.getName() + " MetaData   **********\n");
	    result.append("Name         :      " + dbRef.meta.getName() + "\n");
	    result.append("Description  :      " + dbRef.meta.getDescr() + "\n");
	    result.append("Start time   :      " + sd.get(Calendar.YEAR) + " " + nf.format(sd.get(Calendar.MONTH)+1) + " " + nf.format(sd.get(Calendar.DAY_OF_MONTH)) + " " + nf.format(sd.get(Calendar.HOUR_OF_DAY)) + " " + nf.format(sd.get(Calendar.MINUTE)) + " " + nf.format(sd.get(Calendar.SECOND)) + "\n");
	    result.append("End time     :      " +ed.get(Calendar.YEAR) + " " + nf.format(ed.get(Calendar.MONTH)+1) + " " + nf.format(ed.get(Calendar.DAY_OF_MONTH)) + " " + nf.format(ed.get(Calendar.HOUR_OF_DAY)) + " " + nf.format(ed.get(Calendar.MINUTE)) + " " + nf.format(ed.get(Calendar.SECOND)) + "\n");
	    result.append("Last modified:      " +mod.get(Calendar.YEAR) + " " + nf.format(mod.get(Calendar.MONTH)+1) + " " + nf.format(mod.get(Calendar.DAY_OF_MONTH)) + " " + nf.format(mod.get(Calendar.HOUR_OF_DAY)) + " " + nf.format(mod.get(Calendar.MINUTE)) + " " + nf.format(mod.get(Calendar.SECOND)) + "\n");
	    result.append("Continous    :      " + dbRef.meta.getCont() + "\n");
	    result.append("Timestep     :      " + dbRef.meta.getTimeStep() + " (ms)" + "\n");

	    String[] ntmp = dbRef.meta.getFieldNames();
	    String[] ttmp = dbRef.meta.getFieldTypes();
            StringBuffer ns = new StringBuffer();
            StringBuffer ts = new StringBuffer();
            ns.append("Fields       :      ");
            ts.append("Types        :      ");
	    if(ntmp != null && ttmp != null) {
                for(int i=0;i<ntmp.length;i++) {
                    int len1=0;
                    int len2=0;
                    if (ntmp[i].length()>ttmp[i].length()) {
                        len1=ntmp[i].length();
                        len2=ttmp[i].length();
                        char chArr[] = new char[((int) (len1-len2)/2)];
                        for(int j=0;j<chArr.length;j++)
                            chArr[j]=' ';
                        
                        String pad = new String(chArr);

                        ns.append(ntmp[i] + " ");
                        ts.append(pad + ttmp[i] + " " + pad);
                        if((len1-len2)%2 != 0)
                            ts.append(" ");

                    }
                    else {
                        len1=ttmp[i].length();
                        len2=ntmp[i].length();
                        char chArr[] = new char[((int) (len1-len2)/2)];
                        for(int j=0;j<chArr.length;j++)
                            chArr[j]=' ';
                        
                        String pad = new String(chArr);
                        ns.append(pad + ntmp[i] + " " + pad);
                        if((len1-len2)%2 != 0)
                            ns.append(" ");

                        ts.append(ttmp[i] + " ");                        
                    }
		}
		ns.append("\n");
		ts.append("\n");                
	    }
            result.append(ns.toString()+ts.toString());
	    result.append("**********   " + dbRef.meta.getName() + " MetaData   **********");
	    return result.toString();
	}
	else { 
	    result.append("MetaData for " + dbName  + " is unavailable\n");
	    return result.toString();
	}
    }


    // Main entry point
    static public void main(String[] args) {

	if(args.length<1) {
	    System.out.println("Usage: java saaps.saam.ShowMetaData <Db class name>");
	    System.exit(0);
	}
	System.out.println(ShowMetaData.getMetaString(args[0]));
    }*/
}

