package saaps.dbt;

import java.io.*;
import java.util.*;
import java.text.*;
import java.lang.*;

import saaps.util.*;

public class Test  {
    static public void main(String[] args) {
        
        int ave,i;
        
        SimpleDateFormat formatter = (SimpleDateFormat)
        SimpleDateFormat.getDateTimeInstance(0,0,new Locale("sv","SE"));
        
        formatter.setTimeZone(TimeZone.getTimeZone("UTC"));
        formatter.applyPattern("yyyy.MM.dd HH:mm:ss");
        
        if(args.length<2) {
            System.out.println("Usage: java saaps.dbt.Test <Db class name> < d | h | m >");
            System.exit(0);
        }
        try {
            int aveIn = 1;
            NumberFormat nf = NumberFormat.getInstance();
            nf.setMaximumFractionDigits(3);
            nf.setMinimumFractionDigits(3);
            
            Calendar sd = Calendar.getInstance(TimeZone.getTimeZone("UTC"),new Locale("sv","SE"));
            Calendar ed = Calendar.getInstance(TimeZone.getTimeZone("UTC"),new Locale("sv","SE"));
            sd.set(2000,5-1,1,0,0,0);
            sd.clear(sd.MILLISECOND);
            ed.set(2000,5-1,1,0,15,0);
            ed.clear(ed.MILLISECOND);
            //ed.add(Calendar.MINUTE,10);
            i=4;
            long start = -10*60*1000;
            long end = 10*60*1000;
            
            Database db = Database.getInstance(args[0],true);
            int numObj = (int) ((ed.getTime().getTime() - sd.getTime().getTime())/db.meta.getTimeStep());
            int size = (int) db.getFirst().getObjectSize();
            System.out.println(args[0] + " size:" + size  + " numObj:" + numObj + " Tot Size:" + size*numObj);
            
            
            //TimeSeries ts = db.retrieveTS(sd.getTime(),ed.getTime(),false,1*60*1000);
            //limit in bytes
            //TimeSeries ts = db.newGetTimeSeries(sd.getTime(),ed.getTime(), 20*1024*1024);
            //TimeSeries ts = db.getResampledTimeSeries(sd.getTime(),ed.getTime(), 24*24*60*60*1000);
            //TimeSeries ts = db.retrieveHere(db.getLast().getDate(),-10,true);
            //TimeSeries ts = db.retrieveTS(sd,ed,false);

            TimeSeries ts = db.retrieveTS(sd.getTime(),ed.getTime(),false);
            System.out.println("TimeSeries: " + ts.getShortDescription() + " long descr:" + ts.getLongDescription());
                        
            for(i = 0;i<ts.getLength();i++) {
                System.out.print("d: " + formatter.format(ts.getDate(i)));
                for(int j=0;j<ts.getNumOfDataFields();j++) {
                    System.out.print(" " + nf.format(ts.getData(i,j)));
                }
                System.out.println("");
            }
            db.close();
        }
        catch (Exception e) {
            System.err.println(e);
            e.printStackTrace();
        }
    }
}
