/*
 * Prob.java
 *
 * Created on June 20, 2001, 2:08 PM
 */

package saaps.math;

import java.io.Serializable;

/**
 *
 * @author  root
 * @version 
 */
public class Prob extends java.lang.Object implements Serializable {

    public double[] x;
    public double[] y;
    public double[][] xy;
    
    public Prob() {
    }
    
    /**
     *Create probabilities with uniform distribution.
     */
    public Prob(int m, int n) {
        this.x = new double[m];
        this.y = new double[n];
        this.xy = new double[m][n];
        for (int i=0;i<m;i++) {
            this.x[i] = 1.0/m;
        }
        for (int i=0;i<n;i++) {
            this.y[i] = 1.0/n;
        }
        for (int i=0;i<m;i++) {
            for (int j=0;j<n;j++) {
                this.xy[i][j] = this.x[i] * this.y[j];
            }
        }
    }
    
    /**
     x = [0, .., m-1]
     */
    public Prob(int[] x, int[] y) {
        this.calcProb(x,y);
    }

    public void calcProb(int[] x, int[] y) {
        //Find maximum x value.
        int xmax = 0;
        for (int i=0;i<x.length;i++) {
            if (x[i] > xmax) xmax = x[i];
        }
        //x can take a value between 0 to xmax.
        //The number of possible values is thus m = xmax + 1.
        int m = xmax + 1;
        //Find maximum y value.
        int ymax = 0;
        for (int i=0;i<y.length;i++) {
            if (y[i] > ymax) ymax = y[i];
        }
        //y can take a value between 0 to ymax.
        //The number of possible values is thus n = ymax + 1.
        int n = ymax + 1;
        
        //Calculate probabilities.
        this.calcProb(x,y,m,n);
        
/*        //Init the probs.
        this.x = new double[m];
        this.y = new double[n];
        this.xy = new double[m][n];
        //Calculate the fraction.
        double f = 1.0/x.length;
        //Calculate the probabilities.
        for (int i=0;i<x.length;i++) {
            this.x[x[i]] += f;
            this.y[y[i]] += f;
            this.xy[x[i]][y[i]] += f;
        }*/
    }
    
    public void calcProb(int[] x, int[] y, int m, int n) {
        //x can take on a value between 0 to m-1.
        //If x is larger than m-1 it is considered to belong to class m-1.
        for (int i=0;i<x.length;i++) {
            if (x[i]>m-1) x[i] = m-1;
        }
        //y can take on a value between 0 to n-1.
        //If y is larger than n-1 it is considered to belong to class n-1.
        for (int i=0;i<y.length;i++) {
            if (y[i]>n-1) y[i] = n-1;
        }
        
        //Init the probs.
        this.x = new double[m];
        this.y = new double[n];
        this.xy = new double[m][n];
        //Calculate the fraction.
        double f = 1.0/x.length;
        //Calculate the probabilities.
        for (int i=0;i<x.length;i++) {
            this.x[x[i]] += f;
            this.y[y[i]] += f;
            this.xy[x[i]][y[i]] += f;
        }
    }
    
    public static void main(String[] args) {
//        int[] x = {0,1,2,3,0,1,2,3,0,1,2,3};
//        int[] y = {0,1,2,3,4,0,1,2,3,4,0,1};
        Prob p = new Prob(3,5);
        double sx = 0;
        for (int i=0;i<p.x.length;i++) {
            System.out.println("px(" + i + ")=" + p.x[i]);
            sx += p.x[i];
        }
        System.out.println("Sum px = " + sx);
        double sy = 0;
        for (int i=0;i<p.y.length;i++) {
            System.out.println("py(" + i + ")=" + p.y[i]);
            sy += p.y[i];
        }
        System.out.println("Sum py = " + sy);
        double sxy = 0;
        for (int i=0;i<p.x.length;i++) {
            for (int j=0;j<p.y.length;j++) {
                System.out.println("pxy(" + i + "," + j + ")=" + p.xy[i][j]);
                sxy += p.xy[i][j];
            }
        }
        System.out.println("Sum pxy = " + sxy);
    }
    
}
