/*
 * AnomalyPlotterApp.java
 *
 * Created on August 20, 2001, 1:05 PM
 */

package saaps.saam;

//import saaps.util.EventList;
//import saaps.util.EventListDialog;
import saaps.util.InfoDialog;
import saaps.util.PlotFrame;
import saaps.util.TimeSeries;
import saaps.util.AppHelp;

/**
 *
 * @author  root
 * @version 
 */
public class AnomalyPlotterApp extends java.awt.Panel {

    //The frame that holds the panel.
    private java.awt.Frame frame;
    
    //The relation between field index and field type.
    private AnomalyPlotterFieldData apfd;
    
    private AppHelp help = null;
    
    /** Creates new form AnomalyPlotterApp */
    public AnomalyPlotterApp(java.awt.Frame frame) {
        this.frame = frame;
        this.apfd = new AnomalyPlotterFieldData();
        this.initComponents ();
    }
    
    public static void getAnomalyPlotterApp() {
        final java.awt.Frame frame = new java.awt.Frame();
        frame.addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                /** Exit the Application */
                frame.dispose();
                System.exit (0);
            }
        }
      );
      frame.setBackground(new java.awt.Color (204, 204, 204));
      frame.setName("Anomaly Plotter");
      frame.setTitle("Anomaly Plotter");
      frame.add(new AnomalyPlotterApp(frame));
      frame.pack();
      frame.show();
    }

    /**
     * Removes components not needed in the Applet.
     */
    public void setAppletStyle() {
        this.panelSouth.remove(buttonQuit);
    }
    
    public static void main(String[] args) {
        AnomalyPlotterApp.getAnomalyPlotterApp();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        labelTitle = new java.awt.Label();
        panelWest = new java.awt.Panel();
        buttonEditAnomalyData = new java.awt.Button();
        buttonIdentifyFields = new java.awt.Button();
        panelSouth = new java.awt.Panel();
        buttonHelp = new java.awt.Button();
        buttonQuit = new java.awt.Button();
        panelEast = new java.awt.Panel();
        buttonLocalTimePlot = new java.awt.Button();
        buttonLocalTimeHistogram = new java.awt.Button();
        buttonLTLong = new java.awt.Button();
        buttonLTLat = new java.awt.Button();
        
        setLayout(new java.awt.BorderLayout());
        
        labelTitle.setAlignment(java.awt.Label.CENTER);
        labelTitle.setBackground(new java.awt.Color(204, 204, 204));
        labelTitle.setFont(new java.awt.Font("Dialog", 1, 18));
        labelTitle.setForeground(java.awt.Color.black);
        labelTitle.setText("Anomaly Plotter");
        add(labelTitle, java.awt.BorderLayout.NORTH);
        
        panelWest.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        panelWest.setBackground(new java.awt.Color(204, 204, 204));
        panelWest.setFont(new java.awt.Font("Dialog", 0, 11));
        panelWest.setForeground(java.awt.Color.black);
        panelWest.setName("panel3");
        buttonEditAnomalyData.setBackground(new java.awt.Color(204, 204, 204));
        buttonEditAnomalyData.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonEditAnomalyData.setForeground(java.awt.Color.black);
        buttonEditAnomalyData.setLabel("Edit Anomaly Data ...");
        buttonEditAnomalyData.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonEditAnomalyDataActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.insets = new java.awt.Insets(0, 10, 10, 0);
        panelWest.add(buttonEditAnomalyData, gridBagConstraints1);
        
        buttonIdentifyFields.setBackground(new java.awt.Color(204, 204, 204));
        buttonIdentifyFields.setEnabled(false);
        buttonIdentifyFields.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonIdentifyFields.setForeground(java.awt.Color.black);
        buttonIdentifyFields.setLabel("Identify Fields ...");
        buttonIdentifyFields.setName("button8");
        buttonIdentifyFields.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonIdentifyFieldsActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 10, 0, 0);
        panelWest.add(buttonIdentifyFields, gridBagConstraints1);
        
        add(panelWest, java.awt.BorderLayout.WEST);
        
        panelSouth.setBackground(new java.awt.Color(204, 204, 204));
        panelSouth.setFont(new java.awt.Font("Dialog", 0, 11));
        panelSouth.setForeground(java.awt.Color.black);
        panelSouth.setName("panel10");
        buttonHelp.setBackground(new java.awt.Color(204, 204, 204));
        buttonHelp.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonHelp.setForeground(java.awt.Color.black);
        buttonHelp.setLabel("Help");
        buttonHelp.setName("button12");
        buttonHelp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHelpActionPerformed(evt);
            }
        });
        
        panelSouth.add(buttonHelp);
        
        buttonQuit.setBackground(new java.awt.Color(204, 204, 204));
        buttonQuit.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonQuit.setForeground(java.awt.Color.black);
        buttonQuit.setLabel("Quit");
        buttonQuit.setName("button13");
        buttonQuit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonQuitActionPerformed(evt);
            }
        });
        
        panelSouth.add(buttonQuit);
        
        add(panelSouth, java.awt.BorderLayout.SOUTH);
        
        panelEast.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        panelEast.setBackground(new java.awt.Color(204, 204, 204));
        panelEast.setFont(new java.awt.Font("Dialog", 0, 11));
        panelEast.setForeground(java.awt.Color.black);
        panelEast.setName("panel12");
        buttonLocalTimePlot.setBackground(new java.awt.Color(204, 204, 204));
        buttonLocalTimePlot.setEnabled(false);
        buttonLocalTimePlot.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonLocalTimePlot.setForeground(java.awt.Color.black);
        buttonLocalTimePlot.setLabel("Local Time Plot");
        buttonLocalTimePlot.setName("button15");
        buttonLocalTimePlot.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonLocalTimePlotActionPerformed(evt);
            }
        });
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints2.insets = new java.awt.Insets(0, 10, 10, 10);
        panelEast.add(buttonLocalTimePlot, gridBagConstraints2);
        
        buttonLocalTimeHistogram.setBackground(new java.awt.Color(204, 204, 204));
        buttonLocalTimeHistogram.setEnabled(false);
        buttonLocalTimeHistogram.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonLocalTimeHistogram.setForeground(java.awt.Color.black);
        buttonLocalTimeHistogram.setLabel("Local Time Histogram");
        buttonLocalTimeHistogram.setName("button10");
        buttonLocalTimeHistogram.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonLocalTimeHistogramActionPerformed(evt);
            }
        });
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.insets = new java.awt.Insets(0, 10, 10, 10);
        panelEast.add(buttonLocalTimeHistogram, gridBagConstraints2);
        
        buttonLTLong.setBackground(new java.awt.Color(204, 204, 204));
        buttonLTLong.setEnabled(false);
        buttonLTLong.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonLTLong.setForeground(java.awt.Color.black);
        buttonLTLong.setLabel("LT-Long. Plot");
        buttonLTLong.setName("button6");
        buttonLTLong.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonLTLongActionPerformed(evt);
            }
        });
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints2.insets = new java.awt.Insets(0, 10, 10, 10);
        panelEast.add(buttonLTLong, gridBagConstraints2);
        
        buttonLTLat.setBackground(new java.awt.Color(204, 204, 204));
        buttonLTLat.setEnabled(false);
        buttonLTLat.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonLTLat.setForeground(java.awt.Color.black);
        buttonLTLat.setLabel("LT-Lat. Plot");
        buttonLTLat.setName("button6");
        buttonLTLat.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonLTLatActionPerformed(evt);
            }
        });
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints2.insets = new java.awt.Insets(0, 10, 0, 10);
        panelEast.add(buttonLTLat, gridBagConstraints2);
        
        add(panelEast, java.awt.BorderLayout.EAST);
        
    }//GEN-END:initComponents

  private void buttonLTLatActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonLTLatActionPerformed
// Add your handling code here:
      //Get the time series with LT-Latitude data.
      TimeSeries ts = this.apfd.getLTLatTS();
      //Plot if we have data else produce an error.
      if (ts != null) {
          //Set the plot parameters.
          int xField = 0;
          int[] yFields = {1};
          boolean lines = false;
          boolean points = true;
          boolean xLog = false;
          boolean yLog = false;
          //Create the plot.
          new PlotFrame(ts,xField,yFields,lines,points,xLog,yLog).setVisible(true);
      }
      else {
          StringBuffer sb = new StringBuffer();
          sb.append("The plot can not be produced.");
          sb.append("\nThe local time is not available and can not be computed,");
          sb.append("\nor the latitude is not available.");
          sb.append("\nThe following fields are present:");
          String[] types = this.apfd.getTypeUsed();
          if (types == null) {
              sb.append("\n None.");
          }
          else {
              for (int i=0;i<types.length;i++) {
                  sb.append("\n" + types[i]);
              }
          }
          new InfoDialog(this.frame,"Error",sb.toString(),40).setVisible(true);
      }
  }//GEN-LAST:event_buttonLTLatActionPerformed

  private void buttonLTLongActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonLTLongActionPerformed
// Add your handling code here:
      //Get the time series with LT-Longitude data.
      TimeSeries ts = this.apfd.getLTLongTS();
      //Plot if we have data else produce an error.
      if (ts != null) {
          //Set the plot parameters.
          int xField = 0;
          int[] yFields = {1};
          boolean lines = false;
          boolean points = true;
          boolean xLog = false;
          boolean yLog = false;
          //Create the plot.
          new PlotFrame(ts,xField,yFields,lines,points,xLog,yLog).setVisible(true);
      }
      else {
          StringBuffer sb = new StringBuffer();
          sb.append("The plot can not be produced.");
          sb.append("\nThe local time is not available and can not be computed,");
          sb.append("\nor the longitude is not available.");
          sb.append("\nThe following fields are present:");
          String[] types = this.apfd.getTypeUsed();
          if (types == null) {
              sb.append("\n None.");
          }
          else {
              for (int i=0;i<types.length;i++) {
                  sb.append("\n" + types[i]);
              }
          }
          new InfoDialog(this.frame,"Error",sb.toString(),40).setVisible(true);
      }
  }//GEN-LAST:event_buttonLTLongActionPerformed

    private void buttonHelpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonHelpActionPerformed
      System.out.println("Launching help frame ...");
      if(help != null) {
          help.setVisible(true);
      }
      else {
        /* Get a Class object from this object and then the Name of the class to use as help fi */
          help = AppHelp.getAppHelp(this.getClass().getName());
      }
    }//GEN-LAST:event_buttonHelpActionPerformed

  private void buttonQuitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonQuitActionPerformed
      if(help != null)
          help.dispose();
      this.frame.dispose();
  }//GEN-LAST:event_buttonQuitActionPerformed

  private void buttonLocalTimeHistogramActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonLocalTimeHistogramActionPerformed
// Add your handling code here:
      //Get the time series with local time data.
      TimeSeries ts = this.apfd.getLocalTimeHistogram();
      //Plot if we have data else produce an error.
      if (ts != null) {
          //Set the plot parameters.
          int xField = 0;
          int[] yFields = {1};
          boolean lines = true;
          boolean points = true;
          boolean xLog = false;
          boolean yLog = false;
          //Create the plot.
          new PlotFrame(ts,xField,yFields,lines,points,xLog,yLog).setVisible(true);
      }
      else {
          StringBuffer sb = new StringBuffer();
          sb.append("The plot can not be produced.");
          sb.append("\nThe local time is not available and can not be computed.");
          sb.append("\nThe following fields are present:");
          String[] types = this.apfd.getTypeUsed();
          if (types == null) {
              sb.append("\n None.");
          }
          else {
              for (int i=0;i<types.length;i++) {
                  sb.append("\n" + types[i]);
              }
          }
          new InfoDialog(this.frame,"Error",sb.toString(),40).setVisible(true);
      }
  }//GEN-LAST:event_buttonLocalTimeHistogramActionPerformed

  private void buttonLocalTimePlotActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonLocalTimePlotActionPerformed
// Add your handling code here:
      //Get the time series with local time data.
      TimeSeries ts = this.apfd.getLocalTimeTS();
      //Plot if we have data else produce an error.
      if (ts != null) {
          //Set the plot parameters.
          int xField = -1;
          int[] yFields = {0};
          boolean lines = false;
          boolean points = true;
          boolean xLog = false;
          boolean yLog = false;
          //Create the plot.
          new PlotFrame(ts,xField,yFields,lines,points,xLog,yLog).setVisible(true);
      }
      else {
          StringBuffer sb = new StringBuffer();
          sb.append("The plot can not be produced.");
          sb.append("\nThe local time is not available and can not be computed.");
          sb.append("\nThe following fields are present:");
          String[] types = this.apfd.getTypeUsed();
          if (types == null) {
              sb.append("\n None.");
          }
          else {
              for (int i=0;i<types.length;i++) {
                  sb.append("\n" + types[i]);
              }
          }
          new InfoDialog(this.frame,"Error",sb.toString(),40).setVisible(true);
      }
  }//GEN-LAST:event_buttonLocalTimePlotActionPerformed

  private void buttonEditAnomalyDataActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonEditAnomalyDataActionPerformed
// Add your handling code here:
      AnomalyPlotterData apd = new AnomalyPlotterData(this.frame,this.apfd.getDataString());
      apd.setVisible(true);
      if (apd.isOK()) {
          this.apfd.setDataString(apd.getDataString());
          if ((apd.getDataString()).equals("") == false)
              this.apfd.parseData();
      }
      if (this.apfd.isAllSet()) {
          this.buttonIdentifyFields.setEnabled(true);
          this.buttonLTLong.setEnabled(true);
          this.buttonLTLat.setEnabled(true);
          this.buttonLocalTimePlot.setEnabled(true);
          this.buttonLocalTimeHistogram.setEnabled(true);
      }
  }//GEN-LAST:event_buttonEditAnomalyDataActionPerformed

  private void buttonIdentifyFieldsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonIdentifyFieldsActionPerformed
// Add your handling code here:
      if (this.apfd.isAllSet()) {
          AnomalyPlotterFields apf = new AnomalyPlotterFields(this.frame,this.apfd);
          apf.setVisible(true);
          if (apf.okButtonPushed()) {
//              this.apfd.setFieldTypeMapping(apf.getFieldTypeMapping());
              this.apfd.setFieldToTypeMap(apf.getFieldToTypeMap());
          }
//          if (this.apfd.isAllSet()) {
          this.buttonLTLong.setEnabled(true);
          this.buttonLTLat.setEnabled(true);
          this.buttonLocalTimePlot.setEnabled(true);
          this.buttonLocalTimeHistogram.setEnabled(true);
//          }
      }
      else {
          new InfoDialog(this.frame,"Error","Anomaly Data must first be edited.",40).setVisible(true);
      }
  }//GEN-LAST:event_buttonIdentifyFieldsActionPerformed

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private java.awt.Label labelTitle;
  private java.awt.Panel panelWest;
  private java.awt.Button buttonEditAnomalyData;
  private java.awt.Button buttonIdentifyFields;
  private java.awt.Panel panelSouth;
  private java.awt.Button buttonHelp;
  private java.awt.Button buttonQuit;
  private java.awt.Panel panelEast;
  private java.awt.Button buttonLocalTimePlot;
  private java.awt.Button buttonLocalTimeHistogram;
  private java.awt.Button buttonLTLong;
  private java.awt.Button buttonLTLat;
  // End of variables declaration//GEN-END:variables

}
