/*
 * AnomalyPlotterFields.java
 *
 * Created on August 20, 2001, 2:44 PM
 */

package saaps.saam;

import java.util.StringTokenizer;
import java.util.Vector;

import saaps.util.InfoDialog;

/**
 *
 * @author  root
 * @version 
 */
public class AnomalyPlotterAppletFields extends java.awt.Dialog {
    
    //True if the OK button has been pushed.
    private boolean ok = false;
    
    //This object contains the mapping from field index to field type.
    private AnomalyPlotterFieldData apfd;
    
    //The parent frame.
    private java.awt.Frame parent;

    /** Creates new form AnomalyPlotterFields */
    public AnomalyPlotterAppletFields(java.awt.Frame parent, boolean modal) {
        super (parent, modal);
        this.parent = parent;
        initComponents ();
        pack ();
    }
    
    public AnomalyPlotterAppletFields(java.awt.Frame parent, AnomalyPlotterFieldData apfd) {
        super(parent,true);
        this.parent = parent;
        this.apfd = apfd;
        this.initComponents();
        this.initSampleLine();
        this.initFieldIndex(apfd.getFieldNotUsed());
        this.initFieldType(apfd.getTypeNotUsed());
        this.initFieldInfo(apfd.getMapFieldToType());
        this.pack();
    }
    
    public boolean okButtonPushed() {
        return this.ok;
    }
    
    private void initSampleLine() {
        this.textFieldSampleLine.setText(this.apfd.getSampleLine());
    }
    
    private void initFieldIndex(String[] s) {
        if (s != null) {
            for (int i=0;i<s.length;i++) {
                this.listFieldIndex.add(s[i]);
            }
        }
    }
    
    private void initFieldType(String[] s) {
        if (s != null) {
            for (int i=0;i<s.length;i++) {
                this.listFieldSelect.add(s[i]);
            }
        }
    }
    
    private void initFieldInfo(String[] s) {
        if (s != null) {
            for (int i=0;i<s.length;i++) {
                this.listFieldInfo.add(s[i]);
            }
        }
    }
    
    public String[] getFieldIndexNotUsed() {
        return this.listFieldIndex.getItems();
    }
    
    public String[] getFieldTypeNotUsed() {
        return this.listFieldSelect.getItems();
    }
    
    public String[] getFieldToTypeMap() {
        return this.listFieldInfo.getItems();
    }
    
    /** This method is called from within the init() method to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        panelCenter = new java.awt.Panel();
        panelFieldIndex = new java.awt.Panel();
        labelFieldIndex = new java.awt.Label();
        listFieldIndex = new java.awt.List();
        buttonFieldIndex = new java.awt.Button();
        panelFieldSelect = new java.awt.Panel();
        labelFieldSelect = new java.awt.Label();
        listFieldSelect = new java.awt.List();
        buttonFieldSelect = new java.awt.Button();
        panelFieldInfo = new java.awt.Panel();
        labelFieldInfo = new java.awt.Label();
        listFieldInfo = new java.awt.List();
        buttonFieldInfo = new java.awt.Button();
        panelSouth = new java.awt.Panel();
        buttonCancel = new java.awt.Button();
        buttonOK = new java.awt.Button();
        panelNorth = new java.awt.Panel();
        labelTitle = new java.awt.Label();
        textFieldSampleLine = new java.awt.TextField();
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });
        
        panelCenter.setLayout(new java.awt.GridLayout(1, 3));
        
        panelCenter.setFont(new java.awt.Font("Dialog", 0, 11));
        panelCenter.setName("panel5");
        panelCenter.setBackground(new java.awt.Color(204, 204, 204));
        panelCenter.setForeground(java.awt.Color.black);
        panelFieldIndex.setLayout(new java.awt.BorderLayout());
        
        panelFieldIndex.setFont(new java.awt.Font("Dialog", 0, 11));
        panelFieldIndex.setName("panel6");
        panelFieldIndex.setBackground(new java.awt.Color(204, 204, 204));
        panelFieldIndex.setForeground(java.awt.Color.black);
        labelFieldIndex.setFont(new java.awt.Font("Dialog", 0, 11));
        labelFieldIndex.setName("label10");
        labelFieldIndex.setBackground(new java.awt.Color(204, 204, 204));
        labelFieldIndex.setForeground(java.awt.Color.black);
        labelFieldIndex.setText("Field Index");
        panelFieldIndex.add(labelFieldIndex, java.awt.BorderLayout.NORTH);
        
        listFieldIndex.setFont(new java.awt.Font("Dialog", 0, 11));
        listFieldIndex.setBackground(new java.awt.Color(255, 247, 233));
        listFieldIndex.setForeground(java.awt.Color.black);
        listFieldIndex.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                listFieldIndexItemStateChanged(evt);
            }
        });
        
        panelFieldIndex.add(listFieldIndex, java.awt.BorderLayout.CENTER);
        
        buttonFieldIndex.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonFieldIndex.setLabel("Use Default");
        buttonFieldIndex.setName("button13");
        buttonFieldIndex.setBackground(new java.awt.Color(204, 204, 204));
        buttonFieldIndex.setForeground(java.awt.Color.black);
        buttonFieldIndex.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonFieldIndexActionPerformed(evt);
            }
        });
        
        panelFieldIndex.add(buttonFieldIndex, java.awt.BorderLayout.SOUTH);
        
        panelCenter.add(panelFieldIndex);
        
        panelFieldSelect.setLayout(new java.awt.BorderLayout());
        
        panelFieldSelect.setFont(new java.awt.Font("Dialog", 0, 11));
        panelFieldSelect.setName("panel7");
        panelFieldSelect.setBackground(new java.awt.Color(204, 204, 204));
        panelFieldSelect.setForeground(java.awt.Color.black);
        labelFieldSelect.setFont(new java.awt.Font("Dialog", 0, 11));
        labelFieldSelect.setName("label12");
        labelFieldSelect.setBackground(new java.awt.Color(204, 204, 204));
        labelFieldSelect.setForeground(java.awt.Color.black);
        labelFieldSelect.setText("Field Type");
        panelFieldSelect.add(labelFieldSelect, java.awt.BorderLayout.NORTH);
        
        listFieldSelect.setFont(new java.awt.Font("Dialog", 0, 11));
        listFieldSelect.setBackground(new java.awt.Color(255, 247, 233));
        listFieldSelect.setForeground(java.awt.Color.black);
        panelFieldSelect.add(listFieldSelect, java.awt.BorderLayout.CENTER);
        
        buttonFieldSelect.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonFieldSelect.setLabel("Add");
        buttonFieldSelect.setName("button11");
        buttonFieldSelect.setBackground(new java.awt.Color(204, 204, 204));
        buttonFieldSelect.setForeground(java.awt.Color.black);
        buttonFieldSelect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonFieldSelectActionPerformed(evt);
            }
        });
        
        panelFieldSelect.add(buttonFieldSelect, java.awt.BorderLayout.SOUTH);
        
        panelCenter.add(panelFieldSelect);
        
        panelFieldInfo.setLayout(new java.awt.BorderLayout());
        
        panelFieldInfo.setFont(new java.awt.Font("Dialog", 0, 11));
        panelFieldInfo.setName("panel8");
        panelFieldInfo.setBackground(new java.awt.Color(204, 204, 204));
        panelFieldInfo.setForeground(java.awt.Color.black);
        labelFieldInfo.setFont(new java.awt.Font("Dialog", 0, 11));
        labelFieldInfo.setName("label13");
        labelFieldInfo.setBackground(new java.awt.Color(204, 204, 204));
        labelFieldInfo.setForeground(java.awt.Color.black);
        labelFieldInfo.setText("Field Information");
        panelFieldInfo.add(labelFieldInfo, java.awt.BorderLayout.NORTH);
        
        listFieldInfo.setFont(new java.awt.Font("Dialog", 0, 11));
        listFieldInfo.setBackground(new java.awt.Color(255, 247, 233));
        listFieldInfo.setForeground(java.awt.Color.black);
        panelFieldInfo.add(listFieldInfo, java.awt.BorderLayout.CENTER);
        
        buttonFieldInfo.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonFieldInfo.setLabel("Remove");
        buttonFieldInfo.setName("button12");
        buttonFieldInfo.setBackground(new java.awt.Color(204, 204, 204));
        buttonFieldInfo.setForeground(java.awt.Color.black);
        buttonFieldInfo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonFieldInfoActionPerformed(evt);
            }
        });
        
        panelFieldInfo.add(buttonFieldInfo, java.awt.BorderLayout.SOUTH);
        
        panelCenter.add(panelFieldInfo);
        
        add(panelCenter, java.awt.BorderLayout.CENTER);
        
        panelSouth.setFont(new java.awt.Font("Dialog", 0, 11));
        panelSouth.setName("panel11");
        panelSouth.setBackground(new java.awt.Color(204, 204, 204));
        panelSouth.setForeground(java.awt.Color.black);
        buttonCancel.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonCancel.setLabel("Cancel");
        buttonCancel.setName("button14");
        buttonCancel.setBackground(new java.awt.Color(204, 204, 204));
        buttonCancel.setForeground(java.awt.Color.black);
        buttonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonCancelActionPerformed(evt);
            }
        });
        
        panelSouth.add(buttonCancel);
        
        buttonOK.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonOK.setLabel("OK");
        buttonOK.setName("button15");
        buttonOK.setBackground(new java.awt.Color(204, 204, 204));
        buttonOK.setForeground(java.awt.Color.black);
        buttonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonOKActionPerformed(evt);
            }
        });
        
        panelSouth.add(buttonOK);
        
        add(panelSouth, java.awt.BorderLayout.SOUTH);
        
        panelNorth.setLayout(new java.awt.BorderLayout());
        
        panelNorth.setFont(new java.awt.Font("Dialog", 0, 11));
        panelNorth.setName("panel6");
        panelNorth.setBackground(new java.awt.Color(204, 204, 204));
        panelNorth.setForeground(java.awt.Color.black);
        labelTitle.setFont(new java.awt.Font("Dialog", 1, 18));
        labelTitle.setName("label9");
        labelTitle.setBackground(new java.awt.Color(204, 204, 204));
        labelTitle.setForeground(java.awt.Color.black);
        labelTitle.setText("Identify Fields");
        labelTitle.setAlignment(java.awt.Label.CENTER);
        panelNorth.add(labelTitle, java.awt.BorderLayout.NORTH);
        
        textFieldSampleLine.setText("textField1");
        textFieldSampleLine.setBackground(new java.awt.Color(223, 223, 223));
        textFieldSampleLine.setName("textfield1");
        textFieldSampleLine.setEditable(false);
        textFieldSampleLine.setFont(new java.awt.Font("Dialog", 0, 11));
        textFieldSampleLine.setForeground(java.awt.Color.black);
        panelNorth.add(textFieldSampleLine, java.awt.BorderLayout.SOUTH);
        
        add(panelNorth, java.awt.BorderLayout.NORTH);
        
    }//GEN-END:initComponents

  private void listFieldIndexItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_listFieldIndexItemStateChanged
// Add your handling code here:
      
      int index = Integer.valueOf(this.listFieldIndex.getSelectedItem()).intValue() - 1;
      String s = this.textFieldSampleLine.getText();
      int selectStart = 0;
      int spacePos = 0;
      while (spacePos < index) {
          selectStart = s.indexOf(' ',selectStart+1);
          spacePos++;
      }
      int selectEnd = s.indexOf(' ',selectStart+1);
      this.textFieldSampleLine.select(selectStart,selectEnd);
  }//GEN-LAST:event_listFieldIndexItemStateChanged

  private void buttonFieldIndexActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonFieldIndexActionPerformed
// Add your handling code here:
      //Move back all fields.
      this.listFieldIndex.clear();
      this.initFieldIndex(this.apfd.getFields());
      this.listFieldSelect.clear();
      this.initFieldType(this.apfd.getTypes());
      this.listFieldInfo.clear();
      //The defualt field to type mapping.
      int iMax = Math.min(this.listFieldIndex.getItemCount(),this.listFieldSelect.getItemCount());
      for (int i=0;i<iMax;i++) {
          this.listFieldInfo.add(this.listFieldIndex.getItem(0) + " " + this.listFieldSelect.getItem(0));
          this.listFieldIndex.remove(0);
          this.listFieldSelect.remove(0);
      }
  }//GEN-LAST:event_buttonFieldIndexActionPerformed

  private void buttonFieldInfoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonFieldInfoActionPerformed
// Add your handling code here:
      //Make sure an item has been selected.
      int index = this.listFieldInfo.getSelectedIndex();
      if (index>=0) {
          String mapping = this.listFieldInfo.getItem(index);
          this.listFieldInfo.remove(index);
          StringTokenizer st = new StringTokenizer(mapping);
          this.listFieldIndex.add(st.nextToken());
          this.listFieldSelect.add(st.nextToken());
      }
      else {
          new InfoDialog(this.parent,"Error!","You must make a selection in the Field Information list.",40).setVisible(true);
      }
  }//GEN-LAST:event_buttonFieldInfoActionPerformed

  private void buttonFieldSelectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonFieldSelectActionPerformed
// Add your handling code here:
      //Get the field index.
      int field = this.listFieldIndex.getSelectedIndex();
      //Get the field type.
      int type = this.listFieldSelect.getSelectedIndex();
      //Make sure that an item in both lists have been selected.
      if (field>=0 & type>=0) {
          String mapping = this.listFieldIndex.getSelectedItem();
          this.listFieldIndex.remove(this.listFieldIndex.getSelectedIndex());
          mapping += " " + this.listFieldSelect.getSelectedItem();
          this.listFieldSelect.remove(this.listFieldSelect.getSelectedIndex());
          this.listFieldInfo.add(mapping);
      }
      else {
          new InfoDialog(this.parent,"Error!","You must make a selection in both the Field Index and Field Type lists.",40).setVisible(true);
      }
  }//GEN-LAST:event_buttonFieldSelectActionPerformed

  private void buttonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonOKActionPerformed
// Add your handling code here:
      this.ok = true;
      this.dispose();
  }//GEN-LAST:event_buttonOKActionPerformed

  private void buttonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCancelActionPerformed

      this.dispose();
  }//GEN-LAST:event_buttonCancelActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible (false);
        dispose ();
    }//GEN-LAST:event_closeDialog

    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
        new AnomalyPlotterAppletFields (new java.awt.Frame (), new AnomalyPlotterFieldData()).show ();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.Panel panelCenter;
    private java.awt.Panel panelFieldIndex;
    private java.awt.Label labelFieldIndex;
    private java.awt.List listFieldIndex;
    private java.awt.Button buttonFieldIndex;
    private java.awt.Panel panelFieldSelect;
    private java.awt.Label labelFieldSelect;
    private java.awt.List listFieldSelect;
    private java.awt.Button buttonFieldSelect;
    private java.awt.Panel panelFieldInfo;
    private java.awt.Label labelFieldInfo;
    private java.awt.List listFieldInfo;
    private java.awt.Button buttonFieldInfo;
    private java.awt.Panel panelSouth;
    private java.awt.Button buttonCancel;
    private java.awt.Button buttonOK;
    private java.awt.Panel panelNorth;
    private java.awt.Label labelTitle;
    private java.awt.TextField textFieldSampleLine;
    // End of variables declaration//GEN-END:variables

}
