package saaps.saam;

import java.applet.AppletContext;
import java.io.IOException;
import java.net.URL;
import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.util.Date;
import java.util.Calendar;
import java.util.TimeZone;
import java.util.Vector;
//import com.netbeans.developer.awt.AbsoluteLayout;
//import com.netbeans.developer.awt.AbsoluteContstraints;
import saaps.dbt.DatabaseRMI;
import saaps.network.NetworkParam;
import saaps.network.NormParam;
import saaps.dbt.MetaData;
import saaps.util.PlotFrame;
import saaps.util.TimeSeries;
import saaps.util.YMDChoice;

/**
 * This applet plots the data in the SAAPS database.
 * It lists the database objects from which the user
 * can select an object. The start and end date choices
 * are initiated based on the chosen database object.
 * After the user select the dates the data can be loaded
 * to the applet. The data field that should be plotted on
 * the x-axis is selected, and one or more fields for the
 * y-axis are slected. The plot symbol can be chosen and
 * when the plot button is pushed the plot is produced.
 *
 * @author  Peter Wintoft
 * @version 2000-02-18
 */
public class DataPlotterAppletAWT extends java.applet.Applet {

  private TimeSeries ts;
  private MetaData metaData;
  private 
  String[] fn;
  public DataGet dg=null;
  
  private Calendar cal = Calendar.getInstance(TimeZone.getTimeZone("GMT"));
  
  /** Initializes the Form */
  public void init () {
    initComponents ();
    //Get the database objects list.
    DatabaseRMI dbrmi = null;
    Vector dbList = null;
    try
    {
System.err.println("DBAWT");
      dbrmi = (DatabaseRMI) Naming.lookup("//" + getCodeBase().getHost() +
              ":2001" + "/DatabaseRMIServer");
      dbList = dbrmi.getDatabaseList();
    }
    catch(NotBoundException nbe)
    {
      System.err.println(nbe);
    }
    catch(MalformedURLException mfurle)
    {
      System.err.println(mfurle);
    }
    catch(RemoteException re)
    {
      System.err.println(re);
    }
    if (dbList == null)
      new ErrorDialog(getAppletFrame(),"Can not read database.\nFailed.");

System.err.println(dbList.size());
    //Show the database list.
    for (int i=0;i<dbList.size();i++)
      listDatabase.add((String) ((Vector) dbList.elementAt(i)).elementAt(1));
    //Select the first database list item.
    this.listDatabase.select(0);
    // Set default fields to latest date.
    this.setDateToLatestDate();
    //Resize the applet.
    int width = 450;
    int height = 430;
    resize(width,height);
  }

  private void verifyInputFields() throws NumberFormatException {
      Integer.valueOf(this.textFieldSY.getText());
      Integer.valueOf(this.textFieldEY.getText());
      Integer.valueOf(this.textFieldSM.getText());
      Integer.valueOf(this.textFieldEM.getText());
      Integer.valueOf(this.textFieldSD.getText());
      Integer.valueOf(this.textFieldED.getText());
  }

  /** This method is called from within the init() method to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents() {//GEN-BEGIN:initComponents
      labelTitle = new java.awt.Label();
      panelMain = new java.awt.Panel();
      panelDatabase = new java.awt.Panel();
      labelDatabase = new java.awt.Label();
      listDatabase = new java.awt.List();
      buttonInspect = new java.awt.Button();
      panelGetData = new java.awt.Panel();
      panelTime = new java.awt.Panel();
      labelStart = new java.awt.Label();
      labelEnd = new java.awt.Label();
      textFieldSY = new java.awt.TextField();
      textFieldEY = new java.awt.TextField();
      textFieldSM = new java.awt.TextField();
      textFieldEM = new java.awt.TextField();
      textFieldSD = new java.awt.TextField();
      textFieldED = new java.awt.TextField();
      panelGetDataButtons = new java.awt.Panel();
//      buttonSelectLatestData = new java.awt.Button();
      buttonGetData = new java.awt.Button();
      panelXAxis = new java.awt.Panel();
      labelXAxis = new java.awt.Label();
      listXAxis = new java.awt.List();
      panelYAxis = new java.awt.Panel();
      labelYAxis = new java.awt.Label();
      listYAxis = new java.awt.List();
      panelSouth = new java.awt.Panel();
      buttonPlot = new java.awt.Button();
      buttonHelp = new java.awt.Button();
      
      setLayout(new java.awt.BorderLayout());
      
      setBackground(java.awt.Color.lightGray);
      labelTitle.setAlignment(java.awt.Label.CENTER);
      labelTitle.setBackground(java.awt.Color.lightGray);
      labelTitle.setFont(new java.awt.Font("SansSerif", 1, 18));
      labelTitle.setText("Data Plotter");
      add(labelTitle, java.awt.BorderLayout.NORTH);
      
      panelMain.setLayout(new java.awt.GridLayout(2, 2));
      
      panelMain.setBackground(new java.awt.Color(204, 204, 204));
      panelMain.setFont(new java.awt.Font("Dialog", 0, 11));
      panelMain.setForeground(java.awt.Color.black);
      panelMain.setName("panel11");
      panelDatabase.setLayout(new java.awt.BorderLayout());
      
      panelDatabase.setBackground(new java.awt.Color(204, 204, 204));
      panelDatabase.setFont(new java.awt.Font("Dialog", 0, 11));
      panelDatabase.setForeground(java.awt.Color.black);
      panelDatabase.setName("panel12");
      labelDatabase.setBackground(java.awt.Color.lightGray);
      labelDatabase.setText("Database objects");
      panelDatabase.add(labelDatabase, java.awt.BorderLayout.NORTH);
      
      listDatabase.setBackground(new java.awt.Color(255, 247, 233));
      listDatabase.setForeground(java.awt.Color.black);
      listDatabase.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(java.awt.event.ItemEvent evt) {
              listDatabaseItemStateChanged(evt);
          }
      });
      
      panelDatabase.add(listDatabase, java.awt.BorderLayout.CENTER);
      
      buttonInspect.setBackground(new java.awt.Color(204, 204, 204));
      buttonInspect.setFont(new java.awt.Font("Dialog", 0, 11));
      buttonInspect.setForeground(java.awt.Color.black);
      buttonInspect.setLabel("Show MetaData");
      buttonInspect.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              buttonInspectActionPerformed(evt);
          }
      });
      
      panelDatabase.add(buttonInspect, java.awt.BorderLayout.SOUTH);
      
      panelMain.add(panelDatabase);
      
      panelGetData.setLayout(new java.awt.BorderLayout());
      
      panelGetData.setBackground(new java.awt.Color(204, 204, 204));
      panelGetData.setFont(new java.awt.Font("Dialog", 0, 11));
      panelGetData.setForeground(java.awt.Color.black);
      panelGetData.setName("panel13");
      panelTime.setLayout(new java.awt.GridLayout(4, 2));
      
      panelTime.setBackground(new java.awt.Color(204, 204, 204));
      panelTime.setFont(new java.awt.Font("Dialog", 0, 11));
      panelTime.setForeground(java.awt.Color.black);
      panelTime.setName("panel14");
      labelStart.setBackground(java.awt.Color.lightGray);
      labelStart.setText("Start");
      panelTime.add(labelStart);
      
      labelEnd.setBackground(java.awt.Color.lightGray);
      labelEnd.setText("End (incl)");
      panelTime.add(labelEnd);
      
//      textFieldSY.setText("textField1");
      textFieldSY.setText("YYYY");
      textFieldSY.setBackground(new java.awt.Color(255, 247, 233));
      textFieldSY.setFont(new java.awt.Font("Dialog", 0, 11));
      textFieldSY.setForeground(java.awt.Color.black);
      textFieldSY.setName("textfield1");
      panelTime.add(textFieldSY);
      
//      textFieldEY.setText("textField2");
      textFieldEY.setText("YYYY");
      textFieldEY.setBackground(new java.awt.Color(255, 247, 233));
      textFieldEY.setFont(new java.awt.Font("Dialog", 0, 11));
      textFieldEY.setForeground(java.awt.Color.black);
      textFieldEY.setName("textfield2");
      panelTime.add(textFieldEY);
      
//      textFieldSM.setText("textField3");
      textFieldSM.setText("MM");
      textFieldSM.setBackground(new java.awt.Color(255, 247, 233));
      textFieldSM.setFont(new java.awt.Font("Dialog", 0, 11));
      textFieldSM.setForeground(java.awt.Color.black);
      textFieldSM.setName("textfield3");
      panelTime.add(textFieldSM);
      
//      textFieldEM.setText("textField4");
      textFieldEM.setText("MM");
      textFieldEM.setBackground(new java.awt.Color(255, 247, 233));
      textFieldEM.setFont(new java.awt.Font("Dialog", 0, 11));
      textFieldEM.setForeground(java.awt.Color.black);
      textFieldEM.setName("textfield4");
      panelTime.add(textFieldEM);
      
//      textFieldSD.setText("textField5");
      textFieldSD.setText("DD");
      textFieldSD.setBackground(new java.awt.Color(255, 247, 233));
      textFieldSD.setFont(new java.awt.Font("Dialog", 0, 11));
      textFieldSD.setForeground(java.awt.Color.black);
      textFieldSD.setName("textfield5");
      panelTime.add(textFieldSD);

//      textFieldED.setText("textField6");
      textFieldED.setText("DD");
      textFieldED.setBackground(new java.awt.Color(255, 247, 233));
      textFieldED.setFont(new java.awt.Font("Dialog", 0, 11));
      textFieldED.setForeground(java.awt.Color.black);
      textFieldED.setName("textfield6");
      textFieldED.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              textField6ActionPerformed(evt);
          }
      });

      panelTime.add(textFieldED);

      panelGetData.add(panelTime, java.awt.BorderLayout.CENTER);

      panelGetDataButtons.setBackground(new java.awt.Color(204, 204, 204));
      panelGetDataButtons.setFont(new java.awt.Font("Dialog", 0, 11));
      panelGetDataButtons.setForeground(java.awt.Color.black);
      panelGetDataButtons.setName("panel18");
/*      buttonSelectLatestData.setBackground(new java.awt.Color(204, 204, 204));
      buttonSelectLatestData.setFont(new java.awt.Font("Dialog", 0, 11));
      buttonSelectLatestData.setForeground(java.awt.Color.black);
      buttonSelectLatestData.setLabel("Latest Data");
      buttonSelectLatestData.setName("button13");
      buttonSelectLatestData.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              buttonSelectLatestDataActionPerformed(evt);
          }
      });

      panelGetDataButtons.add(buttonSelectLatestData);
*/
      buttonGetData.setLabel("Get Data");
      buttonGetData.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              buttonGetDataActionPerformed(evt);
          }
      });
      
      panelGetDataButtons.add(buttonGetData);
      
      panelGetData.add(panelGetDataButtons, java.awt.BorderLayout.SOUTH);
      
      panelMain.add(panelGetData);
      
      panelXAxis.setLayout(new java.awt.BorderLayout());
      
      panelXAxis.setBackground(new java.awt.Color(204, 204, 204));
      panelXAxis.setFont(new java.awt.Font("Dialog", 0, 11));
      panelXAxis.setForeground(java.awt.Color.black);
      panelXAxis.setName("panel15");
      labelXAxis.setBackground(java.awt.Color.lightGray);
      labelXAxis.setText("X Axis Data");
      panelXAxis.add(labelXAxis, java.awt.BorderLayout.NORTH);
      
      listXAxis.setBackground(new java.awt.Color(255, 247, 233));
      listXAxis.setForeground(java.awt.Color.black);
      panelXAxis.add(listXAxis, java.awt.BorderLayout.CENTER);
      
      panelMain.add(panelXAxis);
      
      panelYAxis.setLayout(new java.awt.BorderLayout());
      
      panelYAxis.setBackground(new java.awt.Color(204, 204, 204));
      panelYAxis.setFont(new java.awt.Font("Dialog", 0, 11));
      panelYAxis.setForeground(java.awt.Color.black);
      panelYAxis.setName("panel16");
      labelYAxis.setBackground(java.awt.Color.lightGray);
      labelYAxis.setText("Y Axis Data");
      panelYAxis.add(labelYAxis, java.awt.BorderLayout.NORTH);
      
      listYAxis.setBackground(new java.awt.Color(255, 247, 233));
      listYAxis.setForeground(java.awt.Color.black);
      listYAxis.setMultipleMode(true);
      panelYAxis.add(listYAxis, java.awt.BorderLayout.CENTER);
      
      panelMain.add(panelYAxis);
      
      add(panelMain, java.awt.BorderLayout.CENTER);
      
      panelSouth.setBackground(new java.awt.Color(204, 204, 204));
      panelSouth.setFont(new java.awt.Font("Dialog", 0, 11));
      panelSouth.setForeground(java.awt.Color.black);
      panelSouth.setName("panel17");
      buttonPlot.setLabel("Plot");
      buttonPlot.setName("buttonPlot");
      buttonPlot.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              buttonNPlotActionPerformed(evt);
          }
      });
      
      panelSouth.add(buttonPlot);
      
      buttonHelp.setBackground(new java.awt.Color(204, 204, 204));
      buttonHelp.setForeground(java.awt.Color.black);
      buttonHelp.setLabel("Help");
      buttonHelp.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              buttonHelpActionPerformed(evt);
          }
      });
      
      panelSouth.add(buttonHelp);
      
      add(panelSouth, java.awt.BorderLayout.SOUTH);
      
  }//GEN-END:initComponents

  private void buttonNPlotActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonNPlotActionPerformed
    // Add your handling code here:
    int xField = listXAxis.getSelectedIndex()-1;
    int[] yFields = listYAxis.getSelectedIndexes();
    boolean lines = true;
    boolean points = false;
    boolean xLog = false;
    boolean yLog = false;
    String xLabel = listXAxis.getSelectedItem();
    String[] yLabels = listYAxis.getSelectedItems();
    PlotFrame pf = new PlotFrame(ts,xField,yFields,lines,points,xLog,yLog);
    pf.show();
  }//GEN-LAST:event_buttonNPlotActionPerformed

  private void textField6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_textField6ActionPerformed
// Add your handling code here:
  }//GEN-LAST:event_textField6ActionPerformed

/*  private void buttonSelectLatestDataActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonSelectLatestDataActionPerformed
// Add your handling code here:
      this.setDateToLatestDate();
  }//GEN-LAST:event_buttonSelectLatestDataActionPerformed
*/
  private void setDateToLatestDate() {
      //Get the latest date.
      DatabaseRMI dbrmi = null;
      String dbObject = (String) listDatabase.getSelectedItem();
      Date d = null;
      try
      {

          dbrmi = (DatabaseRMI)
          Naming.lookup("//" + getCodeBase().getHost() +
          ":2001" + "/DatabaseRMIServer");
//          metaData = dbrmi.getMetaData(dbObject);
          d = dbrmi.getEndDate(dbObject);
      }
      catch(NotBoundException nbe)
      {
          System.err.println(nbe);
      }
      catch(MalformedURLException murle)
      {
          System.err.println(murle);
      }
      catch(RemoteException re)
      {
          System.err.println(re);
      }
//      Date d = metaData.getEndDate();

      //Insert as both start and end date.
      this.cal.setTime(d);
      String year = Integer.toString(this.cal.get(Calendar.YEAR));
      String month = Integer.toString(this.cal.get(Calendar.MONTH)+1);
      String date = Integer.toString(this.cal.get(Calendar.DATE));
      this.textFieldSY.setText(year);
      this.textFieldSM.setText(month);
      this.textFieldSD.setText(date);
      this.textFieldEY.setText(year);
      this.textFieldEM.setText(month);
      this.textFieldED.setText(date);
  }
  
  private void buttonInspectActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonInspectActionPerformed
// Add your handling code here:
    DatabaseRMI dbrmi = null;
    MetaData md = null;
    String dbObject = (String) listDatabase.getSelectedItem();
    try
    {
      dbrmi = (DatabaseRMI)
        Naming.lookup("//" + getCodeBase().getHost() +
        ":2001" + "/DatabaseRMIServer");
      md = dbrmi.getMetaData(dbObject);
//      metaData = dbrmi.getMetaData(dbObject);
      (new MetaDataDialog(getAppletFrame(),md)).setVisible(true);
//      dbrmi.showMetaData(getAppletFrame(),dbObject);
//      metaData = dbrmi.getMetaData(dbObject);
    }
    catch(NotBoundException nbe)
    {
      System.err.println(nbe);
    }
    catch(MalformedURLException murle)
    {
      System.err.println(murle);
    }
    catch(RemoteException re)
    {
      System.err.println(re);
    }
//    System.out.println(metaData.getName());
//    (new MetaDataDialog(getAppletFrame(),dbObject)).show();
  }//GEN-LAST:event_buttonInspectActionPerformed

  private void buttonHelpActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonHelpActionPerformed
// Add your handling code here:
    AppletContext ac = getAppletContext();
    URL url = getDocumentBase();
    try
    {
      URL urlDoc = new URL(url,"DataPlotterAppletAWTHelp.html");
      ac.showDocument(urlDoc,"Data Plotter Applet Help");
    }
    catch (MalformedURLException murle)
    {
      System.err.println(murle);
    }
  }//GEN-LAST:event_buttonHelpActionPerformed

  private void listDatabaseItemStateChanged (java.awt.event.ItemEvent evt) {//GEN-FIRST:event_listDatabaseItemStateChanged
    // Add your handling code here:
    String s = listDatabase.getSelectedItem();
    this.setDateToLatestDate();
    // clear the possible fields in the other lists
    this.listXAxis.clear();
    this.listYAxis.clear();    
  }//GEN-LAST:event_listDatabaseItemStateChanged


  private void buttonPlotActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button1ActionPerformed
    // Add your handling code here:
    int xField = listXAxis.getSelectedIndex()-1;
    int[] yFields = listYAxis.getSelectedIndexes();
    boolean lines = true;
    boolean points = false;
    boolean xLog = false;
    boolean yLog = false;
    String xLabel = listXAxis.getSelectedItem();
    String[] yLabels = listYAxis.getSelectedItems();
    PlotFrame pf = new PlotFrame(ts,xField,yFields,lines,points,xLog,yLog);
    pf.show();
  }//GEN-LAST:event_button1ActionPerformed

  private java.awt.Frame getAppletFrame()
  {
    java.awt.Component curr = this;
    while (!(curr instanceof java.awt.Frame))
    curr = curr.getParent();
    return (java.awt.Frame) curr;
  }

  private void buttonGetDataActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonGetDataActionPerformed
      try {
          this.verifyInputFields();
          dg = new DataGet();
          dg.start();
          listXAxis.removeAll();
          listYAxis.removeAll();
      }
      catch (NumberFormatException e) {
          new ErrorDialog(this.getAppletFrame(),"Incorrect date format specified.");
      }
  }//GEN-LAST:event_buttonGetDataActionPerformed

  private Date getStartDate() {
      this.setDate(this.textFieldSY,this.textFieldSM,this.textFieldSD);
      return this.cal.getTime();
  }
  
  private Date getEndDate() {
      this.setDate(this.textFieldEY,this.textFieldEM,this.textFieldED);
      this.cal.set(Calendar.HOUR_OF_DAY,23);
      this.cal.set(Calendar.MINUTE,59);
      this.cal.set(Calendar.SECOND,59);
      return this.cal.getTime();
  }
  
  private void setDate(java.awt.TextField y, java.awt.TextField m, java.awt.TextField d) {
      this.cal.clear();
      int year = Integer.parseInt(y.getText());
      int month = Integer.parseInt(m.getText())-1;
      int date = Integer.parseInt(d.getText());
      this.cal.set(Calendar.YEAR,year);
      this.cal.set(Calendar.MONTH,month);
      this.cal.set(Calendar.DATE,date);
  }
  
  private void jButtonGetDataActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonGetDataActionPerformed
    // Add your handling code here:

  }//GEN-LAST:event_jButtonGetDataActionPerformed

  private void jButtonPlotActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonPlotActionPerformed
    // Add your handling code here:
  }//GEN-LAST:event_jButtonPlotActionPerformed


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private java.awt.Label labelTitle;
  private java.awt.Panel panelMain;
  private java.awt.Panel panelDatabase;
  private java.awt.Label labelDatabase;
  private java.awt.List listDatabase;
  private java.awt.Button buttonInspect;
  private java.awt.Panel panelGetData;
  private java.awt.Panel panelTime;
  private java.awt.Label labelStart;
  private java.awt.Label labelEnd;
  private java.awt.TextField textFieldSY;
  private java.awt.TextField textFieldEY;
  private java.awt.TextField textFieldSM;
  private java.awt.TextField textFieldEM;
  private java.awt.TextField textFieldSD;
  private java.awt.TextField textFieldED;
  private java.awt.Panel panelGetDataButtons;
//  private java.awt.Button buttonSelectLatestData;
  private java.awt.Button buttonGetData;
  private java.awt.Panel panelXAxis;
  private java.awt.Label labelXAxis;
  private java.awt.List listXAxis;
  private java.awt.Panel panelYAxis;
  private java.awt.Label labelYAxis;
  private java.awt.List listYAxis;
  private java.awt.Panel panelSouth;
  private java.awt.Button buttonPlot;
  private java.awt.Button buttonHelp;
  // End of variables declaration//GEN-END:variables


  public class DataGet extends Thread {
      DatabaseRMI dbrmi = null;
      Date sd,ed;
      String dbObject;
      java.awt.Frame frame = getAppletFrame();
      
      public DataGet() {
          sd = getStartDate();
          ed = getEndDate();
          dbObject = (String) listDatabase.getSelectedItem();
      }
      
      public final void run() {
          
          ts = null;
          DataLoadingDialog dld = new DataLoadingDialog(frame,false,dg);
          dld.show();
          try {
              //Limit the data amount to be loaded for ACE data.
              if (dbObject.startsWith("ACEmagDB") | dbObject.startsWith("ACEsweDB")) {
                  long st = sd.getTime();
                  long et = ed.getTime();
                  if (((double) (et-st))/1000/3600/24>3) {
                      st = et - ((long) 1000*3600*24*3);
                      sd = new Date(st);
                  }
              }
              dbrmi = (DatabaseRMI)
              Naming.lookup("//" + getCodeBase().getHost() +
              ":2001" + "/DatabaseRMIServer");
              ts = dbrmi.getTimeSeries(dbObject,sd,ed,true);
//              ts = dbrmi.getTimeSeries(dbObject,sd,ed,frame);
//              metaData = dbrmi.getMetaData(dbObject);
              //Initialize the data field list from the meta data.
//              fn = metaData.getFieldNames();
//              fn = dbrmi.getFieldNames(dbObject);
              fn = dbrmi.getListNames(dbObject);

              listXAxis.add("Time");
              for (int i=0;i<fn.length;i++) {
                  listXAxis.add(fn[i]);
                  listYAxis.add(fn[i]);
              }
              dld.dispose();
          }
          catch(NotBoundException nbe) {
              dld.dispose();
              System.err.println(nbe);
              new ErrorDialog(getAppletFrame(),nbe.getMessage());
          }
          catch(MalformedURLException murle) {
              dld.dispose();
              System.err.println(murle);
              new ErrorDialog(getAppletFrame(),murle.getMessage());
          }
          catch(RemoteException re) {
              dld.dispose();
              System.err.println(re);
              new ErrorDialog(getAppletFrame(),re.getMessage());
          }
          catch(IOException ioe) {
              System.err.println(ioe);
              dld.dispose();
              new ErrorDialog(getAppletFrame(),ioe.getMessage());
          }
          catch(saaps.dbt.NoDataFoundException ndfe) {
              dld.dispose();
              System.err.println(ndfe);
              new ErrorDialog(getAppletFrame(),ndfe.getMessage());
          }
          catch (Exception e) {
              dld.dispose();
              System.out.println(e);
          }
      }
  }
}
