/*
 * DataPlotterAxisDialog.java
 *
 * Created on August 8, 2000, 9:35 AM
 */
 
package saaps.saam;

/** 
* A dialog box to change the x- and y-axes ranges.
*
* @author  Peter Wintoft
* @version 1.0 2000-08-08
* @see  DataPlotterFrame
*/
public class DataPlotterAxisDialog extends java.awt.Dialog {

  private double[] xRange = new double[2];
  private double[] yRange = new double[2];
  
  /** Creates new form DataPlotterAxisDialog */
  public DataPlotterAxisDialog(java.awt.Frame parent,boolean modal) {
    super (parent, modal);
    initComponents ();
    pack ();
  }

  /**
  * Creates a new dialog and sets the text field values from the argument list.
  *
  * @param  parent The parent frame.
  * @param  modal If true the dialog will be modal.
  * @param  xr  The minimum (<code>xr[0]</code>) and maximum (<code>xr[1]</code>) x-axis values.
  * @param  yr  The minimum (<code>yr[0]</code>) and maximum (<code>yr[1]</code>) y-axis values.
  */
  public DataPlotterAxisDialog(java.awt.Frame parent,boolean modal,double[] xr, double[] yr)
  {
    super(parent,modal);
    initComponents();
    xRange[0] = xr[0];
    xRange[1] = xr[1];
    yRange[0] = yr[0];
    yRange[1] = yr[1];
    textFieldXMin.setText(String.valueOf(xRange[0]));
    textFieldXMax.setText(String.valueOf(xRange[1]));
    textFieldYMin.setText(String.valueOf(yRange[0]));
    textFieldYMax.setText(String.valueOf(yRange[1]));
    pack();
  }
  /** This method is called from within the init() method to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents() {//GEN-BEGIN:initComponents
      labelXMin = new java.awt.Label();
      textFieldXMin = new java.awt.TextField();
      labelXMax = new java.awt.Label();
      textFieldXMax = new java.awt.TextField();
      labelYMin = new java.awt.Label();
      textFieldYMin = new java.awt.TextField();
      labelYMax = new java.awt.Label();
      textFieldYMax = new java.awt.TextField();
      buttonCancel = new java.awt.Button();
      buttonOK = new java.awt.Button();
      
      setLayout(new java.awt.GridLayout(5, 2));
      
      addWindowListener(new java.awt.event.WindowAdapter() {
          public void windowClosing(java.awt.event.WindowEvent evt) {
              closeDialog(evt);
          }
      });
      
      labelXMin.setBackground(new java.awt.Color(204, 204, 204));
      labelXMin.setFont(new java.awt.Font("Dialog", 0, 11));
      labelXMin.setForeground(java.awt.Color.black);
      labelXMin.setName("label2");
      labelXMin.setText("X min");
      add(labelXMin);
      
      textFieldXMin.setText("textField1");
      textFieldXMin.setBackground(new java.awt.Color(255, 247, 233));
      textFieldXMin.setFont(new java.awt.Font("Dialog", 0, 11));
      textFieldXMin.setForeground(java.awt.Color.black);
      textFieldXMin.setName("textfield2");
      add(textFieldXMin);
      
      labelXMax.setBackground(new java.awt.Color(204, 204, 204));
      labelXMax.setFont(new java.awt.Font("Dialog", 0, 11));
      labelXMax.setForeground(java.awt.Color.black);
      labelXMax.setName("label4");
      labelXMax.setText("X max");
      add(labelXMax);
      
      textFieldXMax.setText("textField2");
      textFieldXMax.setBackground(new java.awt.Color(255, 247, 233));
      textFieldXMax.setFont(new java.awt.Font("Dialog", 0, 11));
      textFieldXMax.setForeground(java.awt.Color.black);
      textFieldXMax.setName("textfield3");
      add(textFieldXMax);
      
      labelYMin.setBackground(new java.awt.Color(204, 204, 204));
      labelYMin.setFont(new java.awt.Font("Dialog", 0, 11));
      labelYMin.setForeground(java.awt.Color.black);
      labelYMin.setName("label5");
      labelYMin.setText("Y min");
      add(labelYMin);
      
      textFieldYMin.setText("textField3");
      textFieldYMin.setBackground(new java.awt.Color(255, 247, 233));
      textFieldYMin.setFont(new java.awt.Font("Dialog", 0, 11));
      textFieldYMin.setForeground(java.awt.Color.black);
      textFieldYMin.setName("textfield4");
      add(textFieldYMin);
      
      labelYMax.setBackground(new java.awt.Color(204, 204, 204));
      labelYMax.setFont(new java.awt.Font("Dialog", 0, 11));
      labelYMax.setForeground(java.awt.Color.black);
      labelYMax.setName("label6");
      labelYMax.setText("Y max");
      add(labelYMax);
      
      textFieldYMax.setText("textField4");
      textFieldYMax.setBackground(new java.awt.Color(255, 247, 233));
      textFieldYMax.setFont(new java.awt.Font("Dialog", 0, 11));
      textFieldYMax.setForeground(java.awt.Color.black);
      textFieldYMax.setName("textfield5");
      add(textFieldYMax);
      
      buttonCancel.setBackground(new java.awt.Color(204, 204, 204));
      buttonCancel.setFont(new java.awt.Font("Dialog", 0, 11));
      buttonCancel.setForeground(java.awt.Color.black);
      buttonCancel.setLabel("Cancel");
      buttonCancel.setName("button3");
      buttonCancel.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              buttonCancelActionPerformed(evt);
          }
      });
      
      add(buttonCancel);
      
      buttonOK.setBackground(new java.awt.Color(204, 204, 204));
      buttonOK.setFont(new java.awt.Font("Dialog", 0, 11));
      buttonOK.setForeground(java.awt.Color.black);
      buttonOK.setLabel("OK");
      buttonOK.setName("button4");
      buttonOK.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              buttonOKActionPerformed(evt);
          }
      });
      
      add(buttonOK);
      
  }//GEN-END:initComponents

  private void buttonOKActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonOKActionPerformed
// Add your handling code here:
    try {
      xRange[0] = (new Double(textFieldXMin.getText())).doubleValue();
      xRange[1] = (new Double(textFieldXMax.getText())).doubleValue();
      yRange[0] = (new Double(textFieldYMin.getText())).doubleValue();
      yRange[1] = (new Double(textFieldYMax.getText())).doubleValue();
//      xRange[0] = Double.parseDouble(textFieldXMin.getText());
//      xRange[1] = Double.parseDouble(textFieldXMax.getText());
//      yRange[0] = Double.parseDouble(textFieldYMin.getText());
//      yRange[1] = Double.parseDouble(textFieldYMax.getText());
    }
    catch(NumberFormatException nfe)
    {
        new ErrorDialog(this,"Please use double values.");
        return;
    }
//    System.out.println("OK! Now it will be disposed");
    setVisible(false);
    dispose();
  }//GEN-LAST:event_buttonOKActionPerformed

  private void buttonCancelActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCancelActionPerformed
// Add your handling code here:
    setVisible(false);
    dispose();
  }//GEN-LAST:event_buttonCancelActionPerformed

  /** Closes the dialog */
  private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
    setVisible (false);
    dispose ();
  }//GEN-LAST:event_closeDialog

  /**
  * Get the x-axis range values.
  *
  * @return The x-axis range in a 2-element double array.
  */
  public double[] getXRange()
  {
    return xRange;
  }
  
  /**
  * Get the y-axis range values.
  *
  * @return The y-axis range in a 2-element double array.
  */
  public double[] getYRange()
  {
    return yRange;
  }
  
  /**
  * A main method to test the class.
  *
  * @param args the command line arguments
  */
  public static void main (String args[]) {
//    new DataPlotterAxisDialog (new java.awt.Frame (), true).show ();
    double[] xr = {1.0,2.0};
    double[] yr = {3.0,4.0};
    new DataPlotterAxisDialog(new java.awt.Frame (), true, xr, yr).show();
  }


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private java.awt.Label labelXMin;
  private java.awt.TextField textFieldXMin;
  private java.awt.Label labelXMax;
  private java.awt.TextField textFieldXMax;
  private java.awt.Label labelYMin;
  private java.awt.TextField textFieldYMin;
  private java.awt.Label labelYMax;
  private java.awt.TextField textFieldYMax;
  private java.awt.Button buttonCancel;
  private java.awt.Button buttonOK;
  // End of variables declaration//GEN-END:variables

}