/*
 * ElFluenceLevelApp.java
 *
 * Created on June 25, 2001, 1:28 PM
 */

package saaps.saam;

import java.io.IOException;

import saaps.math.ProbCond;
import saaps.util.EventList;
import saaps.util.EventListDialog;
import saaps.util.EventRandomDialog;
import saaps.util.AppHelp;
import saaps.util.TextFieldException;

/**
 *
 * @author  root
 * @version 
 */
public class ElFluenceLevelApp extends java.awt.Frame {

    //The events.
    private EventList eventList = null;
    
    //The non-events.
    private EventList nonEventList = null;
    
    private AppHelp help = null;
    
    /** Creates new form ElFluenceLevelApp */
    public ElFluenceLevelApp() {
        initComponents ();
        pack ();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        panelNorth = new java.awt.Panel();
        buttonEditEvents = new java.awt.Button();
        buttonEditNonEvents = new java.awt.Button();
        buttonRandomNonEvents = new java.awt.Button();
        buttonOptimize = new java.awt.Button();
        buttonRun = new java.awt.Button();
        panelSouth = new java.awt.Panel();
        buttonHelp = new java.awt.Button();
        buttonQuit = new java.awt.Button();
        panelCentre = new java.awt.Panel();
        panel06MeV = new java.awt.Panel();
        label06Title = new java.awt.Label();
        label06TimeDelay = new java.awt.Label();
        text06FieldTimeDelay = new java.awt.TextField();
        label06TimeDelayUnit = new java.awt.Label();
        label06Level = new java.awt.Label();
        textField06Level = new java.awt.TextField();
        label06LevelUnit = new java.awt.Label();
        textArea06Result = new java.awt.TextArea();
        panel20MeV = new java.awt.Panel();
        label20Title = new java.awt.Label();
        label20TimeDelay = new java.awt.Label();
        text20FieldTimeDelay = new java.awt.TextField();
        label20TimeDelayUnit = new java.awt.Label();
        label20Level = new java.awt.Label();
        textField20Level = new java.awt.TextField();
        label20LevelUnit = new java.awt.Label();
        textArea20Result = new java.awt.TextArea();
        
        setBackground(new java.awt.Color(204, 204, 255));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        panelNorth.setFont(new java.awt.Font("Dialog", 0, 11));
        panelNorth.setName("panel5");
        panelNorth.setBackground(new java.awt.Color(204, 204, 204));
        panelNorth.setForeground(java.awt.Color.black);
        buttonEditEvents.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonEditEvents.setLabel("Edit Events ...");
        buttonEditEvents.setBackground(new java.awt.Color(204, 204, 204));
        buttonEditEvents.setForeground(java.awt.Color.black);
        buttonEditEvents.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonEditEventsActionPerformed(evt);
            }
        });
        
        panelNorth.add(buttonEditEvents);
        
        buttonEditNonEvents.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonEditNonEvents.setLabel("Edit Non-Events ...");
        buttonEditNonEvents.setBackground(new java.awt.Color(204, 204, 204));
        buttonEditNonEvents.setForeground(java.awt.Color.black);
        buttonEditNonEvents.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonEditNonEventsActionPerformed(evt);
            }
        });
        
        panelNorth.add(buttonEditNonEvents);
        
        buttonRandomNonEvents.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonRandomNonEvents.setLabel("Random Non-Events ...");
        buttonRandomNonEvents.setName("button36");
        buttonRandomNonEvents.setBackground(new java.awt.Color(204, 204, 204));
        buttonRandomNonEvents.setForeground(java.awt.Color.black);
        buttonRandomNonEvents.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonRandomNonEventsActionPerformed(evt);
            }
        });
        
        panelNorth.add(buttonRandomNonEvents);
        
        buttonOptimize.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonOptimize.setLabel("Optimize");
        buttonOptimize.setBackground(new java.awt.Color(204, 204, 204));
        buttonOptimize.setForeground(java.awt.Color.black);
        buttonOptimize.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonOptimizeActionPerformed(evt);
            }
        });
        
        panelNorth.add(buttonOptimize);
        
        buttonRun.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonRun.setLabel("Run");
        buttonRun.setBackground(new java.awt.Color(204, 204, 204));
        buttonRun.setForeground(java.awt.Color.black);
        buttonRun.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonRunActionPerformed(evt);
            }
        });
        
        panelNorth.add(buttonRun);
        
        add(panelNorth, java.awt.BorderLayout.NORTH);
        
        panelSouth.setFont(new java.awt.Font("Dialog", 0, 11));
        panelSouth.setName("panel7");
        panelSouth.setBackground(new java.awt.Color(204, 204, 204));
        panelSouth.setForeground(java.awt.Color.black);
        buttonHelp.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonHelp.setLabel("Help");
        buttonHelp.setName("button7");
        buttonHelp.setBackground(new java.awt.Color(204, 204, 204));
        buttonHelp.setForeground(java.awt.Color.black);
        buttonHelp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHelpActionPerformed(evt);
            }
        });
        
        panelSouth.add(buttonHelp);
        
        buttonQuit.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonQuit.setLabel("Quit");
        buttonQuit.setName("button8");
        buttonQuit.setBackground(new java.awt.Color(204, 204, 204));
        buttonQuit.setForeground(java.awt.Color.black);
        buttonQuit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonQuitActionPerformed(evt);
            }
        });
        
        panelSouth.add(buttonQuit);
        
        add(panelSouth, java.awt.BorderLayout.SOUTH);
        
        panelCentre.setLayout(new java.awt.GridLayout(1, 2));
        
        panelCentre.setFont(new java.awt.Font("Dialog", 0, 11));
        panelCentre.setName("panel9");
        panelCentre.setBackground(new java.awt.Color(204, 204, 204));
        panelCentre.setForeground(java.awt.Color.black);
        panel06MeV.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        panel06MeV.setFont(new java.awt.Font("Dialog", 0, 11));
        panel06MeV.setBackground(new java.awt.Color(255, 255, 102));
        panel06MeV.setForeground(java.awt.Color.black);
        label06Title.setFont(new java.awt.Font("Dialog", 1, 14));
        label06Title.setBackground(new java.awt.Color(255, 255, 102));
        label06Title.setForeground(java.awt.Color.black);
//        label06Title.setText(">0.6 MeV daily electron fluence");
label06Title.setText(">0.6 MeV daily electron fluence FAKE DATA TEST");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.gridwidth = 6;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        panel06MeV.add(label06Title, gridBagConstraints1);
        
        label06TimeDelay.setFont(new java.awt.Font("Dialog", 0, 11));
        label06TimeDelay.setBackground(new java.awt.Color(255, 255, 102));
        label06TimeDelay.setForeground(java.awt.Color.black);
        label06TimeDelay.setText("Time delay");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(15, 10, 0, 0);
        panel06MeV.add(label06TimeDelay, gridBagConstraints1);
        
        text06FieldTimeDelay.setText("0");
        text06FieldTimeDelay.setBackground(new java.awt.Color(255, 247, 233));
        text06FieldTimeDelay.setFont(new java.awt.Font("Dialog", 0, 11));
        text06FieldTimeDelay.setColumns(3);
        text06FieldTimeDelay.setForeground(java.awt.Color.black);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.gridheight = 3;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(15, 3, 0, 0);
        panel06MeV.add(text06FieldTimeDelay, gridBagConstraints1);
        
        label06TimeDelayUnit.setFont(new java.awt.Font("Dialog", 0, 11));
        label06TimeDelayUnit.setBackground(new java.awt.Color(255, 255, 102));
        label06TimeDelayUnit.setForeground(java.awt.Color.black);
        label06TimeDelayUnit.setText("(days)");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 3;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(15, 2, 0, 0);
        panel06MeV.add(label06TimeDelayUnit, gridBagConstraints1);
        
        label06Level.setFont(new java.awt.Font("Dialog", 0, 11));
        label06Level.setBackground(new java.awt.Color(255, 255, 102));
        label06Level.setForeground(java.awt.Color.black);
        label06Level.setText("Threshold level");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(19, 10, 0, 0);
        panel06MeV.add(label06Level, gridBagConstraints1);
        
        textField06Level.setText("0");
        textField06Level.setBackground(new java.awt.Color(255, 247, 233));
        textField06Level.setFont(new java.awt.Font("Dialog", 0, 11));
        textField06Level.setColumns(8);
        textField06Level.setForeground(java.awt.Color.black);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.gridheight = 3;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(19, 2, 0, 0);
        panel06MeV.add(textField06Level, gridBagConstraints1);
        
        label06LevelUnit.setFont(new java.awt.Font("Dialog", 0, 11));
        label06LevelUnit.setBackground(new java.awt.Color(255, 255, 102));
        label06LevelUnit.setForeground(java.awt.Color.black);
        label06LevelUnit.setText("(cm^-2 sr^-1)");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 4;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.gridwidth = 3;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(19, 0, 0, 0);
        panel06MeV.add(label06LevelUnit, gridBagConstraints1);
        
        textArea06Result.setBackground(new java.awt.Color(255, 247, 233));
        textArea06Result.setFont(new java.awt.Font("Dialog", 0, 11));
        textArea06Result.setColumns(20);
        textArea06Result.setForeground(java.awt.Color.black);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 7;
        gridBagConstraints1.gridwidth = 7;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(19, 10, 0, 0);
        panel06MeV.add(textArea06Result, gridBagConstraints1);
        
        panelCentre.add(panel06MeV);
        
        panel20MeV.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        panel20MeV.setFont(new java.awt.Font("Dialog", 0, 11));
        panel20MeV.setBackground(java.awt.Color.red);
        panel20MeV.setForeground(java.awt.Color.black);
        label20Title.setFont(new java.awt.Font("Dialog", 1, 14));
        label20Title.setBackground(java.awt.Color.red);
        label20Title.setForeground(java.awt.Color.black);
//        label20Title.setText(">2 MeV daily electron fluence");
label20Title.setText(">2 MeV daily electron fluence FAKE DATA TEST");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 0;
        gridBagConstraints2.gridwidth = 6;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        panel20MeV.add(label20Title, gridBagConstraints2);
        
        label20TimeDelay.setFont(new java.awt.Font("Dialog", 0, 11));
        label20TimeDelay.setBackground(java.awt.Color.red);
        label20TimeDelay.setForeground(java.awt.Color.black);
        label20TimeDelay.setText("Time delay");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(15, 10, 0, 0);
        panel20MeV.add(label20TimeDelay, gridBagConstraints2);
        
        text20FieldTimeDelay.setText("0");
        text20FieldTimeDelay.setBackground(new java.awt.Color(255, 247, 233));
        text20FieldTimeDelay.setFont(new java.awt.Font("Dialog", 0, 11));
        text20FieldTimeDelay.setColumns(3);
        text20FieldTimeDelay.setForeground(java.awt.Color.black);
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 1;
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.gridwidth = 2;
        gridBagConstraints2.gridheight = 3;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(15, 3, 0, 0);
        panel20MeV.add(text20FieldTimeDelay, gridBagConstraints2);
        
        label20TimeDelayUnit.setFont(new java.awt.Font("Dialog", 0, 11));
        label20TimeDelayUnit.setBackground(java.awt.Color.red);
        label20TimeDelayUnit.setForeground(java.awt.Color.black);
        label20TimeDelayUnit.setText("(days)");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 3;
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.gridwidth = 2;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(15, 2, 0, 0);
        panel20MeV.add(label20TimeDelayUnit, gridBagConstraints2);
        
        label20Level.setFont(new java.awt.Font("Dialog", 0, 11));
        label20Level.setBackground(java.awt.Color.red);
        label20Level.setForeground(java.awt.Color.black);
        label20Level.setText("Threshold level");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 4;
        gridBagConstraints2.gridwidth = 2;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(19, 10, 0, 0);
        panel20MeV.add(label20Level, gridBagConstraints2);
        
        textField20Level.setText("0");
        textField20Level.setBackground(new java.awt.Color(255, 247, 233));
        textField20Level.setFont(new java.awt.Font("Dialog", 0, 11));
        textField20Level.setColumns(8);
        textField20Level.setForeground(java.awt.Color.black);
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 2;
        gridBagConstraints2.gridy = 4;
        gridBagConstraints2.gridwidth = 2;
        gridBagConstraints2.gridheight = 3;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(19, 2, 0, 0);
        panel20MeV.add(textField20Level, gridBagConstraints2);
        
        label20LevelUnit.setFont(new java.awt.Font("Dialog", 0, 11));
        label20LevelUnit.setBackground(java.awt.Color.red);
        label20LevelUnit.setForeground(java.awt.Color.black);
        label20LevelUnit.setText("(cm^-2 sr^-1)");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 4;
        gridBagConstraints2.gridy = 4;
        gridBagConstraints2.gridwidth = 3;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(19, 0, 0, 0);
        panel20MeV.add(label20LevelUnit, gridBagConstraints2);
        
        textArea20Result.setBackground(new java.awt.Color(255, 247, 233));
        textArea20Result.setFont(new java.awt.Font("Dialog", 0, 11));
        textArea20Result.setColumns(20);
        textArea20Result.setForeground(java.awt.Color.black);
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 7;
        gridBagConstraints2.gridwidth = 7;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(19, 10, 0, 0);
        panel20MeV.add(textArea20Result, gridBagConstraints2);
        
        panelCentre.add(panel20MeV);
        
        add(panelCentre, java.awt.BorderLayout.CENTER);
        
    }//GEN-END:initComponents

  private void buttonRandomNonEventsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonRandomNonEventsActionPerformed
// Add your handling code here:
      if (this.eventList == null) {
          new ErrorDialog(this,"      Please edit the event list first!    ");
      }
      else {
          EventRandomDialog erd = new EventRandomDialog(this,this.eventList);
          erd.setVisible(true);
          if (erd.isOK() && (erd.getEventList()).getNumOfEvents()>0) {
               this.nonEventList = erd.getEventList();
          }
      }
  }//GEN-LAST:event_buttonRandomNonEventsActionPerformed

    private void buttonHelpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonHelpActionPerformed
      System.out.println("Launching help frame ...");
      if(help != null) {
          help.setVisible(true);
      }
      else {
        /* Get a Class object from this object and then the Name of the class to use as help fi */
          help = AppHelp.getAppHelp(this.getClass().getName());
      }
    }//GEN-LAST:event_buttonHelpActionPerformed

  private void buttonRunActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonRunActionPerformed
      if (this.eventList == null || this.nonEventList == null) {
          new ErrorDialog(this,"      Please edit the event lists first!    ");
      }
      else {
          try {
              verifyInputFields();
              ElFluenceLevel efl = new ElFluenceLevel();
              efl.setEventList(this.eventList);
              efl.setNonEventList(this.nonEventList);
              int[] td = new int[2];
              td[0] = this.parseInteger(this.text06FieldTimeDelay.getText());
              td[1] = this.parseInteger(this.text20FieldTimeDelay.getText());
              efl.setTimeDelay(td);
              double[] lev = new double[2];
              lev[0] = this.parseDouble(this.textField06Level.getText());
              lev[1] = this.parseDouble(this.textField20Level.getText());
              efl.setLevel(lev);
              efl.calcStat();
              this.textArea06Result.setText(efl.get06RunText());
              this.textArea20Result.setText(efl.get20RunText());
          }
          catch (IOException e) {
              System.out.println("Data access error. Please verify event lists!\n\n"+e);
              new ErrorDialog(this,"      Data access error. Please verify event lists!    \n\n"+e);
          }
          catch (TextFieldException e) {
              System.out.println(e.toString());
              new ErrorDialog(this,"\n\n   "+e.getMessage());
          }
      }
  }//GEN-LAST:event_buttonRunActionPerformed

  /**
   * Checks the input fields for correct input.
   */
  private void verifyInputFields() throws TextFieldException {
      try {
          Integer.valueOf(this.text06FieldTimeDelay.getText());
          Integer.valueOf(this.text20FieldTimeDelay.getText());
      }
      catch (NumberFormatException e) {
          throw new TextFieldException("Please use integer for time delay field.\n");
      }
      try {
          Double.valueOf(this.textField06Level.getText());
          Double.valueOf(this.textField20Level.getText());
      }
      catch (NumberFormatException e) {
          throw new TextFieldException("Please use double for level field.\n");
      }
  }
  
  private int parseInteger(String x) {
      int y = 0;
      try {
          y = Integer.parseInt(x);
      }
      catch (NumberFormatException e) {
          System.err.println(e);
      }
      return y;
  }
  
  private double parseDouble(String x) {
      double y = 1e4;
      try {
          y = Double.parseDouble(x);
      }
      catch (NumberFormatException e) {
          System.err.println(e);
      }
      return y;
  }
  
  private void buttonOptimizeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonOptimizeActionPerformed
      if (this.eventList == null || this.nonEventList == null) {
          new ErrorDialog(this,"      Please edit the event lists first!    ");
      }
      else {
          java.awt.Dialog dialog = new java.awt.Dialog(this, "Optimizing ...", false);
          dialog.add(new java.awt.Label("Optimizing ...                                        "));
          dialog.pack();
          dialog.setVisible(true);
      
          try {
              verifyInputFields();
              ElFluenceLevel efl = new ElFluenceLevel();
              efl.setEventList(this.eventList);
              efl.setNonEventList(this.nonEventList);
              efl.optimize();
          
              int[] td = efl.getTimeDelay();
              double[] level = efl.getLevel();
          
              dialog.dispose();
          
              this.text06FieldTimeDelay.setText(Integer.toString(td[0]));
              this.text20FieldTimeDelay.setText(Integer.toString(td[1]));
              this.textField06Level.setText(Double.toString(level[0]));
              this.textField20Level.setText(Double.toString(level[1]));
          
              ProbCond[] pc = efl.getProbCond();
              double[] pcxy = new double[pc.length];
              double[] pcyx = new double[pc.length];
              for (int i=0;i<pc.length;i++) {
                  pcxy[i] = ( pc[i].xy[0][0] + pc[i].xy[0][0] ) / 2.0;
                  pcyx[i] = ( pc[i].yx[0][0] + pc[i].yx[0][0] ) / 2.0;
              }
          
          //      this.textArea06Result.setText("The time delay was varied from -5 to 5 days.");
          //      this.textArea06Result.appendText("\nThe 0.6 MeV electron fluence level was varied from 10^7 to 10^11 cm^-2 sr^-1.");
          //      this.textArea06Result.appendText("\nThe optimal time delay and threshold level gives the highest probability that the prediction is correct.");
          //      this.textArea06Result.appendText("\n\nThe optimal time delay = " + td[0] + " days.");
          //      this.textArea06Result.appendText("\nThe optimal threshold level = " + level[0] + " cm^-2 sr^-1.");
          //      this.textArea06Result.appendText("\n\nThe probability that the prediction is observed = " + pcyx[0]);
          //      this.textArea06Result.appendText("\nThe probability that the observation is predicted = " + pcyx[0]);
              this.textArea06Result.setText(efl.get06OptText());
          
          //      this.textArea20Result.setText("The time delay was varied from -5 to 5 days.");
          //      this.textArea20Result.appendText("\nThe 2.0 MeV electron fluence level was varied from 10^7 to 10^11 cm^-2 sr^-1.");
          //      this.textArea20Result.appendText("\nThe optimal time delay and threshold level gives the highest probability that the prediction is correct.");
          //      this.textArea20Result.appendText("\n\nThe optimal time delay = " + td[0] + " days.");
          //      this.textArea20Result.appendText("\nThe optimal threshold level = " + level[0] + " cm^-2 sr^-1.");
          //      this.textArea20Result.appendText("\n\nThe probability that the prediction is observed = " + pcyx[0]);
          //      this.textArea20Result.appendText("\nThe probability that the observation is predicted = " + pcyx[0]);
              this.textArea20Result.setText(efl.get20OptText());
/*      ElFluenceLevel efl = new ElFluenceLevel(this.eventList,this.nonEventList);
      efl.optimize(ElFluenceLevel.LINCORR);
      this.text06FieldTimeDelay.setText(efl.get06TimeDelay());
      this.textField06Level.setText(efl.get06Level());
      this.textArea06Result.setText(efl.get06Stat());*/
          }
          catch (IOException e) {
              dialog.dispose();
              System.out.println("Data access error. Please verify event lists!\n\n"+e);
              new ErrorDialog(this,"      Data access error. Please verify event lists!    \n\n"+e);
          }
          catch (TextFieldException e) {
              dialog.dispose();
              System.out.println(e.toString());
              new ErrorDialog(this,"\n\n   "+e.getMessage());
          }
      }
  }//GEN-LAST:event_buttonOptimizeActionPerformed

/*  private String resultText(ElFluenceLevel efl) {
      StringBuffer sb = new StringBuffer();
      sb.append("Linear correlation = " + efl.getLinearCorrelation());
      sb.append("\nP(Observed | Predicted) = " + efl.getPXY());
      sb.append("\nP(Predicted | Observed) = " + efl.getPYX());
      return sb.toString();
  }*/
  
  private void buttonQuitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonQuitActionPerformed
      if(help != null)
          help.dispose();

      this.dispose();
  }//GEN-LAST:event_buttonQuitActionPerformed

  private void buttonEditNonEventsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonEditNonEventsActionPerformed
// Add your handling code here:
      EventListDialog eld = new EventListDialog(this,"Non-Event list",this.nonEventList);
      eld.setVisible(true);
      if (eld.isOK()) {
          this.nonEventList = eld.getEventList();
      }
  }//GEN-LAST:event_buttonEditNonEventsActionPerformed

  private void buttonEditEventsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonEditEventsActionPerformed
// Add your handling code here:
      EventListDialog eld = new EventListDialog(this,"Event list",this.eventList);
      eld.setVisible(true);
      if (eld.isOK()) {
          this.eventList = eld.getEventList();
      }
  }//GEN-LAST:event_buttonEditEventsActionPerformed

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit (0);
    }//GEN-LAST:event_exitForm

    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
        new ElFluenceLevelApp ().show ();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.Panel panelNorth;
    private java.awt.Button buttonEditEvents;
    private java.awt.Button buttonEditNonEvents;
    private java.awt.Button buttonRandomNonEvents;
    private java.awt.Button buttonOptimize;
    private java.awt.Button buttonRun;
    private java.awt.Panel panelSouth;
    private java.awt.Button buttonHelp;
    private java.awt.Button buttonQuit;
    private java.awt.Panel panelCentre;
    private java.awt.Panel panel06MeV;
    private java.awt.Label label06Title;
    private java.awt.Label label06TimeDelay;
    private java.awt.TextField text06FieldTimeDelay;
    private java.awt.Label label06TimeDelayUnit;
    private java.awt.Label label06Level;
    private java.awt.TextField textField06Level;
    private java.awt.Label label06LevelUnit;
    private java.awt.TextArea textArea06Result;
    private java.awt.Panel panel20MeV;
    private java.awt.Label label20Title;
    private java.awt.Label label20TimeDelay;
    private java.awt.TextField text20FieldTimeDelay;
    private java.awt.Label label20TimeDelayUnit;
    private java.awt.Label label20Level;
    private java.awt.TextField textField20Level;
    private java.awt.Label label20LevelUnit;
    private java.awt.TextArea textArea20Result;
    // End of variables declaration//GEN-END:variables

}
