/*
 * ElFluenceLevelApplet.java
 *
 * Created on July 5, 2001, 1:10 PM
 */

package saaps.saam;

import saaps.math.ProbCond;
import saaps.util.EventList;
import saaps.util.EventListDialog;
import saaps.util.EventRandomDialog;

import java.net.MalformedURLException;
import java.io.IOException;

import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import saaps.dbt.DatabaseRMI;

/**
 *
 * @author  leif
 * @version 
 */
public class ElFluenceLevelApplet extends java.applet.Applet {

        //The events.
    private EventList eventList;
    
    //The non-events.
    private EventList nonEventList;

    private DatabaseRMI dbrmi = null;
    
    /** Initializes the applet ElFluenceLevelApplet */
    public void init () {
        try {
            dbrmi = (DatabaseRMI) Naming.lookup("//" + getCodeBase().getHost() +
            ":2001" + "/DatabaseRMIServer");
        }
        catch(NotBoundException nbe) {
            System.err.println(nbe);
        }
        catch(MalformedURLException murle) {
            System.err.println(murle);
        }
        catch(RemoteException re) {
            System.err.println(re);
        }
        initComponents ();
    }
    
    /** This method is called from within the init() method to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        panel06MeV = new java.awt.Panel();
        label1 = new java.awt.Label();
        label2 = new java.awt.Label();
        text06FieldTimeDelay = new java.awt.TextField();
        label3 = new java.awt.Label();
        label4 = new java.awt.Label();
        textField06Level = new java.awt.TextField();
        label5 = new java.awt.Label();
        textArea06Result = new java.awt.TextArea();
        panel20MeV = new java.awt.Panel();
        label6 = new java.awt.Label();
        label7 = new java.awt.Label();
        text20FieldTimeDelay = new java.awt.TextField();
        label8 = new java.awt.Label();
        label9 = new java.awt.Label();
        textField20Level = new java.awt.TextField();
        label10 = new java.awt.Label();
        textArea20Result = new java.awt.TextArea();
        panelBottom = new java.awt.Panel();
        buttonHelp = new java.awt.Button();
        panelButtons = new java.awt.Panel();
        buttonEditEvents = new java.awt.Button();
        buttonEditNonEvents = new java.awt.Button();
        buttonRandomNonEvents = new java.awt.Button();
        buttonOptimize = new java.awt.Button();
        buttonRun = new java.awt.Button();
        
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        panel06MeV.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        panel06MeV.setBackground(new java.awt.Color(255, 255, 102));
        panel06MeV.setFont(new java.awt.Font("Dialog", 0, 11));
        panel06MeV.setForeground(java.awt.Color.black);
        label1.setBackground(new java.awt.Color(255, 255, 102));
        label1.setFont(new java.awt.Font("Dialog", 1, 14));
        label1.setForeground(java.awt.Color.black);
        label1.setText(">0.6 MeV daily electron fluence FAKE DATA TEST");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 0;
        gridBagConstraints2.gridwidth = 6;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        panel06MeV.add(label1, gridBagConstraints2);
        
        label2.setBackground(new java.awt.Color(255, 255, 102));
        label2.setFont(new java.awt.Font("Dialog", 0, 11));
        label2.setForeground(java.awt.Color.black);
        label2.setText("Time delay");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(15, 10, 0, 0);
        panel06MeV.add(label2, gridBagConstraints2);
        
        text06FieldTimeDelay.setText("0");
        text06FieldTimeDelay.setBackground(new java.awt.Color(255, 247, 233));
        text06FieldTimeDelay.setColumns(3);
        text06FieldTimeDelay.setFont(new java.awt.Font("Dialog", 0, 11));
        text06FieldTimeDelay.setForeground(java.awt.Color.black);
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 1;
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.gridwidth = 2;
        gridBagConstraints2.gridheight = 3;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(15, 3, 0, 0);
        panel06MeV.add(text06FieldTimeDelay, gridBagConstraints2);
        
        label3.setBackground(new java.awt.Color(255, 255, 102));
        label3.setFont(new java.awt.Font("Dialog", 0, 11));
        label3.setForeground(java.awt.Color.black);
        label3.setText("(days)");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 3;
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.gridwidth = 2;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(15, 2, 0, 0);
        panel06MeV.add(label3, gridBagConstraints2);
        
        label4.setBackground(new java.awt.Color(255, 255, 102));
        label4.setFont(new java.awt.Font("Dialog", 0, 11));
        label4.setForeground(java.awt.Color.black);
        label4.setText("Threshold level");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 4;
        gridBagConstraints2.gridwidth = 2;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(19, 10, 0, 0);
        panel06MeV.add(label4, gridBagConstraints2);
        
        textField06Level.setText("0");
        textField06Level.setBackground(new java.awt.Color(255, 247, 233));
        textField06Level.setColumns(8);
        textField06Level.setFont(new java.awt.Font("Dialog", 0, 11));
        textField06Level.setForeground(java.awt.Color.black);
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 2;
        gridBagConstraints2.gridy = 4;
        gridBagConstraints2.gridwidth = 2;
        gridBagConstraints2.gridheight = 3;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(19, 2, 0, 0);
        panel06MeV.add(textField06Level, gridBagConstraints2);
        
        label5.setBackground(new java.awt.Color(255, 255, 102));
        label5.setFont(new java.awt.Font("Dialog", 0, 11));
        label5.setForeground(java.awt.Color.black);
        label5.setText("(cm^-2 sr^-1)");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 4;
        gridBagConstraints2.gridy = 4;
        gridBagConstraints2.gridwidth = 3;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(19, 0, 0, 0);
        panel06MeV.add(label5, gridBagConstraints2);
        
        textArea06Result.setBackground(new java.awt.Color(255, 247, 233));
        textArea06Result.setColumns(20);
        textArea06Result.setFont(new java.awt.Font("Dialog", 0, 11));
        textArea06Result.setForeground(java.awt.Color.black);
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 7;
        gridBagConstraints2.gridwidth = 7;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(19, 10, 0, 0);
        panel06MeV.add(textArea06Result, gridBagConstraints2);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 6;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.ipadx = 20;
        gridBagConstraints1.ipady = 20;
        gridBagConstraints1.insets = new java.awt.Insets(17, 10, 0, 0);
        add(panel06MeV, gridBagConstraints1);
        
        panel20MeV.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints3;
        
        panel20MeV.setBackground(java.awt.Color.red);
        panel20MeV.setFont(new java.awt.Font("Dialog", 0, 11));
        panel20MeV.setForeground(java.awt.Color.black);
        label6.setBackground(java.awt.Color.red);
        label6.setFont(new java.awt.Font("Dialog", 1, 14));
        label6.setForeground(java.awt.Color.black);
        label6.setText(">2 MeV daily electron fluence FAKE DATA TEST");
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.gridx = 0;
        gridBagConstraints3.gridy = 0;
        gridBagConstraints3.gridwidth = 6;
        gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
        panel20MeV.add(label6, gridBagConstraints3);
        
        label7.setBackground(java.awt.Color.red);
        label7.setFont(new java.awt.Font("Dialog", 0, 11));
        label7.setForeground(java.awt.Color.black);
        label7.setText("Time delay");
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.gridx = 0;
        gridBagConstraints3.gridy = 1;
        gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints3.insets = new java.awt.Insets(15, 10, 0, 0);
        panel20MeV.add(label7, gridBagConstraints3);
        
        text20FieldTimeDelay.setText("0");
        text20FieldTimeDelay.setBackground(new java.awt.Color(255, 247, 233));
        text20FieldTimeDelay.setColumns(3);
        text20FieldTimeDelay.setFont(new java.awt.Font("Dialog", 0, 11));
        text20FieldTimeDelay.setForeground(java.awt.Color.black);
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.gridx = 1;
        gridBagConstraints3.gridy = 1;
        gridBagConstraints3.gridwidth = 2;
        gridBagConstraints3.gridheight = 3;
        gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints3.insets = new java.awt.Insets(15, 3, 0, 0);
        panel20MeV.add(text20FieldTimeDelay, gridBagConstraints3);
        
        label8.setBackground(java.awt.Color.red);
        label8.setFont(new java.awt.Font("Dialog", 0, 11));
        label8.setForeground(java.awt.Color.black);
        label8.setText("(days)");
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.gridx = 3;
        gridBagConstraints3.gridy = 1;
        gridBagConstraints3.gridwidth = 2;
        gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints3.insets = new java.awt.Insets(15, 2, 0, 0);
        panel20MeV.add(label8, gridBagConstraints3);
        
        label9.setBackground(java.awt.Color.red);
        label9.setFont(new java.awt.Font("Dialog", 0, 11));
        label9.setForeground(java.awt.Color.black);
        label9.setText("Threshold level");
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.gridx = 0;
        gridBagConstraints3.gridy = 4;
        gridBagConstraints3.gridwidth = 2;
        gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints3.insets = new java.awt.Insets(19, 10, 0, 0);
        panel20MeV.add(label9, gridBagConstraints3);
        
        textField20Level.setText("0");
        textField20Level.setBackground(new java.awt.Color(255, 247, 233));
        textField20Level.setColumns(8);
        textField20Level.setFont(new java.awt.Font("Dialog", 0, 11));
        textField20Level.setForeground(java.awt.Color.black);
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.gridx = 2;
        gridBagConstraints3.gridy = 4;
        gridBagConstraints3.gridwidth = 2;
        gridBagConstraints3.gridheight = 3;
        gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints3.insets = new java.awt.Insets(19, 2, 0, 0);
        panel20MeV.add(textField20Level, gridBagConstraints3);
        
        label10.setBackground(java.awt.Color.red);
        label10.setFont(new java.awt.Font("Dialog", 0, 11));
        label10.setForeground(java.awt.Color.black);
        label10.setText("(cm^-2 sr^-1)");
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.gridx = 4;
        gridBagConstraints3.gridy = 4;
        gridBagConstraints3.gridwidth = 3;
        gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints3.insets = new java.awt.Insets(19, 0, 0, 0);
        panel20MeV.add(label10, gridBagConstraints3);
        
        textArea20Result.setBackground(new java.awt.Color(255, 247, 233));
        textArea20Result.setColumns(20);
        textArea20Result.setFont(new java.awt.Font("Dialog", 0, 11));
        textArea20Result.setForeground(java.awt.Color.black);
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.gridx = 0;
        gridBagConstraints3.gridy = 7;
        gridBagConstraints3.gridwidth = 7;
        gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints3.insets = new java.awt.Insets(19, 10, 0, 0);
        panel20MeV.add(textArea20Result, gridBagConstraints3);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 6;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 6;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.ipadx = 20;
        gridBagConstraints1.ipady = 20;
        gridBagConstraints1.insets = new java.awt.Insets(17, 10, 0, 0);
        add(panel20MeV, gridBagConstraints1);
        
        buttonHelp.setBackground(new java.awt.Color(204, 204, 204));
        buttonHelp.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonHelp.setForeground(java.awt.Color.black);
        buttonHelp.setLabel("Help");
        buttonHelp.setName("button7");
        buttonHelp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHelpActionPerformed(evt);
            }
        });
        
        panelBottom.add(buttonHelp);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.gridwidth = 12;
        gridBagConstraints1.gridheight = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(11, 0, 0, 0);
        add(panelBottom, gridBagConstraints1);
        
        buttonEditEvents.setBackground(new java.awt.Color(204, 204, 204));
        buttonEditEvents.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonEditEvents.setForeground(java.awt.Color.black);
        buttonEditEvents.setLabel("Edit Events ...");
        buttonEditEvents.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonEditEventsActionPerformed(evt);
            }
        });
        
        panelButtons.add(buttonEditEvents);
        
        buttonEditNonEvents.setBackground(new java.awt.Color(204, 204, 204));
        buttonEditNonEvents.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonEditNonEvents.setForeground(java.awt.Color.black);
        buttonEditNonEvents.setLabel("Edit Non-Events ...");
        buttonEditNonEvents.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonEditNonEventsActionPerformed(evt);
            }
        });
        
        panelButtons.add(buttonEditNonEvents);
        
        buttonRandomNonEvents.setBackground(new java.awt.Color(204, 204, 204));
        buttonRandomNonEvents.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonRandomNonEvents.setLabel("Random Non-Events ...");
        buttonRandomNonEvents.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonRandomNonEventsActionPerformed(evt);
            }
        });
        
        panelButtons.add(buttonRandomNonEvents);
        
        buttonOptimize.setBackground(new java.awt.Color(204, 204, 204));
        buttonOptimize.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonOptimize.setForeground(java.awt.Color.black);
        buttonOptimize.setLabel("Optimize ...");
        buttonOptimize.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonOptimizeActionPerformed(evt);
            }
        });
        
        panelButtons.add(buttonOptimize);
        
        buttonRun.setBackground(new java.awt.Color(204, 204, 204));
        buttonRun.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonRun.setForeground(java.awt.Color.black);
        buttonRun.setLabel("Run");
        buttonRun.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonRunActionPerformed(evt);
            }
        });
        
        panelButtons.add(buttonRun);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridwidth = 12;
        add(panelButtons, gridBagConstraints1);
        
    }//GEN-END:initComponents

    private void buttonRandomNonEventsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonRandomNonEventsActionPerformed
      EventRandomDialog erd = new EventRandomDialog(this.getAppletFrame(),this.eventList);
      erd.setVisible(true);
      if (erd.isOK()) {
          this.nonEventList = erd.getEventList();
      }
    }//GEN-LAST:event_buttonRandomNonEventsActionPerformed

  private void buttonHelpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonHelpActionPerformed
// Add your handling code here:
    java.applet.AppletContext ac = getAppletContext();
    java.net.URL url = getDocumentBase();
    try
    {
      java.net.URL urlDoc = new java.net.URL(url,"ElFluenceLevelAppletHelp.html");
      ac.showDocument(urlDoc,"Electron Fluence Level Help");
    }
    catch (java.net.MalformedURLException murle)
    {
      System.err.println(murle);
    }
  }//GEN-LAST:event_buttonHelpActionPerformed

    private java.awt.Frame getAppletFrame() {
        java.awt.Component curr = this;
        while (!(curr instanceof java.awt.Frame))
            curr = curr.getParent();
        return (java.awt.Frame) curr;
    }

    /**
     * Checks the input fields for correct input.
     */
    private void verifyInputFields() throws NumberFormatException {
        try {
            Integer.valueOf(this.text06FieldTimeDelay.getText());
            Integer.valueOf(this.text20FieldTimeDelay.getText());
        }
        catch (NumberFormatException e) {
            throw new NumberFormatException("Please use integer for time delay field.\n");
        }
        try {
            Double.valueOf(this.textField06Level.getText());
            Double.valueOf(this.textField20Level.getText());
        }
        catch (NumberFormatException e) {
            throw new NumberFormatException("Please use double for level field.\n");
        }
    }
    
    private int parseInteger(String x) {
        int y = 0;
        try {
            y = Integer.parseInt(x);
        }
        catch (NumberFormatException e) {
            System.err.println(e);
        }
        return y;
    }
    
    private double parseDouble(String x) {
        double y = 1e4;
        try {
            y = Double.valueOf(x).doubleValue();
        }
        catch (NumberFormatException e) {
            System.err.println(e);
        }
        return y;
    }
    
  private void buttonRunActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonRunActionPerformed
      try {
          verifyInputFields();
          int[] td = new int[2];
          td[0] = this.parseInteger(this.text06FieldTimeDelay.getText());
          td[1] = this.parseInteger(this.text20FieldTimeDelay.getText());
          
          double[] lev = new double[2];
          lev[0] = this.parseDouble(this.textField06Level.getText());
          lev[1] = this.parseDouble(this.textField20Level.getText());
          
          //Use RMI to get the ElFluenceLevel object
          ElFluenceLevel efl = dbrmi.getElFluenceLevel(eventList,nonEventList,td,lev);
          this.textArea06Result.setText(efl.get06Stat());
          this.textArea20Result.setText(efl.get20Stat());
          
      }
      catch (NumberFormatException e) {
          new ErrorDialog(this.getAppletFrame(),e.getMessage());
      }
      catch (IOException e) {
          System.out.println("Data access error. Please verify event lists!\n\n"+e);
          new ErrorDialog(this.getAppletFrame(),"      Data access error. Please verify event lists!    \n\n"+e);
      }
      catch (Exception e) {
          System.err.println(e);
          e.printStackTrace();
      }      
  }//GEN-LAST:event_buttonRunActionPerformed

  private void buttonOptimizeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonOptimizeActionPerformed
      java.awt.Dialog dialog = new java.awt.Dialog(getAppletFrame(), "Optimizing ...", false);
      dialog.add(new java.awt.Label("Optimizing ..."));
      dialog.pack();
      
      try {
          verifyInputFields();
          dialog.setVisible(true);
          ElFluenceLevel efl = dbrmi.getOptimizedElFluenceLevel(eventList,nonEventList);
          
          int[] td = efl.getTimeDelay();
          double[] level = efl.getLevel();
          
          dialog.dispose();
          
          this.text06FieldTimeDelay.setText(Integer.toString(td[0]));
          this.text20FieldTimeDelay.setText(Integer.toString(td[1]));
          this.textField06Level.setText(Double.toString(level[0]));
          this.textField20Level.setText(Double.toString(level[1]));
          
          ProbCond[] pc = efl.getProbCond();
          double[] pcxy = new double[pc.length];
          double[] pcyx = new double[pc.length];
          for (int i=0;i<pc.length;i++) {
              pcxy[i] = ( pc[i].xy[0][0] + pc[i].xy[0][0] ) / 2.0;
              pcyx[i] = ( pc[i].yx[0][0] + pc[i].yx[0][0] ) / 2.0;
          }
          
          this.textArea06Result.setText("The time delay was varied from -5 to 5 days.");
          this.textArea06Result.appendText("\nThe 0.6 MeV electron fluence level was varied from 10^7 to 10^11 cm^-2 sr^-1.");
          this.textArea06Result.appendText("\nThe optimal time delay and threshold level gives the highest probability that the prediction is correct.");
          this.textArea06Result.appendText("\n\nThe optimal time delay = " + td[0] + " days.");
          this.textArea06Result.appendText("\nThe optimal threshold level = " + level[0] + " cm^-2 sr^-1.");
          this.textArea06Result.appendText("\n\nThe probability that the prediction is observed = " + pcyx[0]);
          this.textArea06Result.appendText("\nThe probability that the observation is predicted = " + pcyx[0]);
          //      this.textArea06Result.setText(efl.get06Stat());
          
          this.textArea20Result.setText(efl.get20Stat());
      }
      catch (NumberFormatException e) {
          dialog.dispose();
          new ErrorDialog(this.getAppletFrame(),e.getMessage());
      }      
      catch (IOException e) {
          dialog.dispose();
          System.out.println("Data access error. Please verify event lists!\n\n"+e);
          new ErrorDialog(this.getAppletFrame(),"      Data access error. Please verify event lists!    \n\n"+e);
      }
      catch (Exception e) {
          dialog.dispose();
          System.err.println(e);
          e.printStackTrace();
      }
  }//GEN-LAST:event_buttonOptimizeActionPerformed

  private void buttonEditNonEventsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonEditNonEventsActionPerformed
      EventListDialog eld = new EventListDialog(getAppletFrame(),"Non-Event list",this.nonEventList);
      eld.setAppletType();
      eld.setVisible(true);
      if (eld.isOK()) {
          this.nonEventList = eld.getEventList();
      }
  }//GEN-LAST:event_buttonEditNonEventsActionPerformed

  private void buttonEditEventsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonEditEventsActionPerformed
      EventListDialog eld = new EventListDialog(getAppletFrame(),"Event list",this.eventList);
      eld.setAppletType();
      eld.setVisible(true);
      if (eld.isOK()) {
          this.eventList = eld.getEventList();
      }
  }//GEN-LAST:event_buttonEditEventsActionPerformed


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private java.awt.Panel panel06MeV;
  private java.awt.Label label1;
  private java.awt.Label label2;
  private java.awt.TextField text06FieldTimeDelay;
  private java.awt.Label label3;
  private java.awt.Label label4;
  private java.awt.TextField textField06Level;
  private java.awt.Label label5;
  private java.awt.TextArea textArea06Result;
  private java.awt.Panel panel20MeV;
  private java.awt.Label label6;
  private java.awt.Label label7;
  private java.awt.TextField text20FieldTimeDelay;
  private java.awt.Label label8;
  private java.awt.Label label9;
  private java.awt.TextField textField20Level;
  private java.awt.Label label10;
  private java.awt.TextArea textArea20Result;
  private java.awt.Panel panelBottom;
  private java.awt.Button buttonHelp;
  private java.awt.Panel panelButtons;
  private java.awt.Button buttonEditEvents;
  private java.awt.Button buttonEditNonEvents;
  private java.awt.Button buttonRandomNonEvents;
  private java.awt.Button buttonOptimize;
  private java.awt.Button buttonRun;
  // End of variables declaration//GEN-END:variables

}
