/*
 * MetaDataDialog.java
 *
 * Created on June 13, 2001, 11:30 AM
 */

package saaps.saam;

import saaps.dbt.MetaData;
import saaps.dbt.ODIDatabase;
import java.sql.*;
import java.util.Calendar;
import java.util.StringTokenizer;
import java.util.TimeZone;
import java.util.Locale;


/**
 *
 * @author  leif
 * @version 
 */
public class MetaDataDialog extends java.awt.Dialog {
    private static long cdfEpoch1970 = 62167219200000L;

    /** Creates new form MetaDataDialog */
    public MetaDataDialog(java.awt.Frame parent,boolean modal) {
        super (parent, modal);
        initComponents ();
        pack ();
    }

    public MetaDataDialog(java.awt.Dialog parent) {
        super (parent);
        initComponents ();
        pack ();
    }

    public MetaDataDialog(java.awt.Frame parent,MetaData md)
    {
        this(parent,false);
	Calendar calStart = Calendar.getInstance(TimeZone.getTimeZone("UTC"),new Locale("sv","SE"));
	Calendar calEnd = Calendar.getInstance(TimeZone.getTimeZone("UTC"),new Locale("sv","SE"));
        nameF.setText(md.getName());
        descrA.setText(formatText(md.getDescrLong()));

	calStart.setTime(new Date(md.getStartLong()-cdfEpoch1970));
	calEnd.setTime(new Date(md.getEndLong()-cdfEpoch1970));
	startF.setText(formatDate(calStart));
	endF.setText(formatDate(calEnd));
//        startF.setText(formatDate(md.getStartLong()));
//        endF.setText(formatDate(md.getEndLong()));
        resF.setText(md.getStringTimeStep());
    }

    public MetaDataDialog(java.awt.Frame parent,String dbName, String descLong, Long eStart, Long eEnd, String dRes)
    {
        this(parent,false);
	Calendar calStart = Calendar.getInstance(TimeZone.getTimeZone("UTC"),new Locale("sv","SE"));
	Calendar calEnd = Calendar.getInstance(TimeZone.getTimeZone("UTC"),new Locale("sv","SE"));
        nameF.setText(dbName);
//        descrA.setText(descLong);

	calStart.setTime(new Date(eStart-cdfEpoch1970));
	calEnd.setTime(new Date(eEnd-cdfEpoch1970));
	startF.setText(formatDate(calStart));
	endF.setText(formatDate(calEnd));
/*        resF.setText(dRes);
*/    }

    public MetaDataDialog(java.awt.Frame parent,String dbName)
    {
        this(parent,false);
        ODIDatabase odi = new ODIDatabase();
		try {
			Calendar calStart = Calendar.getInstance(TimeZone.getTimeZone("UTC"),new Locale("sv","SE"));
			Calendar calEnd = Calendar.getInstance(TimeZone.getTimeZone("UTC"),new Locale("sv","SE"));
			String q = "SELECT id,epoch_start,epoch_end FROM dataset WHERE sedat_name=\""+dbName+"\"";
//System.out.println(q);
			ResultSet res = odi.query(q);
			res.next();
			String id = res.getString("id");
			nameF.setText(dbName);
			calStart.setTime(new Date(res.getLong("epoch_start")-cdfEpoch1970));
			calEnd.setTime(new Date(res.getLong("epoch_end")-cdfEpoch1970));
			startF.setText(formatDate(calStart));
			endF.setText(formatDate(calEnd));

			q = "SELECT value FROM dataset_metadata WHERE attribute=\"TEXT\" AND dataset_id="+id;
//System.out.println(q);
			res = odi.query(q);
			res.next();
			descrA.setText(formatText(res.getString("value")));
			q = "SELECT value FROM dataset_metadata WHERE attribute=\"Time_resolution\" AND dataset_id="+id;
//System.out.println(q);
			res = odi.query(q);
			res.next();
			resF.setText(res.getString("value"));
		}
		catch(SQLException e) {
			e.printStackTrace();
		}
    }

    /** This method is called from within the init() method to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        panel1 = new java.awt.Panel();
        nameL = new java.awt.Label();
        nameF = new java.awt.TextField();
        descrL = new java.awt.Label();
        descrA = new java.awt.TextArea();
        startL = new java.awt.Label();
        startF = new java.awt.TextField();
        endL = new java.awt.Label();
        endF = new java.awt.TextField();
        resL = new java.awt.Label();
        resF = new java.awt.TextField();
        closeB = new java.awt.Button();
        setLayout(new java.awt.BorderLayout());
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        }
        );
        
        panel1.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        panel1.setFont(new java.awt.Font ("Dialog", 0, 11));
        panel1.setName("panel1");
        panel1.setBackground(new java.awt.Color (204, 204, 204));
        panel1.setForeground(java.awt.Color.black);
        
        nameL.setFont(new java.awt.Font ("Dialog", 0, 11));
          nameL.setName("label5");
          nameL.setBackground(new java.awt.Color (204, 204, 204));
          nameL.setForeground(java.awt.Color.black);
          nameL.setText("Name:");
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.insets = new java.awt.Insets(0, 14, 11, 0);
          gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
          panel1.add(nameL, gridBagConstraints1);
          
          
        nameF.setBackground(new java.awt.Color (255, 255, 255));
          nameF.setName("textfield5");
          nameF.setFont(new java.awt.Font ("Dialog", 0, 11));
          nameF.setForeground(new java.awt.Color (0, 0, 0));
          nameF.setText("     empty field       ");
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.insets = new java.awt.Insets(0, 0, 11, 0);
          gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
          panel1.add(nameF, gridBagConstraints1);
          
          
        descrL.setFont(new java.awt.Font ("Dialog", 0, 11));
          descrL.setName("label6");
          descrL.setBackground(new java.awt.Color (204, 204, 204));
          descrL.setForeground(java.awt.Color.black);
          descrL.setText("Description:");
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridy = 1;
          gridBagConstraints1.insets = new java.awt.Insets(0, 14, 5, 0);
          panel1.add(descrL, gridBagConstraints1);
          
          
        descrA.setBackground(new java.awt.Color (255, 255, 255));
          descrA.setName("text1");
          descrA.setFont(new java.awt.Font ("Dialog", 0, 11));
          descrA.setForeground(new java.awt.Color (0, 0, 0));
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridy = 2;
          gridBagConstraints1.gridwidth = 2;
          gridBagConstraints1.insets = new java.awt.Insets(0, 14, 23, 0);
          panel1.add(descrA, gridBagConstraints1);
          
          
        startL.setFont(new java.awt.Font ("Dialog", 0, 11));
          startL.setName("label7");
          startL.setBackground(new java.awt.Color (204, 204, 204));
          startL.setForeground(java.awt.Color.black);
          startL.setText("Start");
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridy = 3;
          gridBagConstraints1.insets = new java.awt.Insets(3, 14, 0, 0);
          gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
          panel1.add(startL, gridBagConstraints1);
          
          
        startF.setBackground(new java.awt.Color (255, 255, 255));
          startF.setName("start");
          startF.setFont(new java.awt.Font ("Dialog", 0, 11));
          startF.setForeground(new java.awt.Color (0, 0, 0));
          startF.setText(" 2001-06-13 00:00:00 UT ");
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridy = 3;
          gridBagConstraints1.insets = new java.awt.Insets(3, 0, 0, 0);
          gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
          panel1.add(startF, gridBagConstraints1);
          
          
        endL.setFont(new java.awt.Font ("Dialog", 0, 11));
          endL.setName("label8");
          endL.setBackground(new java.awt.Color (204, 204, 204));
          endL.setForeground(java.awt.Color.black);
          endL.setText("End");
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridy = 4;
          gridBagConstraints1.insets = new java.awt.Insets(3, 14, 3, 0);
          gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
          panel1.add(endL, gridBagConstraints1);
          
          
        endF.setBackground(new java.awt.Color (255, 255, 255));
          endF.setName("textfield7");
          endF.setFont(new java.awt.Font ("Dialog", 0, 11));
          endF.setForeground(new java.awt.Color (0, 0, 0));
          endF.setText(" 2001-06-13 00:00:00 UT ");
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridy = 4;
          gridBagConstraints1.insets = new java.awt.Insets(3, 0, 3, 0);
          gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
          panel1.add(endF, gridBagConstraints1);
          
          
        resL.setFont(new java.awt.Font ("Dialog", 0, 11));
          resL.setName("label9");
          resL.setBackground(new java.awt.Color (204, 204, 204));
          resL.setForeground(java.awt.Color.black);
          resL.setText("Resolution");
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridy = 5;
          gridBagConstraints1.insets = new java.awt.Insets(0, 14, 0, 0);
          gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
          panel1.add(resL, gridBagConstraints1);
          
          
        resF.setBackground(new java.awt.Color (255, 255, 255));
          resF.setName("textfield8");
          resF.setFont(new java.awt.Font ("Dialog", 0, 11));
          resF.setForeground(new java.awt.Color (0, 0, 0));
          resF.setText(" 2001-06-13 00:00:00 UT ");
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridy = 5;
          gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
          panel1.add(resF, gridBagConstraints1);
          
          
        closeB.setFont(new java.awt.Font ("Dialog", 0, 11));
          closeB.setLabel("Close");
          closeB.setName("button2");
          closeB.setBackground(new java.awt.Color (204, 204, 204));
          closeB.setForeground(java.awt.Color.black);
          closeB.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  closeBActionPerformed(evt);
              }
          }
          );
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridy = 5;
          panel1.add(closeB, gridBagConstraints1);
          
          
        add(panel1, java.awt.BorderLayout.CENTER);
        
    }//GEN-END:initComponents

  private void closeBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeBActionPerformed
      setVisible (false);
      dispose ();      
  }//GEN-LAST:event_closeBActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible (false);
        dispose ();
    }//GEN-LAST:event_closeDialog

    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
        new MetaDataDialog (new java.awt.Frame (), true).show ();
    }

    private String formatText(String s) {
        StringTokenizer st = new StringTokenizer(s);
        int maxWidth = 25;
        StringBuffer buf = new StringBuffer();
        int i=0;
        while (st.hasMoreTokens())
        {
            String tmp = st.nextToken();
            buf.append(tmp + " ");
            i += tmp.length();
            if (i>maxWidth)
            {
                
                buf.append("\n");
                i = 0;
            }
        }
        return buf.toString();
  }    

  private String formatDate(Calendar c) {
      c.setTimeZone(TimeZone.getTimeZone("GMT"));
      int year = c.get(Calendar.YEAR);
      int month = c.get(Calendar.MONTH) + 1;
      int date = c.get(Calendar.DATE);
      int hour = c.get(Calendar.HOUR_OF_DAY);
      int minute = c.get(Calendar.MINUTE);
      StringBuffer sb = new StringBuffer();
      sb.append(year);
      sb.append("-");
      if (month<10)
          sb.append("0");
      sb.append(month);
      sb.append("-");
      if (date<10)
          sb.append("0");
      sb.append(date);
      sb.append(" ");
      if (hour<10)
          sb.append("0");
      sb.append(hour);
      sb.append(":");
      if (minute<10)
          sb.append("0");
      sb.append(minute);
      sb.append(" UT");
      return sb.toString();
}
  
private String formatResolution(long l) {
    //Seconds
    l = (long) l/1000L;
    if (l==1L)
        return new String("1 second");
    if (l<60L)
        return new String(l + " seconds");
    //Minutes
    l = (long) l/60L;
    if (l==1L)
        return new String("1 minute");
    if (l<60L)
        return new String(l + " minutes");
    //Hours
    l = (long) l/60L;
    if (l==1L)
        return new String("1 hour");
    if (l<24L)
        return new String(l + " hours");
    //Days
    l = (long) l/24L;
    if (l==1L)
        return new String("1 day");
    return new String(l + " days");
}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.Panel panel1;
    private java.awt.Label nameL;
    private java.awt.TextField nameF;
    private java.awt.Label descrL;
    private java.awt.TextArea descrA;
    private java.awt.Label startL;
    private java.awt.TextField startF;
    private java.awt.Label endL;
    private java.awt.TextField endF;
    private java.awt.Label resL;
    private java.awt.TextField resF;
    private java.awt.Button closeB;
    // End of variables declaration//GEN-END:variables

}
