/*
 * SumKpLevelApp.java
 *
 * Created on June 25, 2001, 1:28 PM
 */

package saaps.saam;

import saaps.math.ProbCond;
import saaps.util.EventList;
import saaps.util.EventListDialog;
import saaps.util.EventRandomDialog;
import saaps.util.AppHelp;

/**
 *
 * @author  root
 * @version 
 */
public class SumKpLevelApp extends java.awt.Frame {

    //The events.
    private EventList eventList = null;
    
    //The non-events.
    private EventList nonEventList = null;

    private AppHelp help = null;
    
    /** Creates new form ElFluenceLevelApp */
    public SumKpLevelApp() {
        initComponents ();
        pack ();
    }

    private void verifyInputFields() throws NumberFormatException {
        try {
            Integer.valueOf(textFieldTimeDelay.getText());
        }
        catch (NumberFormatException e) {
            throw new NumberFormatException("Please use integer for time delay.");
        }
        try {
            Double.valueOf(textFieldLevel.getText());
        }
        catch (NumberFormatException e) {
            throw new NumberFormatException("Please use double for threshold level.");
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        panel = new java.awt.Panel();
        labelTitle = new java.awt.Label();
        labelTimeDelay = new java.awt.Label();
        textFieldTimeDelay = new java.awt.TextField();
        labelTimeDelayUnit = new java.awt.Label();
        labelLevel = new java.awt.Label();
        textFieldLevel = new java.awt.TextField();
        textAreaResult = new java.awt.TextArea();
        panelNorth = new java.awt.Panel();
        buttonEditEvents = new java.awt.Button();
        buttonEditNonEvents = new java.awt.Button();
        buttonRandomNonEvents = new java.awt.Button();
        buttonOptimize = new java.awt.Button();
        buttonRun = new java.awt.Button();
        panelSouth = new java.awt.Panel();
        buttonHelp = new java.awt.Button();
        buttonQuit = new java.awt.Button();
        setBackground(new java.awt.Color (204, 204, 255));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        }
        );
        
        panel.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        panel.setFont(new java.awt.Font ("Dialog", 0, 11));
        panel.setBackground(new java.awt.Color (255, 255, 102));
        panel.setForeground(java.awt.Color.black);
        
        labelTitle.setFont(new java.awt.Font ("Dialog", 1, 14));
          labelTitle.setBackground(new java.awt.Color (255, 255, 102));
          labelTitle.setForeground(java.awt.Color.black);
          labelTitle.setText("Sum Kp");
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 0;
          gridBagConstraints2.gridy = 0;
          gridBagConstraints2.gridwidth = 6;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
          panel.add(labelTitle, gridBagConstraints2);
          
          
        labelTimeDelay.setFont(new java.awt.Font ("Dialog", 0, 11));
          labelTimeDelay.setBackground(new java.awt.Color (255, 255, 102));
          labelTimeDelay.setForeground(java.awt.Color.black);
          labelTimeDelay.setText("Time delay");
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 0;
          gridBagConstraints2.gridy = 1;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
          gridBagConstraints2.insets = new java.awt.Insets(15, 10, 0, 0);
          panel.add(labelTimeDelay, gridBagConstraints2);
          
          
        textFieldTimeDelay.setBackground(new java.awt.Color (255, 247, 233));
          textFieldTimeDelay.setFont(new java.awt.Font ("Dialog", 0, 11));
          textFieldTimeDelay.setColumns(3);
          textFieldTimeDelay.setForeground(java.awt.Color.black);
          textFieldTimeDelay.setText("0");
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 1;
          gridBagConstraints2.gridy = 1;
          gridBagConstraints2.gridwidth = 2;
          gridBagConstraints2.gridheight = 3;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
          gridBagConstraints2.insets = new java.awt.Insets(15, 3, 0, 0);
          panel.add(textFieldTimeDelay, gridBagConstraints2);
          
          
        labelTimeDelayUnit.setFont(new java.awt.Font ("Dialog", 0, 11));
          labelTimeDelayUnit.setBackground(new java.awt.Color (255, 255, 102));
          labelTimeDelayUnit.setForeground(java.awt.Color.black);
          labelTimeDelayUnit.setText("(days)");
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 3;
          gridBagConstraints2.gridy = 1;
          gridBagConstraints2.gridwidth = 2;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
          gridBagConstraints2.insets = new java.awt.Insets(15, 2, 0, 0);
          panel.add(labelTimeDelayUnit, gridBagConstraints2);
          
          
        labelLevel.setFont(new java.awt.Font ("Dialog", 0, 11));
          labelLevel.setBackground(new java.awt.Color (255, 255, 102));
          labelLevel.setForeground(java.awt.Color.black);
          labelLevel.setText("Threshold level");
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 0;
          gridBagConstraints2.gridy = 4;
          gridBagConstraints2.gridwidth = 2;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
          gridBagConstraints2.insets = new java.awt.Insets(19, 10, 0, 0);
          panel.add(labelLevel, gridBagConstraints2);
          
          
        textFieldLevel.setBackground(new java.awt.Color (255, 247, 233));
          textFieldLevel.setFont(new java.awt.Font ("Dialog", 0, 11));
          textFieldLevel.setColumns(8);
          textFieldLevel.setForeground(java.awt.Color.black);
          textFieldLevel.setText("0");
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 2;
          gridBagConstraints2.gridy = 4;
          gridBagConstraints2.gridwidth = 2;
          gridBagConstraints2.gridheight = 3;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
          gridBagConstraints2.insets = new java.awt.Insets(19, 2, 0, 0);
          panel.add(textFieldLevel, gridBagConstraints2);
          
          
        textAreaResult.setBackground(new java.awt.Color (255, 247, 233));
          textAreaResult.setFont(new java.awt.Font ("Dialog", 0, 11));
          textAreaResult.setColumns(20);
          textAreaResult.setForeground(java.awt.Color.black);
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 0;
          gridBagConstraints2.gridy = 7;
          gridBagConstraints2.gridwidth = 7;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
          gridBagConstraints2.insets = new java.awt.Insets(19, 10, 0, 0);
          panel.add(textAreaResult, gridBagConstraints2);
          
          
        add(panel, java.awt.BorderLayout.CENTER);
        
        
        panelNorth.setFont(new java.awt.Font ("Dialog", 0, 11));
        panelNorth.setName("panel12");
        panelNorth.setBackground(new java.awt.Color (204, 204, 204));
        panelNorth.setForeground(java.awt.Color.black);
        
        buttonEditEvents.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonEditEvents.setLabel("Edit Events ...");
          buttonEditEvents.setBackground(new java.awt.Color (204, 204, 204));
          buttonEditEvents.setForeground(java.awt.Color.black);
          buttonEditEvents.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonEditEventsActionPerformed(evt);
              }
          }
          );
          panelNorth.add(buttonEditEvents);
          
          
        buttonEditNonEvents.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonEditNonEvents.setLabel("Edit Non-Events ...");
          buttonEditNonEvents.setBackground(new java.awt.Color (204, 204, 204));
          buttonEditNonEvents.setForeground(java.awt.Color.black);
          buttonEditNonEvents.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonEditNonEventsActionPerformed(evt);
              }
          }
          );
          panelNorth.add(buttonEditNonEvents);
          
          
        buttonRandomNonEvents.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonRandomNonEvents.setLabel("Random Non-Events ...");
          buttonRandomNonEvents.setName("button49");
          buttonRandomNonEvents.setBackground(new java.awt.Color (204, 204, 204));
          buttonRandomNonEvents.setForeground(java.awt.Color.black);
          buttonRandomNonEvents.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonRandomNonEventsActionPerformed(evt);
              }
          }
          );
          panelNorth.add(buttonRandomNonEvents);
          
          
        buttonOptimize.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonOptimize.setLabel("Optimize ...");
          buttonOptimize.setBackground(new java.awt.Color (204, 204, 204));
          buttonOptimize.setForeground(java.awt.Color.black);
          buttonOptimize.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonOptimizeActionPerformed(evt);
              }
          }
          );
          panelNorth.add(buttonOptimize);
          
          
        buttonRun.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonRun.setLabel("Run");
          buttonRun.setBackground(new java.awt.Color (204, 204, 204));
          buttonRun.setForeground(java.awt.Color.black);
          buttonRun.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonRunActionPerformed(evt);
              }
          }
          );
          panelNorth.add(buttonRun);
          
          
        add(panelNorth, java.awt.BorderLayout.NORTH);
        
        
        panelSouth.setFont(new java.awt.Font ("Dialog", 0, 11));
        panelSouth.setName("panel13");
        panelSouth.setBackground(new java.awt.Color (204, 204, 204));
        panelSouth.setForeground(java.awt.Color.black);
        
        buttonHelp.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonHelp.setLabel("Help");
          buttonHelp.setName("button7");
          buttonHelp.setBackground(new java.awt.Color (204, 204, 204));
          buttonHelp.setForeground(java.awt.Color.black);
          buttonHelp.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonHelpActionPerformed(evt);
              }
          }
          );
          panelSouth.add(buttonHelp);
          
          
        buttonQuit.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonQuit.setLabel("Quit");
          buttonQuit.setName("button8");
          buttonQuit.setBackground(new java.awt.Color (204, 204, 204));
          buttonQuit.setForeground(java.awt.Color.black);
          buttonQuit.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonQuitActionPerformed(evt);
              }
          }
          );
          panelSouth.add(buttonQuit);
          
          
        add(panelSouth, java.awt.BorderLayout.SOUTH);
        
    }//GEN-END:initComponents

  private void buttonRandomNonEventsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonRandomNonEventsActionPerformed
// Add your handling code here:
      if (this.eventList == null) {
          new ErrorDialog(this,"      Please edit the event list first!    ");
      }
      else {
          EventRandomDialog erd = new EventRandomDialog(this,this.eventList);
          erd.setVisible(true);
          if (erd.isOK() && (erd.getEventList()).getNumOfEvents()>0) {
              this.nonEventList = erd.getEventList();
          }
      }
  }//GEN-LAST:event_buttonRandomNonEventsActionPerformed

    private void buttonHelpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonHelpActionPerformed
      System.out.println("Launching help frame ...");
      if(help != null) {
          help.setVisible(true);
      }
      else {
        /* Get a Class object from this object and then the Name of the class to use as help fi */
          help = AppHelp.getAppHelp(this.getClass().getName());
      }
    }//GEN-LAST:event_buttonHelpActionPerformed

  private void buttonRunActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonRunActionPerformed
      if (this.eventList == null || this.nonEventList == null) {
          new ErrorDialog(this,"      Please edit the event lists first!    ");
      }
      else {
          try {
              verifyInputFields();
              SumKpLevel skl = new SumKpLevel();
              skl.setEventList(this.eventList);
              skl.setNonEventList(this.nonEventList);
              int td = this.parseInteger(this.textFieldTimeDelay.getText());
              skl.setTimeDelay(td);
              double lev = this.parseDouble(this.textFieldLevel.getText());
              skl.setLevel(lev);
              skl.calcStat();
              this.textAreaResult.setText(skl.getRunText());
          }
          catch (NumberFormatException e) {
              new ErrorDialog(this,e.getMessage());
          }
      }
  }//GEN-LAST:event_buttonRunActionPerformed

  private int parseInteger(String x) {
      int y = 0;
      try {
          y = Integer.parseInt(x);
      }
      catch (NumberFormatException e) {
          System.err.println(e);
      }
      return y;
  }
  
  private double parseDouble(String x) {
      double y = 1e4;
      try {
          y = Double.parseDouble(x);
      }
      catch (NumberFormatException e) {
          System.err.println(e);
      }
      return y;
  }
  
  private void buttonOptimizeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonOptimizeActionPerformed
      if (this.eventList == null || this.nonEventList == null) {
          new ErrorDialog(this,"      Please edit the event lists first!    ");
      }
      else {
          try {
              verifyInputFields();
              java.awt.Dialog dialog = new java.awt.Dialog(this, "Optimizing ...", false);
              dialog.add(new java.awt.Label("Optimizing ...                                        "));
              dialog.pack();
              dialog.setVisible(true);
          
              SumKpLevel skl = new SumKpLevel();
              skl.setEventList(this.eventList);
              skl.setNonEventList(this.nonEventList);
              skl.optimize();
              int td = skl.getTimeDelay();
              double level = skl.getLevel();
          
              dialog.dispose();
          
              this.textFieldTimeDelay.setText(Integer.toString(td));
              this.textFieldTimeDelay.setText(Integer.toString(td));
              this.textFieldLevel.setText(Double.toString(level));
              this.textFieldLevel.setText(Double.toString(level));
          
          //      ProbCond[] pc = efl.getProbCond();
          //      double[] pcxy = new double[pc.length];
          //      double[] pcyx = new double[pc.length];
          //      for (int i=0;i<pc.length;i++) {
          //          pcxy[i] = ( pc[i].xy[0][0] + pc[i].xy[0][0] ) / 2.0;
          //          pcyx[i] = ( pc[i].yx[0][0] + pc[i].yx[0][0] ) / 2.0;
          //      }
          
              this.textAreaResult.setText(skl.getOptText());
          }
          catch (NumberFormatException e) {
              new ErrorDialog(this,e.getMessage());
          }
      }
  }//GEN-LAST:event_buttonOptimizeActionPerformed
  
  private void buttonQuitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonQuitActionPerformed
      if(help != null)
          help.dispose();

      this.dispose();
  }//GEN-LAST:event_buttonQuitActionPerformed

  private void buttonEditNonEventsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonEditNonEventsActionPerformed
// Add your handling code here:
      EventListDialog eld = new EventListDialog(this,"Non-Event list",this.nonEventList);
      eld.setVisible(true);
      if (eld.isOK() && (eld.getEventList()).getNumOfEvents()>0) {
          this.nonEventList = eld.getEventList();
      }
  }//GEN-LAST:event_buttonEditNonEventsActionPerformed

  private void buttonEditEventsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonEditEventsActionPerformed
// Add your handling code here:
      EventListDialog eld = new EventListDialog(this,"Event list",this.eventList);
      eld.setVisible(true);
      if (eld.isOK()  && (eld.getEventList()).getNumOfEvents()>0) {
          this.eventList = eld.getEventList();
      }
  }//GEN-LAST:event_buttonEditEventsActionPerformed

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit (0);
    }//GEN-LAST:event_exitForm

    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
        new SumKpLevelApp ().show ();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.Panel panel;
    private java.awt.Label labelTitle;
    private java.awt.Label labelTimeDelay;
    private java.awt.TextField textFieldTimeDelay;
    private java.awt.Label labelTimeDelayUnit;
    private java.awt.Label labelLevel;
    private java.awt.TextField textFieldLevel;
    private java.awt.TextArea textAreaResult;
    private java.awt.Panel panelNorth;
    private java.awt.Button buttonEditEvents;
    private java.awt.Button buttonEditNonEvents;
    private java.awt.Button buttonRandomNonEvents;
    private java.awt.Button buttonOptimize;
    private java.awt.Button buttonRun;
    private java.awt.Panel panelSouth;
    private java.awt.Button buttonHelp;
    private java.awt.Button buttonQuit;
    // End of variables declaration//GEN-END:variables

}
