/*
 * ElFluenceLevelApp.java
 *
 * Created on June 25, 2001, 1:28 PM
 */

package saaps.saam;

import saaps.math.ProbCond;
import saaps.util.EventList;
import saaps.util.EventListDialog;
import saaps.util.EventRandomDialog;

import java.net.MalformedURLException;

import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import saaps.dbt.DatabaseRMI;

/**
 *
 * @author  root
 * @version 
 */
public class SumKpLevelApplet extends java.applet.Applet {

    //The events.
    private EventList eventList;
    
    //The non-events.
    private EventList nonEventList;

    private DatabaseRMI dbrmi = null;
    
    /** Initializes the applet ElFluenceLevelApplet */
    public void init () {
        try {
            dbrmi = (DatabaseRMI) Naming.lookup("//" + getCodeBase().getHost() +
            ":2001" + "/DatabaseRMIServer");
        }
        catch(NotBoundException nbe) {
            System.err.println(nbe);
        }
        catch(MalformedURLException murle) {
            System.err.println(murle);
        }
        catch(RemoteException re) {
            System.err.println(re);
        }
        initComponents ();
    }

    private void verifyInputFields() throws NumberFormatException {
        try {
            Integer.valueOf(textFieldTimeDelay.getText());
        }
        catch (NumberFormatException e) {
            throw new NumberFormatException("Please use integer for time delay.");
        }
        try {
            Double.valueOf(textFieldLevel.getText());
        }
        catch (NumberFormatException e) {
            throw new NumberFormatException("Please use double for threshold level.");
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        panel = new java.awt.Panel();
        labelTitle = new java.awt.Label();
        labelTimeDelay = new java.awt.Label();
        textFieldTimeDelay = new java.awt.TextField();
        labelTimeDelayUnit = new java.awt.Label();
        labelLevel = new java.awt.Label();
        textFieldLevel = new java.awt.TextField();
        textAreaResult = new java.awt.TextArea();
        panelBottom = new java.awt.Panel();
        buttonHelp = new java.awt.Button();
        panelTop = new java.awt.Panel();
        buttonEditEvents = new java.awt.Button();
        buttonEditNonEvents = new java.awt.Button();
        buttonRandomNonEvents = new java.awt.Button();
        buttonOptimize = new java.awt.Button();
        buttonRun = new java.awt.Button();
        
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        setBackground(new java.awt.Color(204, 204, 255));
        panel.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        panel.setFont(new java.awt.Font("Dialog", 0, 11));
        panel.setBackground(new java.awt.Color(255, 255, 102));
        panel.setForeground(java.awt.Color.black);
        labelTitle.setFont(new java.awt.Font("Dialog", 1, 14));
        labelTitle.setBackground(new java.awt.Color(255, 255, 102));
        labelTitle.setForeground(java.awt.Color.black);
        labelTitle.setText("Sum Kp");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 0;
        gridBagConstraints2.gridwidth = 6;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        panel.add(labelTitle, gridBagConstraints2);
        
        labelTimeDelay.setFont(new java.awt.Font("Dialog", 0, 11));
        labelTimeDelay.setBackground(new java.awt.Color(255, 255, 102));
        labelTimeDelay.setForeground(java.awt.Color.black);
        labelTimeDelay.setText("Time delay");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(15, 10, 0, 0);
        panel.add(labelTimeDelay, gridBagConstraints2);
        
        textFieldTimeDelay.setText("0");
        textFieldTimeDelay.setBackground(new java.awt.Color(255, 247, 233));
        textFieldTimeDelay.setFont(new java.awt.Font("Dialog", 0, 11));
        textFieldTimeDelay.setColumns(3);
        textFieldTimeDelay.setForeground(java.awt.Color.black);
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 1;
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.gridwidth = 2;
        gridBagConstraints2.gridheight = 3;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(15, 3, 0, 0);
        panel.add(textFieldTimeDelay, gridBagConstraints2);
        
        labelTimeDelayUnit.setFont(new java.awt.Font("Dialog", 0, 11));
        labelTimeDelayUnit.setBackground(new java.awt.Color(255, 255, 102));
        labelTimeDelayUnit.setForeground(java.awt.Color.black);
        labelTimeDelayUnit.setText("(days)");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 3;
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.gridwidth = 2;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(15, 2, 0, 0);
        panel.add(labelTimeDelayUnit, gridBagConstraints2);
        
        labelLevel.setFont(new java.awt.Font("Dialog", 0, 11));
        labelLevel.setBackground(new java.awt.Color(255, 255, 102));
        labelLevel.setForeground(java.awt.Color.black);
        labelLevel.setText("Threshold level");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 4;
        gridBagConstraints2.gridwidth = 2;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(19, 10, 0, 0);
        panel.add(labelLevel, gridBagConstraints2);
        
        textFieldLevel.setText("0");
        textFieldLevel.setBackground(new java.awt.Color(255, 247, 233));
        textFieldLevel.setFont(new java.awt.Font("Dialog", 0, 11));
        textFieldLevel.setColumns(8);
        textFieldLevel.setForeground(java.awt.Color.black);
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 2;
        gridBagConstraints2.gridy = 4;
        gridBagConstraints2.gridwidth = 2;
        gridBagConstraints2.gridheight = 3;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(19, 2, 0, 0);
        panel.add(textFieldLevel, gridBagConstraints2);
        
        textAreaResult.setBackground(new java.awt.Color(255, 247, 233));
        textAreaResult.setFont(new java.awt.Font("Dialog", 0, 11));
        textAreaResult.setColumns(20);
        textAreaResult.setForeground(java.awt.Color.black);
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 7;
        gridBagConstraints2.gridwidth = 7;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(19, 10, 0, 0);
        panel.add(textAreaResult, gridBagConstraints2);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 7;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.ipadx = 20;
        gridBagConstraints1.ipady = 20;
        gridBagConstraints1.insets = new java.awt.Insets(17, 10, 0, 0);
        add(panel, gridBagConstraints1);
        
        panelBottom.setBackground(new java.awt.Color(204, 204, 255));
        buttonHelp.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonHelp.setLabel("Help");
        buttonHelp.setName("button7");
        buttonHelp.setBackground(new java.awt.Color(204, 204, 204));
        buttonHelp.setForeground(java.awt.Color.black);
        buttonHelp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHelpActionPerformed(evt);
            }
        });
        
        panelBottom.add(buttonHelp);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridwidth = 7;
        gridBagConstraints1.gridheight = 2;
        add(panelBottom, gridBagConstraints1);
        
        panelTop.setBackground(new java.awt.Color(204, 204, 255));
        buttonEditEvents.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonEditEvents.setLabel("Edit Events ...");
        buttonEditEvents.setBackground(new java.awt.Color(204, 204, 204));
        buttonEditEvents.setForeground(java.awt.Color.black);
        buttonEditEvents.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonEditEventsActionPerformed(evt);
            }
        });
        
        panelTop.add(buttonEditEvents);
        
        buttonEditNonEvents.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonEditNonEvents.setLabel("Edit Non-Events ...");
        buttonEditNonEvents.setBackground(new java.awt.Color(204, 204, 204));
        buttonEditNonEvents.setForeground(java.awt.Color.black);
        buttonEditNonEvents.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonEditNonEventsActionPerformed(evt);
            }
        });
        
        panelTop.add(buttonEditNonEvents);
        
        buttonRandomNonEvents.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonRandomNonEvents.setLabel("Random Non-Events ...");
        buttonRandomNonEvents.setBackground(new java.awt.Color(204, 204, 204));
        buttonRandomNonEvents.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonRandomNonEventsActionPerformed(evt);
            }
        });
        
        panelTop.add(buttonRandomNonEvents);
        
        buttonOptimize.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonOptimize.setLabel("Optimize ...");
        buttonOptimize.setBackground(new java.awt.Color(204, 204, 204));
        buttonOptimize.setForeground(java.awt.Color.black);
        buttonOptimize.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonOptimizeActionPerformed(evt);
            }
        });
        
        panelTop.add(buttonOptimize);
        
        buttonRun.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonRun.setLabel("Run");
        buttonRun.setBackground(new java.awt.Color(204, 204, 204));
        buttonRun.setForeground(java.awt.Color.black);
        buttonRun.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonRunActionPerformed(evt);
            }
        });
        
        panelTop.add(buttonRun);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridwidth = 7;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(panelTop, gridBagConstraints1);
        
    }//GEN-END:initComponents

    private void buttonRandomNonEventsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonRandomNonEventsActionPerformed
      EventRandomDialog erd = new EventRandomDialog(this.getAppletFrame(),this.eventList);
      erd.setVisible(true);
      if (erd.isOK()) {
          this.nonEventList = erd.getEventList();
      }
    }//GEN-LAST:event_buttonRandomNonEventsActionPerformed

  private void buttonHelpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonHelpActionPerformed
// Add your handling code here:
    java.applet.AppletContext ac = getAppletContext();
    java.net.URL url = getDocumentBase();
    try
    {
      java.net.URL urlDoc = new java.net.URL(url,"SumKpLevelAppletHelp.html");
      ac.showDocument(urlDoc,"Sum Kp Level Help");
    }
    catch (java.net.MalformedURLException murle)
    {
      System.err.println(murle);
    }
  }//GEN-LAST:event_buttonHelpActionPerformed

  private void buttonRunActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonRunActionPerformed
      try {
          verifyInputFields();
          SumKpLevel skl = new SumKpLevel();
          skl.setEventList(this.eventList);
          skl.setNonEventList(this.nonEventList);
          int td = this.parseInteger(this.textFieldTimeDelay.getText());
          skl.setTimeDelay(td);
          double lev = this.parseDouble(this.textFieldLevel.getText());
          skl.setLevel(lev);
      /* send ref of skl to RMI and run calcStat */
          skl = dbrmi.sumKpLevelCalcStat(skl);
          /* skl.calcStat(); */
      /* ****** */
          this.textAreaResult.setText(skl.getRunText());
      }
      catch (Exception e) {
          new ErrorDialog(this.getAppletFrame(),e.getMessage());
      }
  }//GEN-LAST:event_buttonRunActionPerformed

  private int parseInteger(String x) {
      int y = 0;
      try {
          y = Integer.parseInt(x);
      }
      catch (NumberFormatException e) {
          System.err.println(e);
      }
      return y;
  }
  
  private double parseDouble(String x) {
      double y = 1e4;
      try {
          y = Double.valueOf(x).doubleValue();
      }
      catch (NumberFormatException e) {
          System.err.println(e);
      }
      return y;
  }
  
  private void buttonOptimizeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonOptimizeActionPerformed
      try {
          verifyInputFields();
          java.awt.Dialog dialog = new java.awt.Dialog(getAppletFrame(), "Optimizing ...", false);
          dialog.add(new java.awt.Label("Optimizing ..."));
          dialog.pack();
          dialog.setVisible(true);
          
          SumKpLevel skl = new SumKpLevel();
          skl.setEventList(this.eventList);
          skl.setNonEventList(this.nonEventList);
      /* send ref of skl to RMI and run the optimize */
          skl = dbrmi.sumKpLevelOptimize(skl);
      /* ****** */
          int td = skl.getTimeDelay();
          double level = skl.getLevel();
          
          dialog.dispose();
          
          this.textFieldTimeDelay.setText(Integer.toString(td));
          this.textFieldTimeDelay.setText(Integer.toString(td));
          this.textFieldLevel.setText(Double.toString(level));
          this.textFieldLevel.setText(Double.toString(level));
          
          //      ProbCond[] pc = efl.getProbCond();
          //      double[] pcxy = new double[pc.length];
          //      double[] pcyx = new double[pc.length];
          //      for (int i=0;i<pc.length;i++) {
          //          pcxy[i] = ( pc[i].xy[0][0] + pc[i].xy[0][0] ) / 2.0;
          //          pcyx[i] = ( pc[i].yx[0][0] + pc[i].yx[0][0] ) / 2.0;
          //      }
          
          this.textAreaResult.setText(skl.getOptText());
      }
      catch (NumberFormatException e) {
          new ErrorDialog(this.getAppletFrame(),e.getMessage());
      }
      catch (Exception e) {
          System.err.println(e);
      }
  }//GEN-LAST:event_buttonOptimizeActionPerformed
  
  private void buttonEditNonEventsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonEditNonEventsActionPerformed
// Add your handling code here:
      EventListDialog eld = new EventListDialog(getAppletFrame(),"Non-Event list",this.nonEventList);
      eld.setVisible(true);
      if (eld.isOK()) {
          this.nonEventList = eld.getEventList();
      }
  }//GEN-LAST:event_buttonEditNonEventsActionPerformed

  private void buttonEditEventsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonEditEventsActionPerformed
// Add your handling code here:
      EventListDialog eld = new EventListDialog(getAppletFrame(),"Event list",this.eventList);
      eld.setVisible(true);
      if (eld.isOK()) {
          this.eventList = eld.getEventList();
      }
  }//GEN-LAST:event_buttonEditEventsActionPerformed

    private java.awt.Frame getAppletFrame() {
        java.awt.Component curr = this;
        while (!(curr instanceof java.awt.Frame))
            curr = curr.getParent();
        return (java.awt.Frame) curr;
    }
 
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.Panel panel;
    private java.awt.Label labelTitle;
    private java.awt.Label labelTimeDelay;
    private java.awt.TextField textFieldTimeDelay;
    private java.awt.Label labelTimeDelayUnit;
    private java.awt.Label labelLevel;
    private java.awt.TextField textFieldLevel;
    private java.awt.TextArea textAreaResult;
    private java.awt.Panel panelBottom;
    private java.awt.Button buttonHelp;
    private java.awt.Panel panelTop;
    private java.awt.Button buttonEditEvents;
    private java.awt.Button buttonEditNonEvents;
    private java.awt.Button buttonRandomNonEvents;
    private java.awt.Button buttonOptimize;
    private java.awt.Button buttonRun;
    // End of variables declaration//GEN-END:variables

}
