/*
 * AnomModelPlotApp.java
 *
 * Created on August 16, 2001, 1:45 PM
 */

package saaps.sapm;

import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;

import saaps.util.InfoDialog;
import saaps.util.Model;
import saaps.util.ModelList;
import saaps.util.ModelMetaDataFrame;
import saaps.util.TimeSeries;
import saaps.util.AppHelp;

/**
 *
 * @author  root
 * @version 
 */
public class AnomModelPlotApp extends java.awt.Panel {

    //The models list.
    private ModelList modelList = new ModelList();
    
    //Calendar object for date and time calculations.
    private Calendar cal = Calendar.getInstance(TimeZone.getTimeZone("GMT"));

    private AppHelp help = null;
    
    /** Creates new form AnomModelPlotApp */
    public AnomModelPlotApp(java.awt.Frame frame) {
        this.parentFrame = frame;
        //Set up the components.
        this.setLayout(new java.awt.BorderLayout());
        this.initComponents ();
//        this.panelPlotArea.setSize(500,400);
        this.panelPlotArea.setPreferredSize(new java.awt.Dimension(410,310));
        //Init the model list.
        this.initListModel();
        //Set to todays date
        this.getToday();
        //Plot using first model.
        this.listModel.select(0);
//        this.createPlot(0);
//        this.setSize(560,400);
//        this.setPreferredSize(new java.awt.Dimension(560,400));
//        this.repaint();
//        this.pack ();
    }
    
    private void initListModel() {
        String[] list = this.modelList.getListString();
        for (int i=0;i<list.length;i++) this.listModel.add(list[i]);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        labelTitle = new java.awt.Label();
        panelLeft = new java.awt.Panel();
        panelModel = new java.awt.Panel();
        labelModelList = new java.awt.Label();
        listModel = new java.awt.List();
        buttonInspect = new java.awt.Button();
        panelYMD = new java.awt.Panel();
        labelYear = new java.awt.Label();
        textFieldYear = new java.awt.TextField();
        labelMonth = new java.awt.Label();
        textFieldMonth = new java.awt.TextField();
        labelDay = new java.awt.Label();
        textFieldDay = new java.awt.TextField();
        panelPlotArea = new java.awt.Panel();
        panelButtons = new java.awt.Panel();
        buttonToday = new java.awt.Button();
        buttonPlot = new java.awt.Button();
        buttonHelp = new java.awt.Button();
        buttonQuit = new java.awt.Button();
        
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        labelTitle.setAlignment(java.awt.Label.CENTER);
        labelTitle.setBackground(new java.awt.Color(204, 204, 204));
        labelTitle.setFont(new java.awt.Font("Dialog", 1, 18));
        labelTitle.setForeground(java.awt.Color.black);
        labelTitle.setName("label1");
        labelTitle.setText("Anomaly Prediction Model");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridwidth = 2;
        gridBagConstraints2.insets = new java.awt.Insets(0, 20, 0, 20);
        add(labelTitle, gridBagConstraints2);
        
        panelLeft.setLayout(new java.awt.GridLayout(2, 1));
        
        panelLeft.setBackground(new java.awt.Color(204, 204, 204));
        panelLeft.setFont(new java.awt.Font("Dialog", 0, 11));
        panelLeft.setForeground(java.awt.Color.black);
        panelLeft.setName("panel30");
        panelModel.setLayout(new java.awt.BorderLayout());
        
        panelModel.setBackground(new java.awt.Color(204, 204, 204));
        panelModel.setFont(new java.awt.Font("Dialog", 0, 11));
        panelModel.setForeground(java.awt.Color.black);
        panelModel.setName("panel4");
        labelModelList.setBackground(new java.awt.Color(204, 204, 204));
        labelModelList.setFont(new java.awt.Font("Dialog", 0, 11));
        labelModelList.setForeground(java.awt.Color.black);
        labelModelList.setName("label9");
        labelModelList.setText("Model List");
        panelModel.add(labelModelList, java.awt.BorderLayout.NORTH);
        
        listModel.setBackground(new java.awt.Color(255, 247, 233));
        listModel.setFont(new java.awt.Font("Dialog", 0, 11));
        listModel.setForeground(java.awt.Color.black);
        listModel.setName("list1");
        panelModel.add(listModel, java.awt.BorderLayout.CENTER);
        
        buttonInspect.setBackground(new java.awt.Color(204, 204, 204));
        buttonInspect.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonInspect.setForeground(java.awt.Color.black);
        buttonInspect.setLabel("Inspect model");
        buttonInspect.setName("button6");
        buttonInspect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonInspectActionPerformed(evt);
            }
        });
        
        panelModel.add(buttonInspect, java.awt.BorderLayout.SOUTH);
        
        panelLeft.add(panelModel);
        
        panelYMD.setLayout(new java.awt.GridLayout(3, 2));
        
        panelYMD.setBackground(new java.awt.Color(204, 204, 204));
        panelYMD.setFont(new java.awt.Font("Dialog", 0, 11));
        panelYMD.setForeground(java.awt.Color.black);
        panelYMD.setName("panel5");
        labelYear.setBackground(new java.awt.Color(204, 204, 204));
        labelYear.setFont(new java.awt.Font("Dialog", 0, 11));
        labelYear.setForeground(java.awt.Color.black);
        labelYear.setName("label10");
        labelYear.setText("Year");
        panelYMD.add(labelYear);
        
//        textFieldYear.setText("2001");
        textFieldYear.setBackground(new java.awt.Color(255, 247, 233));
        textFieldYear.setFont(new java.awt.Font("Dialog", 0, 11));
        textFieldYear.setForeground(java.awt.Color.black);
        textFieldYear.setName("textfield1");
        panelYMD.add(textFieldYear);
        
        labelMonth.setBackground(new java.awt.Color(204, 204, 204));
        labelMonth.setFont(new java.awt.Font("Dialog", 0, 11));
        labelMonth.setForeground(java.awt.Color.black);
        labelMonth.setName("label11");
        labelMonth.setText("Month");
        panelYMD.add(labelMonth);
        
//        textFieldMonth.setText("01");
        textFieldMonth.setBackground(new java.awt.Color(255, 247, 233));
        textFieldMonth.setFont(new java.awt.Font("Dialog", 0, 11));
        textFieldMonth.setForeground(java.awt.Color.black);
        textFieldMonth.setName("textfield2");
        panelYMD.add(textFieldMonth);
        
        labelDay.setBackground(new java.awt.Color(204, 204, 204));
        labelDay.setFont(new java.awt.Font("Dialog", 0, 11));
        labelDay.setForeground(java.awt.Color.black);
        labelDay.setName("label12");
        labelDay.setText("Day");
        panelYMD.add(labelDay);
        
//        textFieldDay.setText("01");
        textFieldDay.setBackground(new java.awt.Color(255, 247, 233));
        textFieldDay.setFont(new java.awt.Font("Dialog", 0, 11));
        textFieldDay.setForeground(java.awt.Color.black);
        textFieldDay.setName("textfield3");
        panelYMD.add(textFieldDay);
        
        panelLeft.add(panelYMD);
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        add(panelLeft, gridBagConstraints2);
        
        panelPlotArea.setBackground(new java.awt.Color(204, 204, 204));
        panelPlotArea.setFont(new java.awt.Font("Dialog", 0, 11));
        panelPlotArea.setForeground(java.awt.Color.black);
        panelPlotArea.setName("panel7");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        add(panelPlotArea, gridBagConstraints2);
        
        panelButtons.setBackground(new java.awt.Color(204, 204, 204));
        panelButtons.setFont(new java.awt.Font("Dialog", 0, 11));
        panelButtons.setForeground(java.awt.Color.black);
        panelButtons.setName("panel6");
        buttonToday.setBackground(new java.awt.Color(204, 204, 204));
        buttonToday.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonToday.setForeground(java.awt.Color.black);
        buttonToday.setLabel("Today");
        buttonToday.setName("button7");
        buttonToday.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonTodayActionPerformed(evt);
            }
        });
        
        panelButtons.add(buttonToday);
        
        buttonPlot.setBackground(new java.awt.Color(204, 204, 204));
        buttonPlot.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonPlot.setForeground(java.awt.Color.black);
        buttonPlot.setLabel("Plot");
        buttonPlot.setName("button8");
        buttonPlot.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonPlotActionPerformed(evt);
            }
        });
        
        panelButtons.add(buttonPlot);
        
        buttonHelp.setBackground(new java.awt.Color(204, 204, 204));
        buttonHelp.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonHelp.setForeground(java.awt.Color.black);
        buttonHelp.setLabel("Help");
        buttonHelp.setName("button9");
        buttonHelp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHelpActionPerformed(evt);
            }
        });
        
        panelButtons.add(buttonHelp);
        
        buttonQuit.setBackground(new java.awt.Color(204, 204, 204));
        buttonQuit.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonQuit.setForeground(java.awt.Color.black);
        buttonQuit.setLabel("Quit");
        buttonQuit.setName("button10");
        buttonQuit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonQuitActionPerformed(evt);
            }
        });
        
        panelButtons.add(buttonQuit);
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridy = 3;
        gridBagConstraints2.gridwidth = 2;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(panelButtons, gridBagConstraints2);
        
    }//GEN-END:initComponents

    private void buttonHelpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonHelpActionPerformed
      System.out.println("Launching help frame ...");
      if(help != null) {
          help.setVisible(true);
      }
      else {
        /* Get a Class object from this object and then the Name of the class to use as help fi */
          help = AppHelp.getAppHelp(this.getClass().getName());
      }
    }//GEN-LAST:event_buttonHelpActionPerformed

  private void buttonInspectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonInspectActionPerformed
// Add your handling code here:
      int selectedModel = this.listModel.getSelectedIndex();
      if (selectedModel<0) {
          new InfoDialog(this.parentFrame,"Error","You must first select a model!",32).show();
      }
      else {
          new ModelMetaDataFrame(selectedModel).show();
      }
  }//GEN-LAST:event_buttonInspectActionPerformed

  private void buttonQuitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonQuitActionPerformed
      if(help != null)
          help.dispose();

      this.parentFrame.dispose();
  }//GEN-LAST:event_buttonQuitActionPerformed

  private void buttonTodayActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonTodayActionPerformed
// Add your handling code here:
      this.getToday();
  }//GEN-LAST:event_buttonTodayActionPerformed

  private void getToday() {
      this.cal.setTime(new Date());
      String s = String.valueOf(cal.get(Calendar.YEAR));
      this.textFieldYear.setText(s);
      s = String.valueOf(cal.get(Calendar.MONTH)+1);
      if (s.length()<2) s = "0" + s;
      this.textFieldMonth.setText(s);
      s = String.valueOf(cal.get(Calendar.DATE));
      if (s.length()<2) s = "0" + s;
      this.textFieldDay.setText(s);
  }
  
  private void buttonPlotActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonPlotActionPerformed
      try {
          //Get the selected model.
      int i = this.listModel.getSelectedIndex();
      //If no model has been selected display an error dialog,
      if (i<0) {
          new InfoDialog(this.parentFrame,"Error","You must first select a model!",32).show();
      }
      //else create the plot.
      else {
          this.createPlot(i);
      }
      }
      catch (NumberFormatException e) {
          new saaps.saam.ErrorDialog(this.parentFrame,"Incorrect date format.");
      }
  }//GEN-LAST:event_buttonPlotActionPerformed

  private void createPlot(int modelIndex) throws NumberFormatException {
      //The width and height of the plot.
//      int width = this.panelPlotArea.getWidth();
//      int height = this.panelPlotArea.getHeight();
      int width = 400;
      int height = 300;
      //Create the plot.
      AnomModelPlot plot = new AnomModelPlot(width,height);
      //Remove old plot if it exist.
      java.awt.Component[] comp = this.panelPlotArea.getComponents();
      if (comp.length>0) this.panelPlotArea.remove(comp[0]);
      //Add new plot to the panel.
      this.panelPlotArea.add(plot);
      //Get the model.
      Model model = this.modelList.getModel(modelIndex);
      System.out.println(model.getName());
      //Get the end date.
      Date d2 = this.getEndDate();
      //Get the start date.
      Date d1 = this.getStartDate(d2);
      //Read the time series.
      model.readTimeSeries(d1,d2);
      //Run the model.
      model.run();
      //Get the output.
      TimeSeries ts = model.getOutput();
      //Plot the data.
      plot.setData(ts,0.0,100.0);
      plot.repaint();
      parentFrame.pack();
  }
  
  private Date getEndDate() throws NumberFormatException {
      Date date = null;
      int y = Integer.parseInt(this.textFieldYear.getText());
      int m = Integer.parseInt(this.textFieldMonth.getText()) - 1;
      int d = Integer.parseInt(this.textFieldDay.getText());
      this.cal.clear();
      this.cal.set(Calendar.YEAR,y);
      this.cal.set(Calendar.MONTH,m);
      this.cal.set(Calendar.DATE,d);
      //Add one day.
      cal.add(Calendar.DATE,1);
      date = cal.getTime();
      return date;
  }
  
  private Date getStartDate(Date d) {
      //Go back 15 days.
      cal.setTime(d);
      cal.add(Calendar.DATE,-15);
      return cal.getTime();
  }
  
  public static void getAnomModelPlotApp() {
      final java.awt.Frame myFrame = new java.awt.Frame();
      myFrame.addWindowListener(new java.awt.event.WindowAdapter() {
          public void windowClosing(java.awt.event.WindowEvent evt) {
              /** Exit the Application */
              myFrame.dispose();
              System.exit(0);
          }
      }
      );
      myFrame.setBackground(new java.awt.Color(204, 204, 204));
      myFrame.setLayout(new java.awt.BorderLayout());
      //myFrame.setSize(1000,800);
      //      myFrame.setLayout(new java.awt.GridBagLayout());
      //Setup constraints for filling out SEAApp panel
      //      java.awt.GridBagConstraints gridBagConstraints1 = new java.awt.GridBagConstraints();
      //      gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
      //      gridBagConstraints1.weightx = 1.0;
      //      gridBagConstraints1.weighty = 1.0;
      myFrame.setName("Anomaly Prediction Model");
      myFrame.setTitle("Anomaly Prediction Model");
      //      myFrame.add(new AnomModelPlotApp(myFrame),gridBagConstraints1);
      java.awt.Panel panel = new AnomModelPlotApp(myFrame);
      System.out.println(panel);
      myFrame.add(panel,java.awt.BorderLayout.CENTER);
      myFrame.pack();
      myFrame.show();
  }
  
  /** Exit the Application */
  /**
   * @param args the command line arguments
   */
  public static void main(String args[]) {
/*      final java.awt.Frame myFrame = new java.awt.Frame();
      myFrame.addWindowListener(new java.awt.event.WindowAdapter() {
          public void windowClosing(java.awt.event.WindowEvent evt) {
              myFrame.dispose();
              System.exit (0);
          }
      }
      );
      myFrame.setBackground(new java.awt.Color (204, 204, 204));
      myFrame.setLayout(new java.awt.GridBagLayout());
      //Setup constraints for filling out SEAApp panel
      java.awt.GridBagConstraints gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
      gridBagConstraints1.weightx = 1.0;
      gridBagConstraints1.weighty = 1.0;
      myFrame.setName("Anomaly Prediction Model");
      myFrame.setTitle("Anomaly Prediction Model");
      myFrame.add(new AnomModelPlotApp(myFrame),gridBagConstraints1);
      myFrame.pack();
      myFrame.show();*/
      AnomModelPlotApp.getAnomModelPlotApp();
  }
  
  private java.awt.Frame parentFrame;
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private java.awt.Label labelTitle;
  private java.awt.Panel panelLeft;
  private java.awt.Panel panelModel;
  private java.awt.Label labelModelList;
  private java.awt.List listModel;
  private java.awt.Button buttonInspect;
  private java.awt.Panel panelYMD;
  private java.awt.Label labelYear;
  private java.awt.TextField textFieldYear;
  private java.awt.Label labelMonth;
  private java.awt.TextField textFieldMonth;
  private java.awt.Label labelDay;
  private java.awt.TextField textFieldDay;
  private java.awt.Panel panelPlotArea;
  private java.awt.Panel panelButtons;
  private java.awt.Button buttonToday;
  private java.awt.Button buttonPlot;
  private java.awt.Button buttonHelp;
  private java.awt.Button buttonQuit;
  // End of variables declaration//GEN-END:variables

}
