/*
 * AnomModelPlotTest.java
 *
 * Created on July 3, 2001, 11:22 AM
 */

package saaps.sapm;

import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;

import saaps.util.Model;
import saaps.util.ModelList;
import saaps.util.TimeSeries;

/**
 *
 * @author  root
 * @version 
 */
public class AnomModelPlotTest extends java.awt.Frame {

    private Calendar cal = Calendar.getInstance(TimeZone.getTimeZone("GMT"));
    
    /** Creates new form AnomModelPlotTest */
    public AnomModelPlotTest(int modelIndex, int year, int month, int day) {
        initComponents ();
        int width = 400;
        int height = 300;
//        this.panelPlot.setSize(width,height);
        //Set the plot end date.
        cal.clear();
        cal.set(Calendar.YEAR,year);
        cal.set(Calendar.MONTH,month);
        cal.set(Calendar.DATE,day);
        Date d2 = cal.getTime();
        //Set the plot start date.
        cal.add(Calendar.DATE,-15);
        Date d1 = cal.getTime();
        //Create the plot.
        AnomModelPlot plot = new AnomModelPlot(width,height);
        //Add it to the panel.
        this.panelPlot.add(plot);
        //Get the model.
        ModelList ml = new ModelList();
        Model model = ml.getModel(modelIndex);
        System.out.println(model.getName());
        //Set the prediction time.
//        model.setPredictionTime(d);
        model.readTimeSeries(d1,d2);
        //Run the model.
        model.run();
        //Get the output.
        TimeSeries ts = model.getOutput();
        System.out.println(ts.getLength());
        for (int i=0;i<ts.getLength();i++) {
            cal.setTime(ts.getDate(i));
            System.out.println(cal.getTime() + " " + ts.getData(i,0));
        }
        //Plot.
        plot.setData(ts,0.0,100.0);
        plot.repaint();
//        plot.setVisible(true);
        pack ();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        panelPlot = new java.awt.Panel();
        setLayout(new java.awt.FlowLayout());
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        }
        );
        
        panelPlot.setFont(new java.awt.Font ("Dialog", 0, 11));
        panelPlot.setName("panel8");
        panelPlot.setBackground(new java.awt.Color (204, 204, 204));
        panelPlot.setForeground(java.awt.Color.black);
        
        add(panelPlot);
        
    }//GEN-END:initComponents

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit (0);
    }//GEN-LAST:event_exitForm

    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
        //Get the model to run.
        int modelIndex = Integer.parseInt(args[0]);
        //Get the date.
        int year = Integer.parseInt(args[1]);
        int month = Integer.parseInt(args[2])-1;
        int day = Integer.parseInt(args[3]);
        //Create the plot.
        new AnomModelPlotTest(modelIndex,year,month,day).show();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.Panel panelPlot;
    // End of variables declaration//GEN-END:variables

}
