/*
 * StopLightCanvas.java
 *
 * Created on November 21, 2000, 3:23 PM
 */
 
package saaps.sapm;

import java.awt.*;

/** 
 *
 * @author  saaps
 * @version 
 */
public class StopLightCanvas extends java.awt.Canvas {

  //The width and height of the stop light.
  private int width;
  private int height;
/*  //The position and size for an on-lamp.
  private int onX;
  private int onY;
  private int onW;
  private int onH;
  //The position and size for an off-lamp.
  private int offX;
  private int offY;
  private int offW;
  private int offH;
  //Red light colour.
  private int[] red = new int[3];
  //Yellow light colour.
  private int[] yellow = new int[3];
  //Green light colour.
  private int[] green = new int[3];*/
  //The state.
  private int state;
  public static int RED = 0;
  public static int YELLOW = 1;
  public static int GREEN = 2;
  
  //The lamps.
  private Lamp redLamp;
  private Lamp yellowLamp;
  private Lamp greenLamp;
  
  /** Creates new StopLightCanvas */
  public StopLightCanvas() {
    this(50);
  }
  
  public StopLightCanvas(int w)
  {
    width = w;
    height = width*13/5;
/*    offX = width/5;
    offY = offX;
    offW = width - 2*offX;
    offH = offW;
    onX = width/6;
    onY = onX;
    onW = width - 2*onX;
    onH = onW;*/
    redLamp = new Lamp(RED);
    yellowLamp = new Lamp(YELLOW);
    greenLamp = new Lamp(GREEN);
    setSize(width,height);
    setGreen();
  }
  
/*  private void setRedOff()
  {
    red[0] = 125;
    red[1] = 0;
    red[2] = 0;
  }
  
  private void setRedOn()
  {
    red[0] = 255;
    red[1] = 0;
    red[2] = 0;
  }
  
  private void setYellowOff()
  {
    yellow[0] = 125;
    yellow[1] = 125;
    yellow[2] = 0;
  }

  private void setYellowOn()
  {
    yellow[0] = 255;
    yellow[1] = 255;
    yellow[2] = 0;
  }

  private void setGreenOn()
  {
    green[0] = 0;
    green[1] = 255;
    green[2] = 0;
  }
  
  private void setGreenOff()
  {
    green[0] = 0;
    green[1] = 125;
    green[2] = 0;
  }*/
  
  public void setRed()
  {
    redLamp.on();
    yellowLamp.off();
    greenLamp.off();
//    setRedOn();
//    setYellowOff();
//    setGreenOff();
    state = RED;
    super.repaint();
  }
  
  public void setYellow()
  {
    redLamp.off();
    yellowLamp.on();
    greenLamp.off();
//    setRedOff();
//    setYellowOn();
//    setGreenOff();
    state = YELLOW;
    super.repaint();
  }
  
  public void setGreen()
  {
    redLamp.off();
    yellowLamp.off();
    greenLamp.on();
//    setRedOff();
//    setYellowOff();
//    setGreenOn();
    state = GREEN;
    super.repaint();
  }
  
  public void setState(int s)
  {
    state = s;
    switch (state)
    {
      case 0:
        setRed();
        break;
      case 1:
        setYellow();
        break;
      case 2:
        setGreen();
        break;
      default:
        setGreen();
        break;
    }
  }
  
  public int getState()
  {
    return state;
  }
  
  public void paint(Graphics gr)
  {
    //Black box.
    Color col = new Color(0,0,0);
    gr.fillRect(0,0,width,height);
    //Red
    redLamp.draw(gr);
//    col = new Color(red[0],red[1],red[2]);
//    gr.setColor(col);
//    gr.fillOval(10,10,30,30);
    //Yellow
    yellowLamp.draw(gr);
//    col = new Color(yellow[0],yellow[1],yellow[2]);
//    gr.setColor(col);
//    gr.fillOval(10,50,30,30);
    //Green
    greenLamp.draw(gr);
//    col = new Color(green[0],green[1],green[2]);
//    gr.setColor(col);
//    gr.fillOval(10,90,30,30);
  }  
  
  class Lamp
  {
    private int type;
    private int xOff;
    private int yOff;
    private int dOff;
    private int xOn;
    private int yOn;
    private int dOn;
    private Color cOn;
    private Color cOff;
    private boolean state;
    
    protected Lamp(int t)
    {
      type = t;
      state = false;
      if(type==RED)
      {
        cOff = new Color(125,0,0);
        cOn = new Color(255,0,0);
        xOff=width/5;
        yOff=xOff;
        dOff=width-2*xOff;
        xOn=width/8;
        yOn=xOn;
        dOn=width-2*xOn;
      }
      if(type==YELLOW)
      {
        cOff = new Color(125,125,0);
        cOn = new Color(255,255,0);
        xOff=width/5;
        dOff=width-2*xOff;
        yOff=width;
        xOn=width/8;
        dOn=width-2*xOn;
        yOn=width-xOn;
      }
      if(type==GREEN)
      {
        cOff = new Color(0,125,0);
        cOn = new Color(0,255,0);
        xOff=width/5;
        dOff=width-2*xOff;
        yOff=2*width-xOff;
        xOn=width/8;
        dOn=width-2*xOn;
        yOn=width+dOff+xOn;
      }
    }
    
    protected void off()
    {
      state = false;
    }
    
    protected void on()
    {
      state = true;
    }
    
    protected void draw(Graphics g)
    {
      if(state)
      {
        g.setColor(cOn);
        g.fillOval(xOn,yOn,dOn,dOn);
      }
      else
      {
        g.setColor(cOff);
        g.fillOval(xOff,yOff,dOff,dOff);
      }
    }
  }
}