/*
 * EventRandomDialog.java
 *
 * Created on September 4, 2001, 8:37 PM
 */

package saaps.util;

import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;
import java.util.Vector;

/**
 *
 * @author  root
 * @version 
 */
public class EventRandomDialog extends java.awt.Dialog {

    private boolean ok = false;
    
    private Date startDate;
    private Date endDate;
    private Vector randomEvents;
    
    private Calendar cal = Calendar.getInstance(TimeZone.getTimeZone("GMT"));
    private java.awt.Frame parent;
    
    /** Creates new form EventRandomDialog */
    public EventRandomDialog(java.awt.Frame parent,boolean modal) {
        super (parent, modal);
        this.parent=parent;
        initComponents ();
        pack ();
    }
    
    public EventRandomDialog(java.awt.Frame parent, EventList el) {
        super(parent,true);
        this.parent=parent;
        this.initComponents();
        this.textFieldNumOfRandom.setText(Integer.toString(el.getNumOfEvents()));
        this.pack();
        Date[] events = new Date[el.getNumOfEvents()];
        events[0] = el.getEvent(0);
        this.startDate = el.getEvent(0);
        this.endDate = el.getEvent(0);
        for (int i=1;i<el.getNumOfEvents();i++) {
            events[i] = el.getEvent(i);
//            if (this.startDate.after(el.getEvent(i))) this.startDate = el.getEvent(i);
//            if (this.endDate.before(el.getEvent(i))) this.endDate = el.getEvent(i);
            if (this.startDate.after(events[i])) this.startDate = events[i];
            if (this.endDate.before(events[i])) this.endDate = events[i];
        }
        long range = this.endDate.getTime() - this.startDate.getTime();
        int numOfDays = (int) ((range/24L/3600L/1000L)+1L);
//        System.out.println("Number of days in range = " + numOfDays);
        this.randomEvents = new Vector(numOfDays);
        this.cal.setTime(this.startDate);
        boolean addEvent = false;
        double diff = 0;
        long currTime = 0L;
        for (int i=0;i<numOfDays;i++) {
            addEvent = true;
            currTime = cal.getTime().getTime();
            for (int j=0;j<events.length;j++) {
                diff = (double) (currTime - events[j].getTime())/24L/3600L/1000L;
                if (Math.abs(diff)<0.5) addEvent = false;
            }
            if (addEvent) {
                this.randomEvents.addElement(cal.getTime());
            }
            this.cal.add(Calendar.DATE,1);
        }
        this.randomEvents.trimToSize();
//        System.out.println("Number of possible random events = " + this.randomEvents.size());
    }

    public EventList getEventList() {
        Date[] eventDates = null;
        int numOfEvents = Integer.valueOf(this.textFieldNumOfRandom.getText()).intValue();
        if (numOfEvents < this.randomEvents.size()) {
            eventDates = new Date[numOfEvents];
            for (int i=0;i<eventDates.length;i++) {
                int j = (int) (Math.random()*this.randomEvents.size());
                eventDates[i] = (Date) this.randomEvents.elementAt(j);
                this.randomEvents.removeElementAt(j);
            }
        }
        else {
            eventDates = new Date[this.randomEvents.size()];
            for (int i=0;i<eventDates.length;i++) {
                eventDates[i] = (Date) this.randomEvents.elementAt(i);
            }
        }
/*        Date[] eventDates = new Date[numOfEvents];
        long startTime = this.startDate.getTime();
        long endTime = this.endDate.getTime();
        double range = endTime - startTime;
        for (int i=0;i<eventDates.length;i++) {
            long time = Math.round(Math.random()*range) + startTime;
            eventDates[i] = new Date(time);
        }*/
        return new EventList(eventDates);
    }
    
    public boolean isOK() {
        return this.ok;
    }
    
    /** This method is called from within the init() method to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        panelSouth = new java.awt.Panel();
        buttonHelp = new java.awt.Button();
        buttonCancel = new java.awt.Button();
        buttonOK = new java.awt.Button();
        panelNorth = new java.awt.Panel();
        labelNumOfRandom = new java.awt.Label();
        textFieldNumOfRandom = new java.awt.TextField();
        setLayout(new java.awt.BorderLayout());
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        }
        );
        
        panelSouth.setFont(new java.awt.Font ("Dialog", 0, 11));
        panelSouth.setName("panel48");
        panelSouth.setBackground(new java.awt.Color (204, 204, 204));
        panelSouth.setForeground(java.awt.Color.black);
        
        buttonHelp.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonHelp.setLabel("Help");
          buttonHelp.setName("button86");
          buttonHelp.setBackground(new java.awt.Color (204, 204, 204));
          buttonHelp.setForeground(java.awt.Color.black);
          panelSouth.add(buttonHelp);
          
          
        buttonCancel.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonCancel.setLabel("Cancel");
          buttonCancel.setName("button87");
          buttonCancel.setBackground(new java.awt.Color (204, 204, 204));
          buttonCancel.setForeground(java.awt.Color.black);
          buttonCancel.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonCancelActionPerformed(evt);
              }
          }
          );
          panelSouth.add(buttonCancel);
          
          
        buttonOK.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonOK.setLabel("OK");
          buttonOK.setName("button88");
          buttonOK.setBackground(new java.awt.Color (204, 204, 204));
          buttonOK.setForeground(java.awt.Color.black);
          buttonOK.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonOKActionPerformed(evt);
              }
          }
          );
          panelSouth.add(buttonOK);
          
          
        add(panelSouth, java.awt.BorderLayout.SOUTH);
        
        
        panelNorth.setFont(new java.awt.Font ("Dialog", 0, 11));
        panelNorth.setName("panel49");
        panelNorth.setBackground(new java.awt.Color (204, 204, 204));
        panelNorth.setForeground(java.awt.Color.black);
        
        labelNumOfRandom.setFont(new java.awt.Font ("Dialog", 0, 11));
          labelNumOfRandom.setName("label41");
          labelNumOfRandom.setBackground(new java.awt.Color (204, 204, 204));
          labelNumOfRandom.setForeground(java.awt.Color.black);
          labelNumOfRandom.setText("Number of random events");
          panelNorth.add(labelNumOfRandom);
          
          
        textFieldNumOfRandom.setBackground(new java.awt.Color (255, 247, 233));
          textFieldNumOfRandom.setName("textfield6");
          textFieldNumOfRandom.setFont(new java.awt.Font ("Dialog", 0, 11));
          textFieldNumOfRandom.setColumns(6);
          textFieldNumOfRandom.setForeground(java.awt.Color.black);
          panelNorth.add(textFieldNumOfRandom);
          
          
        add(panelNorth, java.awt.BorderLayout.NORTH);
        
    }//GEN-END:initComponents

  private void buttonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonOKActionPerformed
      try {
          Integer.valueOf(this.textFieldNumOfRandom.getText());
          this.ok = true;
          this.dispose();
      }
      catch (NumberFormatException e) {
          new saaps.saam.ErrorDialog(this.parent,"Please use integer for number of events.");
      }
  }//GEN-LAST:event_buttonOKActionPerformed

  private void buttonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCancelActionPerformed
// Add your handling code here:
      this.ok = false;
      this.dispose();
  }//GEN-LAST:event_buttonCancelActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible (false);
        dispose ();
    }//GEN-LAST:event_closeDialog

    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
        new EventRandomDialog (new java.awt.Frame (), true).show ();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.Panel panelSouth;
    private java.awt.Button buttonHelp;
    private java.awt.Button buttonCancel;
    private java.awt.Button buttonOK;
    private java.awt.Panel panelNorth;
    private java.awt.Label labelNumOfRandom;
    private java.awt.TextField textFieldNumOfRandom;
    // End of variables declaration//GEN-END:variables

}
