/*
 * PlotFrameTest.java
 *
 * Created on August 16, 2000, 4:58 PM
 */
 
package saaps.util;

import java.util.Date;
import Jama.Matrix;

/** 
 *
 * @author  saaps
 * @version 
 */
public class PlotFrameTest extends java.awt.Frame {

  private TimeSeriesPlot tsp;
  
  /** Creates new form PlotFrameTest */
  public PlotFrameTest(TimeSeriesPlot t) {
    tsp = t;
    add(tsp);
    initComponents ();
    pack ();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    setLayout (new java.awt.FlowLayout ());
    addWindowListener (new java.awt.event.WindowAdapter () {
      public void windowClosing (java.awt.event.WindowEvent evt) {
        exitForm (evt);
      }
    }
    );

  }//GEN-END:initComponents

  /** Exit the Application */
  private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
    System.exit (0);
  }//GEN-LAST:event_exitForm

  /**
  * @param args the command line arguments
  */
  public static void main (String args[]) {
//    Date[] l = {new Date(-1000L), new Date(0L), new Date(1000L), new Date(2000L), new Date(3000L)};
//    double[][] d = {{0.0,1.3},{1.0,2.9},{4.0,8.3},{9.0,5.4},{16.0,5.1}};
//    TimeSeries ts = new TimeSeries(l,new Jama.Matrix(d));
    //Get Kp data for the last week.
    Date endDate = new Date();
    //Add one day to end date.
    endDate = new Date(endDate.getTime() + 24L*60L*60L*1000L);
    Date startDate = new Date(endDate.getTime() - 7L*24L*60L*60L*1000L);
    saaps.dbt.Database db = saaps.dbt.Database.getInstance("KpDB");
    TimeSeries ts = null;
    try {
        ts = db.retrieveTS(startDate,endDate,true);
        db.close();
    }
    catch (java.io.IOException e) {
        System.err.println(e);
        System.exit(0);
    }
    //Print the ts.
    System.out.println("Length=" + ts.getLength());
    System.out.println("NumOfDataFields=" + ts.getNumOfDataFields());
    for (int i=0;i<ts.getLength();i++) {
        System.out.print(ts.getDate(i));
        double[] tmp = ts.getData(i);
        for (int j=0;j<tmp.length;j++) {
            System.out.print(" " + tmp[j]);
        }
        System.out.println();
    }
    //Set plot parameters.
    int xField = -1;
    int[] yFields = {0,1};
    boolean lines = true;
    boolean points = false;
    boolean xLog = false;
    boolean yLog = false;
    String xLabel = "Time";
    String[] yLabels = {"Kp","Status"};    
    //Create the plot.
    PlotFrame pf = new PlotFrame(ts,xField,yFields,lines,points,xLog,yLog);
//    PlotFrame pf = new PlotFrame(ts);
    pf.show();
    //TimeSeriesPlot tsp = new TimeSeriesPlot(ts);
    //PlotFrameTest pft = new PlotFrameTest (tsp);
    //tsp.plotData();
    //pft.show();
  }


  // Variables declaration - do not modify//GEN-BEGIN:variables
  // End of variables declaration//GEN-END:variables

}