#! /usr/bin/perl -w
###
#
#  Purpose
#  
#   To search for datasets in the ODI database and create system datasets.
#   
#  Arguments/Operator input: none
#  
#   
#  Returns (on standard output)
#  
#   An array of dataset identifiers 
#  
#  External routines
#  
#   Sedat.pm       Several utility routines in module Sedat.
#   
#  Description
#  
#  Author	Daniel Heynderickx
#
# $Log: odi_addds.pl,v $
# Revision 2.0  2009/10/21 10:29:00  dhc
#
###

use CGI qw(:cgi);
use Sedat;

$datasetsDir = objectDir(objectRealName('SYSTEM','U','SYSTEM'),'D');
$descfile = joinName($datasetsDir, 'descfile');

# Open a connection to the ODI database
$dbh = ODI_connect() or abortCGI('Error connecting to ODI database');

my $sth = $dbh->prepare("SELECT ds.sedat_name, dm.value FROM dataset AS ds LEFT JOIN
                         dataset_metadata AS dm ON (ds.id=dm.dataset_id)
                         WHERE sedat_name IS NOT NULL AND dm.attribute='Logical_source_description'");
$sth->execute() or abortCGI($dbh->errstr);
while (my $ref = $sth->fetchrow_arrayref()) {
  $dataset = $ref->[0];
  $desc = ($ref->[1] eq '') ? '' : $ref->[1];
  $cmnd = './sedat_addds.pl';
  if ($desc ne '') {
    open(my $out, ">", $descfile);
    print $out $desc;
    close $out;
    $cmnd .= " -i $descfile ";
  }
  $cmnd .= ' ' . $dataset;
  $rc = system($cmnd);
  print $rc . "\n";
  print $dataset . "\n";
  unlink $descfile;
}
$sth->finish();

# Close the connection to the ODI database
$dbh->disconnect();
