PRO sedat_open_read_odi, datasetname, numents, varmeta, status, oDB, query, nrv_vars, cmn=cmn

  status = 0

  trange = -1
  lpos = STRPOS(datasetname, '[')
  IF (lpos GT 0) THEN BEGIN
    rpos = STRPOS(datasetname, ']')
    trange = STRMID(datasetname, lpos+1, rpos-lpos-1)
    trange = STRSPLIT(trange, ',', /EXTRACT)
    datasetname = STRMID(datasetname, 0, lpos)
  ENDIF

  IF (OBJ_VALID(oDB) NE 1) THEN DBConnect, oDB

  query = "SELECT id, name, numrecs, LEFT(majority, 20) AS majority FROM dataset " + $
          "WHERE sedat_name='" + datasetname + "'"
  oRS = OBJ_NEW('IDLDBRecordSet', oDB, SQL=query)
  IF (oRS->CurrentRecord() LT 0) THEN $
    error_exit, 'Failed to open record set in sedat_open_read_odi'
  dataset = oRS->GetRecord()
  OBJ_DESTROY, oRS
  numents = dataset.numrecs

  varnames = '*'
  vars = odi_vardefs(varnames, dataset.id, oDB)

  numcols = N_ELEMENTS(vars)

  varmeta = 0

  FOR i=0,numcols-1 DO BEGIN
    colname = vars[i].name
    datatype = vars[i].sedat_type

    ndims = LONG(vars[i].dims)
    IF (ndims EQ 0) THEN BEGIN
      ndims = 1L
      dimensions = [1L]
    ENDIF ELSE IF (ndims EQ 1) THEN BEGIN
      dimensions = [LONG(vars[i].sizes)]
    ENDIF ELSE BEGIN
      dimensions = LONG(STRSPLIT(vars[i].sizes, ",", /EXTRACT))
    ENDELSE
    num_elements = 1
    FOR j=0,ndims-1 DO num_elements = num_elements * dimensions[j]

    units = ""
    query = "SELECT LEFT(value, 1000) AS value FROM variable_attribute " + $
            "WHERE variable_metadata_id=" + STRING(vars[i].id) + $
            " AND UPPER(name)='UNITS'"
    oRS = OBJ_NEW('IDLDBRecordSet', oDB, SQL=query)
    IF (oRS->CurrentRecord() GE 0) THEN BEGIN
      rec = oRS->GetRecord()
      units = rec.value
    ENDIF
    OBJ_DESTROY, oRS

    null = "*"
    query = "SELECT LEFT(value, 1000) AS value FROM variable_attribute " + $
            "WHERE variable_metadata_id=" + STRING(vars[i].id) + $
            " AND UPPER(name)='FILLVAL'"
    oRS = OBJ_NEW('IDLDBRecordSet', oDB, SQL=query)
    IF (oRS->CurrentRecord() GE 0) THEN BEGIN
      rec = oRS->GetRecord()
      null = cast_odi_sedat(rec.value, datatype)
    ENDIF
    OBJ_DESTROY, oRS

    si_rel = ""
    query = "SELECT LEFT(value, 1000) AS value FROM variable_attribute " + $
            "WHERE variable_metadata_id=" + STRING(vars[i].id) + $
            " AND UPPER(name)='SI_CONVERSION'"
    oRS = OBJ_NEW('IDLDBRecordSet', oDB, SQL=query)
    IF (oRS->CurrentRecord() GE 0) THEN BEGIN
      rec = oRS->GetRecord()
      si_rel = rec.value
    ENDIF
    OBJ_DESTROY, oRS

; If a colname!LABLAXIS parameter exists then the value of this is retrieved
; to provide the axes_desc (axes description) details
    axis_label = ""
    query = "SELECT LEFT(value, 1000) AS value FROM variable_attribute " + $
            "WHERE variable_metadata_id=" + STRING(vars[i].id) + $
            " AND UPPER(name)='LABLAXIS'"
    oRS = OBJ_NEW('IDLDBRecordSet', oDB, SQL=query)
    IF (oRS->CurrentRecord() GE 0) THEN BEGIN
      single_label = 1
      rec = oRS->GetRecord()
      axis_label = rec.value
    ENDIF ELSE BEGIN
      single_label = 0
      axis_label = colname
    ENDELSE
    OBJ_DESTROY, oRS
    axes_desc = axis_label

; The colname!VAR_TYPE parameter defines the type of the variable/column,
; whether data, support data or metadata
    var_type = ""
    query = "SELECT LEFT(value, 1000) AS value FROM variable_attribute " + $
            "WHERE variable_metadata_id=" + STRING(vars[i].id) + $
            " AND UPPER(name)='VAR_TYPE'"
    oRS = OBJ_NEW('IDLDBRecordSet', oDB, SQL=query)
    IF (oRS->CurrentRecord() GE 0) THEN BEGIN
      rec = oRS->GetRecord()
      var_type = rec.value
    ENDIF
    OBJ_DESTROY, oRS

; For array-valued 'data' columns
    IF ((var_type EQ 'data') AND (num_elements GT 1)) THEN BEGIN
      FOR j=ndims,1,-1 DO BEGIN
        jstr = STRTRIM(STRING(j), 2)
        axis_name = 'axis' + jstr

; Look for a colname!DEPEND_j variable
        axis_values = ''
        query = "SELECT LEFT(value, 1000) AS value FROM variable_attribute " + $
                "WHERE variable_metadata_id=" + STRING(vars[i].id) + $
                " AND UPPER(name)='DEPEND_" + jstr + "'"
        oRS = OBJ_NEW('IDLDBRecordSet', oDB, SQL=query)
        IF (oRS->CurrentRecord() GE 0) THEN BEGIN
          rec = oRS->GetRecord()
          axis_values = rec.value
        ENDIF
        OBJ_DESTROY, oRS

; If found then set up axes_desc as a structure rather than a string
        IF (axis_values NE "") THEN BEGIN
; If a !LABLAXIS parameter was found then we have a simple label with 
; a pointer to another column given by the !DEPEND_j parameter for values 
; of dimension positions
          IF (single_label) THEN BEGIN
            axes_desc = join_struct(axes_desc, $
                                    create_struct(axis_name, $
                                                  {label:axis_label, $
                                                   values:axis_values}))
; Otherwise there should be a !LABL_PTR_j parameter which points to another
; column which contains labels for the dimension positions
          ENDIF ELSE BEGIN
            axis_labels = ''
            query = "SELECT LEFT(value, 1000) AS value FROM variable_attribute " + $
                    "WHERE variable_metadata_id=" + STRING(vars[i].id) + $
                    " AND UPPER(name)='LABL_PTR_" + jstr + "'"
            oRS = OBJ_NEW('IDLDBRecordSet', oDB, SQL=query)
            IF (oRS->CurrentRecord() GE 0) THEN BEGIN
              rec = oRS->GetRecord()
              axis_labels = rec.value
            ENDIF
            OBJ_DESTROY, oRS
            axes_desc = join_struct(axes_desc, $
                                    create_struct(axis_name, $
                                                  {labels:axis_labels, $
                                                   values:axis_values}))
          ENDELSE
        ENDIF
      ENDFOR
    ENDIF

; Create the metadata structure for this column
    sedat_make_meta, colname, datatype, ndims, dimensions, null, meta, $
                     var_type=var_type, units=units, si_rel=si_rel, $
                     axes_desc=axes_desc, $
                     rec_vary=(vars[i].rvar EQ 'T'), $
                     status=status, cmn=cmn

; Add the metadata for this column to the structure of all column metadata    
    if status ne 0 then begin
      print, 'Failed to create metadata for variable '+colname+' in file '+file
    endif else begin
      varmeta = join_struct(varmeta,create_struct(colname,meta))
      IF (vars[i].rvar EQ 'F') THEN BEGIN
        query = "SELECT LEFT(value, 500) AS value FROM variable_nrv WHERE " + $
                "variable_metadata_id=" + STRING(vars[i].id) + " ORDER BY ind"
        oRS = OBJ_NEW('IDLDBRecordSet', oDB, SQL=query)
        IF (oRS->CurrentRecord() LT 0) THEN $
          error_exit, 'Failed to read NRV values in sedat_open_read_odi'
        rec = oRS->GetRecord()
        nrv = [rec.value]
        WHILE (oRS->MoveCursor(/NEXT)) DO BEGIN
          rec = oRS->GetRecord()
          nrv = [nrv, rec.value]
        ENDWHILE
        OBJ_DESTROY, oRS
        sedat_make_variable, dimensions, datatype, value
        if (datatype eq 'C') then value = ''+value
        dvar = create_struct(colname, {values: cast_odi_sedat(STRTRIM(nrv, 2), varmeta.(i).datatype), index: i})
        IF (SIZE(nrv_vars, /D) EQ 0) THEN $
          nrv_vars = dvar $
        ELSE $
          nrv_vars = join_struct(nrv_vars, dvar)
      ENDIF
    endelse
  ENDFOR

;
; Create the SQL query for this dataset
;
  ind = WHERE(vars.rvar EQ 'T', count)
  IF (count LE 0) THEN $
    error_exit, 'No RV variables were found in the dataset in sedat_open_read_odi'
  vars = vars[ind]
; Add variable declaration and SQL strings to structure vars
  FOR i=0,count-1 DO BEGIN
    odi_descvar, vars[i], dataset.majority, vtype, sql
    vars[i].vtype = vtype
    vars[i].sql = sql
  ENDFOR

; Create the SQL query to retrieve the data
  query = odi_rvsql(vars) + " FROM " + dataset.name

  IF (N_ELEMENTS(trange) GT 1) THEN BEGIN
    sqlrange = " WHERE cdf_epoch>=" + STRING(sql_date2cdf_epoch(STRMID(trange[0], 0, STRLEN(trange[0])-1)), FORMAT='(F20.1)') + $
               " AND cdf_epoch<=" + STRING(sql_date2cdf_epoch(STRMID(trange[1], 0, STRLEN(trange[0])-1)), FORMAT='(F20.1)')
    query += sqlrange
    oRS = OBJ_NEW('IDLDBRecordSet', oDB, $
                  SQL="SELECT CAST(count(cdf_epoch) AS BINARY) AS numrecs FROM " + dataset.name + sqlrange)
    rec = oRS->GetRecord()
    OBJ_DESTROY, oRS
    numents = rec.numrecs
  ENDIF

END
