; $Id: sedat_open_subset.pro,v 1.4 2001/12/06 12:48:44 stamper Exp $
; 
; sedat_open_subset
; 
; Open a dataset, restricted to a time subset.
; 
; Arguments
;   file_number   I    The number of the file to open
;   start         I    The start time 
;   stop          I    The stop time
;   meta	  O    The dataset metadata structure returned
; 
; Keywords    
;   status        O    Status code - 0 is success
;   cmn           IO   SEDAT execution environment information
;
; External routines 
;   libidl_stpdf.so STPDF library
;    
; Returns
;   A status code to indicate success/failure; 0 is success
;
; $Log: sedat_open_subset.pro,v $
; Revision 1.4  2001/12/06 12:48:44  stamper
; Commented thoroughly.
;
; Revision 1.3  2000/12/11 15:35:52  stamper
; Added comment header.
; Truncate file name at '[' character if found in name, before adding the
; '[start,stop]' string for the STPDF call.
;

pro sedat_open_subset, file_number, start, stop, meta, STATUS=status, CMN=cmn

; Remove any existing time select on the filename
    file = cmn.idsf[file_number-1]
    pos = strpos(file,'[')
    if (pos ge 0) then begin
        file = strmid(file,0,pos)
    endif

; Add a time range to the file name
    file = file + '[' +start+ ',' +stop+ ']'
    cmn.idsf[file_number-1] = file
;print,'cmn.idsf: ',cmn.idsf[file_number-1]
;print,'cmn.idsd: ',cmn.idsd[file_number-1]
; Print a diagnostic message then open the file 
    if (!QUIET eq 0 ) then print, 'file = "',file,'"'
    sedat_open_read, file_number, meta, STATUS=status, CMN=cmn

end
