<?php

/**
* Parser function for Meteosat/SEM.
*
* <pre>
* <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
* <>          ___  ___  __ _                                        <>
* <>         / _ \/ __|/ _` |               european space agency   <>
* <>        |  __/\__ \ (_| |                                       <>
* <>         \___/\___/\__,_|            agence spatiale europeenne <>
* <>                                                                <>
* <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
* </pre>
* The IPR of this software belongs to the European Space Agency. 
* The usage is at the discretion of the Agency and licenses for its 
* use should be addressed to the Contracts Dept. at ESTEC: 
* <pre>
* European Space Agency ESA/ESTEC 
* Contracts Department 
* Postbus 299 
* 2200 AG Noorwijk 
* The Netherlands 
* 
* WEB:         http://www.esa.int/ 
* Phone:         +31 71 565-6565 
* </pre>
* The software was developed under the ESA/ESTEC contract 21964/08/NL/AT by: 
* <pre>
* Peter Wintoft, Swedish Institute of Space Physics and 
* Daniel Heynderickx, DH Consultancy
* </pre>
* 
* Version number: 1.0 
*
* Release Date: 2 December, 2009 
*
* @version $Id: ISEE1_MEPI.php 253 2009-12-18 14:07:30Z peter $
*
* @package ODI
* @subpackage ParsersFunctions
*/

// Parse a data file and write formatted content to load.tmp

  function parse_Meteosat_SEM($rname, $fid)
  {
// Export the cdf file
    exec($_SERVER["ODI_HOME"] . "/parsers/cdfexport -batch text -settings lr.set -initial \"noheading,nooutput\" -text tmp.txt " . $rname);
    $tHandle = fopen("tmp.txt", "r");
    if ($tHandle !== FALSE)
    {
      $tfile = fopen("load.tmp", "w");
      while (!feof($tHandle))
      {
        $rec = fgets($tHandle);
        $rec = preg_split("/[\s]+/", trim($rec));
        if (count($rec) > 1)
        {
          $cdf_epoch = $rec[97];
          list($epoch, $ms) = cdfepoch_to_date($cdf_epoch);
          fprintf($tfile, "%20.1f, %s, %d", $cdf_epoch, $epoch, $ms);
// Spacecraft coordinates
          fprintf($tfile, str_repeat(",%s", 3), $rec[96], $rec[99], $rec[98]);
// Values
          for ($i = 0; $i < 96; $i++) fprintf($tfile, ",%s", $rec[$i]);

          fprintf($tfile, ", %d%s", $fid, LF);
        }
      }
      fclose($tfile);
      @unlink("tmp.txt");
      $result = TRUE;
    }
    else
      $result = FALSE;

    return $result;
  }

?>