<?php

function dirscan_generic($basedir, $filepattern)
{
    $dir_iterator = new RecursiveDirectoryIterator($basedir);
    $iterator = new RecursiveIteratorIterator($dir_iterator, RecursiveIteratorIterator::SELF_FIRST);

    $dfiles = array();
    foreach ($iterator as $file)
    {
        $fget = TRUE;
        if ($filepattern != "%")
        {
            $parse = explode("%", trim($filepattern, "%"));
// If the filepattern does not start with a wildcard, match from the start of the filename
            if (substr($filepattern, 0, 1) != "%")
                $fget = $fget && (substr($file->getFilename(), 0, strlen($parse[0])) == $parse[0]);
            for ($i = 0; $i < count($parse); $i++)
                $fget = $fget && (strpos($file->getFilename(), $parse[$i]) !== FALSE);
        }
        if (($fget === TRUE) && ($file->isDir() == FALSE))
        {
            $date = gmdate("Y/m/d h:i:s", $file->getMTime());
            $dfiles[] = array($file->getFilename(), $date, $file->getPathname());
        }
    }
    $tmpfiles = array();
    foreach ($dfiles as $key => $row)
        $tmpfiles[$key] = $row[2];
    array_multisort($tmpfiles, SORT_ASC, $dfiles);

    return $dfiles;
}

function parse_generic($rname, $fid, $sk_file) {

    $months = array("Jan", "Feb", "Mar", "Apr", "May", "Jun",
                    "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");

    $result = FALSE;
    
    $sname = substr_replace($sk_file, "set", -3, 3);
    
    if (strpos($rname, ".gz") !== FALSE)
    {
        @unlink("tmp.cdf");
        exec("gunzip -c " . $rname . " > tmp.cdf");
        $rname = "tmp.cdf";
    }
    exec($_SERVER["ODI_HOME"] . "/parsers/cdfexport -zmode 2 -batch text -settings " . $sname . " -initial \"noheading,nooutput\" -text tmp.txt " . $rname);
    if (file_exists("tmp.cdf")) @unlink("tmp.cdf");
    
    if (file_exists("tmp.txt"))
    {
        $tfile = fopen("load.tmp", "w");
        $ihandle = fopen("tmp.txt", "r");
        while (!feof($ihandle))
        {
            $sdum = fgets($ihandle);
            $sdum = preg_split("/\s+/", $sdum);
            if (count($sdum) > 2)
            {
                $date = array_shift($sdum);
// If epoch contains year 0000, skip to end of while loop
                if (substr($date, 7, 4) == "0000") continue;
                $month = substr($date, 3, 3);
                $month = array_search($month, $months);
                if ($month === FALSE) continue;
                $time = array_shift($sdum);
                $dpos = strpos($time, ".");
                if ($dpos !== FALSE)
                    $ms = intval(substr($time, $dpos+1));
                else
                    $ms = 0;
                $epoch = substr($date, 7, 4) . "-" .
                         sprintf("%02d", $month+1) . "-" .
                         substr($date, 0, 2) . " " .
                         substr($time, 0, 2) . ":" .
                         substr($time, 3, 2) . ":" .
                         substr($time, 6, 2);
                $cdf_epoch = date_to_cdfepoch($epoch, $ms);
// If cdf_epoch <= 0, skip to end of while loop
                if ($cdf_epoch <= 0.0) continue;
                fprintf($tfile, "%20.3f, %s, %d", $cdf_epoch, $epoch, $ms);
                for ($i = 0; $i < count($sdum)-1; $i++)
                    fprintf($tfile, ",%s", $sdum[$i]);
                fprintf($tfile, ", %d%s", $fid, LF);
            }
        }
        
        fclose($tfile);
        fclose($ihandle);
        @unlink("tmp.txt");
    
        $result = TRUE;
    }
    else
        $result = FALSE;
        
    return $result;
}

?>