#!/usr/bin/php
<?php
/**
* Add the revision information to the ODI table COMMENTs.
*
* This program is automatically called when the ODI database is created. If it is run manually then
* all tables in ODI will have their COMMENTs updated with the current revision information.
*
* Note: Each time a table holding physical data, i.e. the <samp>dataset_*</samp> tables, its COMMENT
* will contain the current revision information.
* 
* <pre>
* <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
* <>          ___  ___  __ _                                        <>
* <>         / _ \/ __|/ _` |               european space agency   <>
* <>        |  __/\__ \ (_| |                                       <>
* <>         \___/\___/\__,_|            agence spatiale europeenne <>
* <>                                                                <>
* <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
* </pre>
* The IPR of this software belongs to the European Space Agency. 
* The usage is at the discretion of the Agency and licenses for its 
* use should be addressed to the Contracts Dept. at ESTEC: 
* <pre>
* European Space Agency ESA/ESTEC 
* Contracts Department 
* Postbus 299 
* 2200 AG Noorwijk 
* The Netherlands 
* 
* WEB:         http://www.esa.int/ 
* Phone:         +31 71 565-6565 
* </pre>
* The software was developed under the ESA/ESTEC contract 21964/08/NL/AT by: 
* <pre>
* Peter Wintoft, Swedish Institute of Space Physics and 
* Daniel Heynderickx, DH Consultancy
* </pre>
* 
* Version number: 1.0 
*
* Release Date: 2 December, 2009 
*
* @version $Id: add_revision_info.php 215 2009-12-03 09:44:27Z peter $
*
* @package ODI
* @subpackage Admin
*/

require_once($_SERVER["ODI_HOME"]."/lib/odi.library.php");

// Connect to the database at user level 1.
$conn_array=get_conn_array(1);
$conn=connect_to_database_array($conn_array);

// Get the table names.
$q = "SHOW TABLES";
if (!($res=$conn->query($q))) printf("Query: %s\nError: %s\n",$q,$conn->error);

// Alter the tables' COMMENT.
while($table=$res->fetch_row()) {
    $q = "ALTER TABLE ".$table[0]." COMMENT=".quote(REVISION);
    echo $q."\n";
    if (!($conn->query($q))) printf("Query: %s\nError: %s\n",$q,$conn->error);
}

?>