#!/bin/bash
# A script to create the ODI database with three different user levels.
# Note: The user and password must correspond to a MySQL root user.
# Peter Wintoft and Hugh Evans, 2009-10-09.

# A MySQL system administrator user name.
USER=root
# The password.
PW=swan1234

# Check environment variables that must be set by user.
odi_list="ODI_USER_1 ODI_PW_1 ODI_USER_2 ODI_PW_2 ODI_USER_3 ODI_PW_3 ODI_DB"
for item in $odi_list
do
    if [ -z ${!item} ]
    then
        echo "$item is not set."
        echo "No changed made."
        exit
    fi
done

# Create the database.
mysql -v -u ${USER} --password=${PW} << CREATE_DB
  CREATE DATABASE IF NOT EXISTS ${ODI_DB};
CREATE_DB

# Create the users.
mysql -v -u ${USER} --password=${PW} << CREATE_ACCOUNTS
  GRANT ALL ON ${ODI_DB}.* TO '${ODI_USER_1}'@'%' IDENTIFIED BY '${ODI_PW_1}';
  GRANT ALL ON ${ODI_DB}.* TO '${ODI_USER_1}'@'localhost' IDENTIFIED BY '${ODI_PW_1}';
  GRANT SELECT,INSERT,DELETE,UPDATE,INDEX ON ${ODI_DB}.* TO '${ODI_USER_2}'@'%' IDENTIFIED BY '${ODI_PW_2}';
  GRANT SELECT,INSERT,DELETE,UPDATE,INDEX ON ${ODI_DB}.* TO '${ODI_USER_2}'@'localhost' IDENTIFIED BY '${ODI_PW_2}';
  GRANT SELECT ON ${ODI_DB}.* TO '${ODI_USER_3}'@'%' IDENTIFIED BY '${ODI_PW_3}';
  GRANT SELECT ON ${ODI_DB}.* TO '${ODI_USER_3}'@'localhost' IDENTIFIED BY '${ODI_PW_3}';
CREATE_ACCOUNTS