#!/bin/bash
#!/bin/bash --verbose

# Peter Wintoft, Swedish Institute of Space Physics.
# Daniel Heynderickx, DH Consultancy.

# A script to create the ODI database and populate it with the ISTP metadata.
# The script uses the $ODI_* varibles to connect to the database

# Check environment variables that must be set by user.
odi_list="ODI_HOME ODI_USER_1 ODI_PW_1 ODI_DB"
for item in $odi_list
do
    if [ -z ${!item} ]
    then
        echo "$item is not set."
        exit
    fi
done

# Check if environment variables are set else use default values.
odi_param=(-h --port --socket)
odi_var=(ODI_HOST ODI_PORT ODI_SOCKET)
mysql_cmd="mysql --table --local-infile -u $ODI_USER_1 -p$ODI_PW_1"
for (( i=0; i<3; i++ ))
do
     if [ -n "${!odi_var[$i]}" ]
     then
         mysql_cmd=${mysql_cmd}" "${odi_param[$i]}" "${!odi_var[$i]}
     fi
done

mysql_cmd=${mysql_cmd}" "${ODI_DB}" < metadata_tables_create.sql";

echo "Will execute:"
echo $mysql_cmd

eval $mysql_cmd

echo "Done!"

echo "Adding revision info to the tables."
php add_revision_info.php