#!/usr/bin/php
<?php
/**
* Drop all tables in ODI.
* 
* <pre>
* <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
* <>          ___  ___  __ _                                        <>
* <>         / _ \/ __|/ _` |               european space agency   <>
* <>        |  __/\__ \ (_| |                                       <>
* <>         \___/\___/\__,_|            agence spatiale europeenne <>
* <>                                                                <>
* <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
* </pre>
* The IPR of this software belongs to the European Space Agency. 
* The usage is at the discretion of the Agency and licenses for its 
* use should be addressed to the Contracts Dept. at ESTEC: 
* <pre>
* European Space Agency ESA/ESTEC 
* Contracts Department 
* Postbus 299 
* 2200 AG Noorwijk 
* The Netherlands 
* 
* WEB:         http://www.esa.int/ 
* Phone:         +31 71 565-6565 
* </pre>
* The software was developed under the ESA/ESTEC contract 21964/08/NL/AT by: 
* <pre>
* Peter Wintoft, Swedish Institute of Space Physics and 
* Daniel Heynderickx, DH Consultancy
* </pre>
* 
* Version number: $ODI$
* Version number: $OdiVersion$
*
* Release Date: 2 December, 2009 
*
* @version $Id: drop_all_tables.php 226 2009-12-08 09:10:49Z peter $
*
* @package ODI
* @subpackage Admin
*/

require_once($_SERVER["ODI_HOME"].'/lib/odi.library.php');

// Connect to database at user level 1.
$ca=get_conn_array(1);
$conn=connect_to_database_array($ca);

// Repeat table dropping until no more tables.
$more_tables=TRUE;
$i=1;
while($more_tables) {
    $more_tables=FALSE;
    // Get all tables.
    $q='SHOW TABLES';
    if (!($result=$conn->query($q))) printf("Query: %s\nError: %s\n",$q,$conn->error);
    while($row=$result->fetch_row()) {
        $more_tables=TRUE;
        $q='DROP TABLE '.no_quote($row[0]);
        fwrite(STDOUT,"Pass ".$i.". Trying ".$q." ... ");
        if (($conn->query($q))) 
            fwrite(STDOUT,"OK!\n");
        else
            fwrite(STDOUT,"Failed! Will try on next pass.\n");
    }
    $i++;
}
?>