/**
 * This program demonstrates how to connect to the ODI database and retrieve some data.
 * 
 * To compile the program do:
 *
 *  javac -classpath $ODI_HOME/lib/OdiLibrary.jar:$ODI_HOME/SAAPS/lib/mysql-connector-java-5.1.10-bin.jar OdiReadDataTest.java
 *
 * To run the program do:
 *
 *  java -classpath $ODI_HOME/lib/OdiLibrary.jar:$ODI_HOME/SAAPS/lib/mysql-connector-java-5.1.10-bin.jar:. OdiReadDataTest
 *
 * @author Peter Wintoft
 * @version $Id: OdiReadDataTest.java 288 2010-03-30 12:06:46Z peter $
 */

import odi.*;

public class OdiReadDataTest {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        String dataset = "goes_i12_5";
        String epochStart = "2010-01-01 00:00:00.000";
        String epochEnd = "2010-01-01 00:59:59.999";
        String[] variables = {"epoch","position","fpio"};
        try {
            Database db = new Database();
            Dataset ds = db.readDataset(dataset, epochStart, epochEnd, variables);
            System.out.println(ds);
        }
        catch(DatabaseException e) {
            System.err.println(e);
        }

    }

}
