#!/usr/bin/php
<?php
/**
* Check that ODI environment variables are set.
* 
* Usage:
*
* <samp>
*  check_odi.php
* </samp>
*
* <pre>
* <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
* <>          ___  ___  __ _                                        <>
* <>         / _ \/ __|/ _` |               european space agency   <>
* <>        |  __/\__ \ (_| |                                       <>
* <>         \___/\___/\__,_|            agence spatiale europeenne <>
* <>                                                                <>
* <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
* </pre>
* The IPR of this software belongs to the European Space Agency. 
* The usage is at the discretion of the Agency and licenses for its 
* use should be addressed to the Contracts Dept. at ESTEC: 
* <pre>
* European Space Agency ESA/ESTEC 
* Contracts Department 
* Postbus 299 
* 2200 AG Noorwijk 
* The Netherlands 
* 
* WEB:         http://www.esa.int/ 
* Phone:         +31 71 565-6565 
* </pre>
* The software was developed under the ESA/ESTEC contract 21964/08/NL/AT by: 
* <pre>
* Peter Wintoft, Swedish Institute of Space Physics and 
* Daniel Heynderickx, DH Consultancy
* </pre>
* 
* Version number: 1.0 
*
* Release Date: 19 March, 2010 
*
* @version $Id: check_odi.php 298 2010-05-05 10:37:58Z peter $
*
* @package ODI
* @subpackage Tools
*/

require_once($_SERVER["ODI_HOME"].'/lib/odi.library.php');

// Check the environment variables.
check_env("ODI_HOME","Must be set!");
check_env("ODI_USER_1","Only necessary for admin usage.");
check_env("ODI_PW_1","Only necessary for admin usage.");
check_env("ODI_USER_2","Only necessary for admin usage.");
check_env("ODI_PW_2","Only necessary for admin usage.");
check_env("ODI_USER_3","Must be set!");
check_env("ODI_PW_3","Must be set!");
check_env("ODI_DB","Must be set!");
check_env("ODI_RAWDATA","Only necessary for admin usage.");
list($m,$v)=preg_split("/\s+/",exec("mysql --help | grep ^host"));
check_env("ODI_HOST"," Using default host: ".trim($v));
list($m,$v)=preg_split("/\s+/",exec("mysql --help | grep ^socket"));
check_env("ODI_SOCKET"," Using default socket: ".trim($v));
list($m,$v)=preg_split("/\s+/",exec("mysql --help | grep ^port"));
check_env("ODI_PORT"," Using default port: ".trim($v));

// Try to connect to the ODI database.
$ca = get_conn_array(3);
$c = connect_to_database_array($ca);
$s = $c->host_info;
echo $s.LF;
$s = $c->client_info;
echo "MySQL client version: ".$s.LF;
$s = $c->server_info;
echo "MySQL server version: ".$s.LF;

function check_env($n,$m) {
fwrite(STDOUT,$n);
if($v=getenv($n)) {
    fwrite(STDOUT,"=".$v."\n");
}
else {
    fwrite(STDOUT," is not set!. ".$m."\n");
}
}
?>
