#!/usr/bin/php
<?php
/**
* Show the variables for a selected dataset.
*
* Usage:
*
* <samp>
*  show_variables.php dataset_name
* </samp>
*
* where <samp>dataset_name</samp> is the SEDAT dataset name.
*
* <pre>
* <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
* <>          ___  ___  __ _                                        <>
* <>         / _ \/ __|/ _` |               european space agency   <>
* <>        |  __/\__ \ (_| |                                       <>
* <>         \___/\___/\__,_|            agence spatiale europeenne <>
* <>                                                                <>
* <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
* </pre>
* The IPR of this software belongs to the European Space Agency. 
* The usage is at the discretion of the Agency and licenses for its 
* use should be addressed to the Contracts Dept. at ESTEC: 
* <pre>
* European Space Agency ESA/ESTEC 
* Contracts Department 
* Postbus 299 
* 2200 AG Noorwijk 
* The Netherlands 
* 
* WEB:         http://www.esa.int/ 
* Phone:         +31 71 565-6565 
* </pre>
* The software was developed under the ESA/ESTEC contract 21964/08/NL/AT by: 
* <pre>
* Peter Wintoft, Swedish Institute of Space Physics and 
* Daniel Heynderickx, DH Consultancy
* </pre>
* 
* Version number: 1.0
* 
* Release Date: 2 December, 2009 
*
* @version $Id: show_variables.php 289 2010-03-30 12:12:15Z peter $
*
* @package ODI
* @subpackage Tools
*/

require_once($_SERVER["ODI_HOME"].'/lib/odi.library.php');

// Get the input arguments.
$arg_array=array("dataset");
$args=get_cl_arguments($argv,$arg_array);

// Connect to the database at user level 3.
$conn_array=get_conn_array(3);
$conn=connect_to_database_array($conn_array);

// Get the non-record variant variables.
$q0 = 'SELECT data_type.cdf_type AS data_type,';
$q0 .= ' variable_metadata.name AS name';
$q0 .= ' FROM dataset JOIN variable_metadata JOIN data_type';
$q0 .= ' ON dataset.sedat_name='.quote($args["dataset"]);
$q0 .= ' AND variable_metadata.dataset_id = dataset.id';
$q0 .= ' AND variable_metadata.data_type_id = data_type.id';
$q1 = ' ORDER BY name';

$q = $q0 . ' AND record_variance="F"' . $q1;
if (!($res=$conn->query($q))) printf("Query: %s\nError: %s\n",$q,$conn->error);
fwrite(STDOUT,"----------------\nNon-record variant variables\n----------------\n");
while($row=$res->fetch_assoc()) {
    fwrite(STDOUT,$row["name"]."\n");
}

$q = $q0 . ' AND record_variance="T"' . $q1;
if (!($res=$conn->query($q))) printf("Query: %s\nError: %s\n",$q,$conn->error);
fwrite(STDOUT,"----------------\nRecord variant variables\n----------------\n");
while($row=$res->fetch_assoc()) {
    fwrite(STDOUT,$row["name"]."\n");
}

?>